'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.ALIGN_VALUES = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var ALIGN_VALUES = exports.ALIGN_VALUES = ['left', 'right', 'center'];

var AccentHeader = function AccentHeader(_ref) {
	var align = _ref.align,
	    headingTag = _ref.headingTag,
	    children = _ref.children,
	    className = _ref.className,
	    other = _objectWithoutProperties(_ref, ['align', 'headingTag', 'children', 'className']);

	var HeadingTagEl = headingTag;
	return _react2.default.createElement(
		'header',
		{ className: 'accentHeaderWrapper' },
		_react2.default.createElement(
			HeadingTagEl,
			{
				className: (0, _classnames2.default)('accentHeader\n\t\t\t\t\taccentHeader--' + align + '\n\t\t\t\t\talign--' + align + '\n\t\t\t\t\ttext--normal', className)
			},
			children
		)
	);
};

AccentHeader.defaultProps = {
	align: 'left',
	headingTag: 'h2'
};

AccentHeader.propTypes = {
	/** Controls text alignment */
	align: _propTypes2.default.oneOf(ALIGN_VALUES),

	/** Which level of HTML heading tag to use */
	headingTag: _propTypes2.default.oneOf(['h1', 'h2', 'h3', 'h4', 'h5', 'h6'])
};

exports.default = AccentHeader;
AccentHeader.__docgenInfo = {
	'description': '',
	'methods': [],
	'props': {
		'align': {
			'defaultValue': {
				'value': '\'left\'',
				'computed': false
			},
			'type': {
				'name': 'enum',
				'value': [{
					'value': '\'left\'',
					'computed': false
				}, {
					'value': '\'right\'',
					'computed': false
				}, {
					'value': '\'center\'',
					'computed': false
				}]
			},
			'required': false,
			'description': 'Controls text alignment'
		},
		'headingTag': {
			'defaultValue': {
				'value': '\'h2\'',
				'computed': false
			},
			'type': {
				'name': 'enum',
				'value': [{
					'value': '\'h1\'',
					'computed': false
				}, {
					'value': '\'h2\'',
					'computed': false
				}, {
					'value': '\'h3\'',
					'computed': false
				}, {
					'value': '\'h4\'',
					'computed': false
				}, {
					'value': '\'h5\'',
					'computed': false
				}, {
					'value': '\'h6\'',
					'computed': false
				}]
			},
			'required': false,
			'description': 'Which level of HTML heading tag to use'
		}
	}
};
//# sourceMappingURL=AccentHeader.js.map