'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.Footer = exports.LanguageSelectInput = exports.SocialIconsList = exports.FooterCategory = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _locales = require('mwp-config/locales');

var _locales2 = _interopRequireDefault(_locales);

var _localizedLanguageMap = require('mwp-i18n/lib/localizedLanguageMap');

var _localizedLanguageMap2 = _interopRequireDefault(_localizedLanguageMap);

var _AppBadges = require('./media/AppBadges');

var _AppBadges2 = _interopRequireDefault(_AppBadges);

var _Bounds = require('./layout/Bounds');

var _Bounds2 = _interopRequireDefault(_Bounds);

var _Chunk = require('./layout/Chunk');

var _Chunk2 = _interopRequireDefault(_Chunk);

var _Flex = require('./layout/Flex');

var _Flex2 = _interopRequireDefault(_Flex);

var _FlexItem = require('./layout/FlexItem');

var _FlexItem2 = _interopRequireDefault(_FlexItem);

var _InlineBlockList = require('./layout/InlineBlockList');

var _InlineBlockList2 = _interopRequireDefault(_InlineBlockList);

var _GridList = require('./layout/GridList');

var _GridList2 = _interopRequireDefault(_GridList);

var _Icon = require('./media/Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _Section = require('./layout/Section');

var _Section2 = _interopRequireDefault(_Section);

var _SelectInput = require('./forms/SelectInput');

var _SelectInput2 = _interopRequireDefault(_SelectInput);

var _Stripe = require('./layout/Stripe');

var _Stripe2 = _interopRequireDefault(_Stripe);

var _withMatchMedia = require('./utils/components/withMatchMedia');

var _withMatchMedia2 = _interopRequireDefault(_withMatchMedia);

var _getSocialLinks = require('./utils/getSocialLinks');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var FooterCategory = exports.FooterCategory = function FooterCategory(props) {
	return _react2.default.createElement(
		_Chunk2.default,
		null,
		_react2.default.createElement(
			'h4',
			{ className: 'text--bold margin--bottom' },
			props.header
		),
		_react2.default.createElement(_GridList2.default, {
			columns: {
				default: 2,
				medium: 1
			},
			className: 'text--secondary text--small',
			itemClassNames: 'footer-item',
			items: props.items
		})
	);
};

var SocialIconsList = exports.SocialIconsList = function SocialIconsList(_ref) {
	var localeCode = _ref.localeCode;

	var socialLinks = (0, _getSocialLinks.getSocialLinks)(localeCode);
	var socialIcons = [_react2.default.createElement(
		'a',
		{ href: socialLinks.facebook },
		_react2.default.createElement(_Icon2.default, { shape: 'external-facebookboxed', size: 's' })
	), _react2.default.createElement(
		'a',
		{ href: socialLinks.twitter },
		_react2.default.createElement(_Icon2.default, { className: 'margin--left', shape: 'external-twitter', size: 's' })
	), _react2.default.createElement(
		'a',
		{ href: socialLinks.youtube },
		_react2.default.createElement(_Icon2.default, { className: 'margin--left', shape: 'external-youtube', size: 's' })
	), _react2.default.createElement(
		'a',
		{ href: socialLinks.instagram },
		_react2.default.createElement(_Icon2.default, { className: 'margin--left', shape: 'external-instagram', size: 's' })
	)];

	return _react2.default.createElement(_InlineBlockList2.default, { items: socialIcons });
};

var LanguageSelectInput = exports.LanguageSelectInput = function LanguageSelectInput(props) {
	return _react2.default.createElement(_SelectInput2.default, {
		onChange: props.onChange,
		options: _locales2.default.map(function (language) {
			return {
				label: _localizedLanguageMap2.default[language],
				value: language
			};
		}),
		name: 'languagePicker',
		value: props.currentLocaleCode,
		label: 'Language',
		labelClassName: 'visibility--a11yHide'
	});
};

var Footer = function Footer(_ref2) {
	var className = _ref2.className,
	    createMeetup = _ref2.createMeetup,
	    isLight = _ref2.isLight,
	    isLoggedIn = _ref2.isLoggedIn,
	    legalCopy = _ref2.legalCopy,
	    localeCode = _ref2.localeCode,
	    linkSets = _ref2.linkSets,
	    media = _ref2.media,
	    onLanguageSelect = _ref2.onLanguageSelect,
	    socialHeader = _ref2.socialHeader,
	    subFooterLinks = _ref2.subFooterLinks,
	    other = _objectWithoutProperties(_ref2, ['className', 'createMeetup', 'isLight', 'isLoggedIn', 'legalCopy', 'localeCode', 'linkSets', 'media', 'onLanguageSelect', 'socialHeader', 'subFooterLinks']);

	var classNames = (0, _classnames2.default)('column-item', 'column-item--shrink', className);
	var languageShort = localeCode.split('-')[0];

	return _react2.default.createElement(
		'footer',
		_extends({ id: 'mupFooter', className: classNames }, other),
		_react2.default.createElement(
			_Stripe2.default,
			{
				inverted: !isLight,
				className: (0, _classnames2.default)('footerStripe-main', {
					'footerStripe-main--isLight': isLight
				})
			},
			_react2.default.createElement(
				_Bounds2.default,
				{ narrow: true, className: 'bounds--footer' },
				_react2.default.createElement(
					_Section2.default,
					{ hasSeparator: true },
					_react2.default.createElement(
						_Chunk2.default,
						null,
						_react2.default.createElement(
							'a',
							{
								href: createMeetup.link,
								className: 'link link--white',
								onClick: createMeetup.onLinkClick
							},
							createMeetup.text
						)
					)
				),
				_react2.default.createElement(
					_Section2.default,
					{ hasSeparator: true, className: 'border--none' },
					_react2.default.createElement(
						_Flex2.default,
						{ direction: 'column', switchDirection: 'large' },
						_react2.default.createElement(
							_FlexItem2.default,
							{ className: 'margin--bottom' },
							_react2.default.createElement(
								_Flex2.default,
								{ direction: 'column', switchDirection: 'medium' },
								linkSets.map(function (linkSet, i) {
									return _react2.default.createElement(
										_FlexItem2.default,
										{ key: 'linkSet-' + i },
										_react2.default.createElement(FooterCategory, linkSet)
									);
								})
							)
						),
						_react2.default.createElement(
							_FlexItem2.default,
							{ shrink: true },
							_react2.default.createElement(
								_Flex2.default,
								{ noGutters: true, direction: 'column' },
								_react2.default.createElement(
									_FlexItem2.default,
									{ shrink: true },
									_react2.default.createElement(
										_Chunk2.default,
										{ className: 'align--center atMedium_align--left' },
										_react2.default.createElement(
											'h4',
											{ className: 'text--bold margin--bottom' },
											socialHeader
										),
										_react2.default.createElement(SocialIconsList, { localeCode: localeCode })
									)
								),
								_react2.default.createElement(
									_FlexItem2.default,
									null,
									_react2.default.createElement(
										_Flex2.default,
										{
											direction: !media.isAtMediumUp || media.isAtLargeUp ? 'column' : 'row',
											rowReverse: media.isAtMediumUp && !media.isAtLargeUp && !isLoggedIn,
											justify: media.isAtMediumUp && !media.isAtLargeUp && !isLoggedIn ? 'spaceBetween' : null
										},
										!isLoggedIn && _react2.default.createElement(
											_FlexItem2.default,
											{ shrink: true, className: 'margin--top' },
											_react2.default.createElement(
												_Chunk2.default,
												null,
												_react2.default.createElement(LanguageSelectInput, {
													currentLocaleCode: localeCode,
													onChange: onLanguageSelect
												})
											)
										),
										_react2.default.createElement(
											_FlexItem2.default,
											{ shrink: true },
											_react2.default.createElement(
												_Chunk2.default,
												{ className: 'align--center atMedium_align--left margin--top' },
												_react2.default.createElement(_AppBadges2.default, { language: languageShort })
											)
										)
									)
								)
							)
						)
					)
				)
			)
		),
		_react2.default.createElement(
			_Stripe2.default,
			{
				inverted: !isLight,
				className: (0, _classnames2.default)('footerStripe-legal border--none', {
					'footerStripe-legal--isLight': isLight
				})
			},
			_react2.default.createElement(
				_Bounds2.default,
				null,
				_react2.default.createElement(
					'div',
					{ className: 'padding--all' },
					_react2.default.createElement(_InlineBlockList2.default, {
						className: 'text--small align--center atMedium_align--left footerList-legal',
						separator: '\xB7',
						items: [_react2.default.createElement(
							'span',
							null,
							'\xA9 ' + new Date().getFullYear() + ' Meetup LLC'
						)].filter(function (item) {
							return item;
						})
					}),
					_react2.default.createElement(_InlineBlockList2.default, {
						className: 'text--small align--center atMedium_align--left margin--top',
						separator: '\xB7',
						items: [].concat(_toConsumableArray(subFooterLinks))
					})
				)
			)
		)
	);
};

exports.Footer = Footer;
Footer.defaultProps = {
	createMeetup: {
		text: 'Create a Meetup',
		link: '/create/'
	},
	linkSets: [{
		header: 'Your Account',
		items: [_react2.default.createElement(
			'a',
			{ href: '/register' },
			'Settings'
		), _react2.default.createElement(
			'a',
			{ href: '/logout' },
			'Log out'
		), _react2.default.createElement(
			'a',
			{ href: '/help' },
			'Help'
		)]
	}, {
		header: 'Discover',
		items: [_react2.default.createElement(
			'a',
			{ href: '/groups' },
			'Groups'
		), _react2.default.createElement(
			'a',
			{ href: '/calendar' },
			'Calendar'
		), _react2.default.createElement(
			'a',
			{ href: '/topics' },
			'Topics'
		), _react2.default.createElement(
			'a',
			{ href: '/cities' },
			'Cities'
		)]
	}, {
		header: 'Meetup',
		items: [_react2.default.createElement(
			'a',
			{ href: '/about' },
			'About'
		), _react2.default.createElement(
			'a',
			{ href: '/pro' },
			'Meetup Pro'
		), _react2.default.createElement(
			'a',
			{ href: '/jobs' },
			'Careers'
		), _react2.default.createElement(
			'a',
			{ href: '/apps' },
			'Apps'
		), _react2.default.createElement(
			'a',
			{ href: '/meetup_api' },
			'API'
		)]
	}],
	localeCode: 'en-US',
	subFooterLinks: [_react2.default.createElement(
		'a',
		{ href: '/terms' },
		'Terms of Service'
	), _react2.default.createElement(
		'a',
		{ href: '/privacy' },
		'Privacy Policy'
	), _react2.default.createElement(
		'a',
		{ href: '/cookie_policy' },
		'Cookie Policy'
	)],
	socialHeader: 'Follow Us'
};

Footer.propTypes = {
	/** Additional class name/s to add to the `<footer/>` element  */
	className: _propTypes2.default.string,

	/** Takes a URL and a text label to render the link to create a new Meetup group  */
	createMeetup: _propTypes2.default.shape({
		link: _propTypes2.default.string.isRequired,
		text: _propTypes2.default.string.isRequired,
		onLinkClick: _propTypes2.default.func
	}).isRequired,

	/** Renders a light footer background instead of dark. Used for 404's and error pages  */
	isLight: _propTypes2.default.bool,

	/** Used to decide which content to render based on whether user is logged into their Meetup account  */
	isLoggedIn: _propTypes2.default.bool,

	/** Fine print required by Meetup's legal team */
	legalCopy: _propTypes2.default.string,

	/** The current user's locale code, which is used to render the correct social media links and language dropdown */
	localeCode: _propTypes2.default.string.isRequired,

	/** Collections of links to render in the footer. For example: "Your Account" links, "Discovery" links, and Meetup-specific links */
	linkSets: _propTypes2.default.arrayOf(_propTypes2.default.shape({
		header: _propTypes2.default.string.isRequired,
		items: _propTypes2.default.arrayOf(_propTypes2.default.element).isRequired
	})).isRequired,

	/** Function to call when a user selects a language */
	onLanguageSelect: _propTypes2.default.func.isRequired,

	/** Label for our social media links. e.g.: "Follow us" */
	socialHeader: _propTypes2.default.string,

	/** Small-print links. e.g.: "Terms of Servuce" */
	subFooterLinks: _propTypes2.default.arrayOf(_propTypes2.default.element).isRequired
};

exports.default = (0, _withMatchMedia2.default)(Footer);
FooterCategory.__docgenInfo = {
	'description': '',
	'methods': []
};
SocialIconsList.__docgenInfo = {
	'description': '',
	'methods': []
};
LanguageSelectInput.__docgenInfo = {
	'description': '',
	'methods': []
};
Footer.__docgenInfo = {
	'description': '',
	'methods': [],
	'props': {
		'createMeetup': {
			'defaultValue': {
				'value': '{\n    text: \'Create a Meetup\',\n    link: \'/create/\',\n}',
				'computed': false
			},
			'type': {
				'name': 'shape',
				'value': {
					'link': {
						'name': 'string',
						'required': true
					},
					'text': {
						'name': 'string',
						'required': true
					},
					'onLinkClick': {
						'name': 'func',
						'required': false
					}
				}
			},
			'required': true,
			'description': 'Takes a URL and a text label to render the link to create a new Meetup group'
		},
		'linkSets': {
			'defaultValue': {
				'value': '[\n    {\n        header: \'Your Account\',\n        items: [\n            <a href="/register">Settings</a>,\n            <a href="/logout">Log out</a>,\n            <a href="/help">Help</a>,\n        ],\n    },\n    {\n        header: \'Discover\',\n        items: [\n            <a href="/groups">Groups</a>,\n            <a href="/calendar">Calendar</a>,\n            <a href="/topics">Topics</a>,\n            <a href="/cities">Cities</a>,\n        ],\n    },\n    {\n        header: \'Meetup\',\n        items: [\n            <a href="/about">About</a>,\n            <a href="/pro">Meetup Pro</a>,\n            <a href="/jobs">Careers</a>,\n            <a href="/apps">Apps</a>,\n            <a href="/meetup_api">API</a>,\n        ],\n    },\n]',
				'computed': false
			},
			'type': {
				'name': 'arrayOf',
				'value': {
					'name': 'shape',
					'value': {
						'header': {
							'name': 'string',
							'required': true
						},
						'items': {
							'name': 'arrayOf',
							'value': {
								'name': 'element'
							},
							'required': true
						}
					}
				}
			},
			'required': true,
			'description': 'Collections of links to render in the footer. For example: "Your Account" links, "Discovery" links, and Meetup-specific links'
		},
		'localeCode': {
			'defaultValue': {
				'value': '\'en-US\'',
				'computed': false
			},
			'type': {
				'name': 'string'
			},
			'required': true,
			'description': 'The current user\'s locale code, which is used to render the correct social media links and language dropdown'
		},
		'subFooterLinks': {
			'defaultValue': {
				'value': '[\n    <a href="/terms">Terms of Service</a>,\n    <a href="/privacy">Privacy Policy</a>,\n    <a href="/cookie_policy">Cookie Policy</a>,\n]',
				'computed': false
			},
			'type': {
				'name': 'arrayOf',
				'value': {
					'name': 'element'
				}
			},
			'required': true,
			'description': 'Small-print links. e.g.: "Terms of Servuce"'
		},
		'socialHeader': {
			'defaultValue': {
				'value': '\'Follow Us\'',
				'computed': false
			},
			'type': {
				'name': 'string'
			},
			'required': false,
			'description': 'Label for our social media links. e.g.: "Follow us"'
		},
		'className': {
			'type': {
				'name': 'string'
			},
			'required': false,
			'description': 'Additional class name/s to add to the `<footer/>` element'
		},
		'isLight': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Renders a light footer background instead of dark. Used for 404\'s and error pages'
		},
		'isLoggedIn': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Used to decide which content to render based on whether user is logged into their Meetup account'
		},
		'legalCopy': {
			'type': {
				'name': 'string'
			},
			'required': false,
			'description': 'Fine print required by Meetup\'s legal team'
		},
		'onLanguageSelect': {
			'type': {
				'name': 'func'
			},
			'required': true,
			'description': 'Function to call when a user selects a language'
		}
	}
};
//# sourceMappingURL=Footer.js.map