'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.VALID_BREAKPOINTS = exports.HIDE_GRADIENT_CLASSNAME = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _rafSchd = require('raf-schd');

var _rafSchd2 = _interopRequireDefault(_rafSchd);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var HIDE_GRADIENT_CLASSNAME = exports.HIDE_GRADIENT_CLASSNAME = 'hscrollGradient--hidden';

var VALID_BREAKPOINTS = exports.VALID_BREAKPOINTS = {
	medium: 'atMedium',
	large: 'atLarge'
};

/**
 * Horizontal Scroll
 * @module Hscroll
 */

var Hscroll = function (_React$PureComponent) {
	_inherits(Hscroll, _React$PureComponent);

	function Hscroll(props) {
		_classCallCheck(this, Hscroll);

		var _this = _possibleConstructorReturn(this, (Hscroll.__proto__ || Object.getPrototypeOf(Hscroll)).call(this, props));

		_this.onScroll = _this.onScroll.bind(_this);

		_this.state = {
			isScrolled: false
		};
		return _this;
	}

	_createClass(Hscroll, [{
		key: 'onScroll',
		value: function onScroll(e) {
			var scrollLeft = e.target.scrollLeft;

			(0, _rafSchd2.default)(this.setState(function () {
				return { isScrolled: Boolean(scrollLeft) };
			}));
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    hasGradient = _props.hasGradient,
			    unclipAt = _props.unclipAt,
			    className = _props.className,
			    children = _props.children,
			    other = _objectWithoutProperties(_props, ['hasGradient', 'unclipAt', 'className', 'children']);

			var wrapClassNames = (0, _classnames2.default)('hscrollContainer', _defineProperty({
				hscrollGradientWrap: hasGradient && !unclipAt
			}, HIDE_GRADIENT_CLASSNAME, !this.state.isScrolled), className);

			var hscrollClassNames = (0, _classnames2.default)('hscroll', _defineProperty({}, VALID_BREAKPOINTS[unclipAt] + '_hscroll--unclip', !!unclipAt));

			return _react2.default.createElement(
				'div',
				_extends({ onScroll: this.onScroll, className: wrapClassNames }, other),
				_react2.default.createElement(
					'div',
					{ className: hscrollClassNames },
					_react2.default.createElement(
						'div',
						{ className: 'hscroll-content' },
						children
					)
				)
			);
		}
	}]);

	return Hscroll;
}(_react2.default.PureComponent);

Hscroll.propTypes = {
	/** Whether the beginning and end of the scrolling element disappears into a gradient instead of being abruptly cut off */
	hasGradient: _propTypes2.default.bool,

	/** Breakpoint at which to render the items without a horizontal scroll */
	unclipAt: _propTypes2.default.oneOf(Object.keys(VALID_BREAKPOINTS))
};

exports.default = Hscroll;
Hscroll.__docgenInfo = {
	'description': 'Horizontal Scroll\n@module Hscroll',
	'methods': [{
		'name': 'onScroll',
		'docblock': null,
		'modifiers': [],
		'params': [{
			'name': 'e',
			'type': null
		}],
		'returns': null
	}],
	'displayName': 'Hscroll',
	'props': {
		'hasGradient': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Whether the beginning and end of the scrolling element disappears into a gradient instead of being abruptly cut off'
		},
		'unclipAt': {
			'type': {
				'name': 'enum',
				'value': [{
					'value': '"medium"',
					'computed': false
				}, {
					'value': '"large"',
					'computed': false
				}]
			},
			'required': false,
			'description': 'Breakpoint at which to render the items without a horizontal scroll'
		}
	}
};
//# sourceMappingURL=Hscroll.js.map