'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.SignupModal = exports.SIGNUP_MODAL_WRAPPER_CLASS = exports.SIGNUP_MODAL_CLASS = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Modal = require('./interactive/Modal');

var _Modal2 = _interopRequireDefault(_Modal);

var _logoMSwarm2color = require('../assets/svg/logo--mSwarm--2color.svg');

var _logoMSwarm2color2 = _interopRequireDefault(_logoMSwarm2color);

var _facebook = require('../assets/svg/facebook.svg');

var _facebook2 = _interopRequireDefault(_facebook);

var _google = require('../assets/svg/google.svg');

var _google2 = _interopRequireDefault(_google);

var _apple = require('../assets/svg/apple.svg');

var _apple2 = _interopRequireDefault(_apple);

var _email = require('../assets/svg/email.svg');

var _email2 = _interopRequireDefault(_email);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

/* meetup web components */


/* images */


/* consts */
var SIGNUP_MODAL_CLASS = exports.SIGNUP_MODAL_CLASS = 'meetup-signupModal';
var SIGNUP_MODAL_WRAPPER_CLASS = exports.SIGNUP_MODAL_WRAPPER_CLASS = SIGNUP_MODAL_CLASS + '-wrapper';

/**
 * @param {Object} props component properties
 * @returns {React.element} SignupModal
 */
var SignupModal = function SignupModal(_ref) {
	var onDismiss = _ref.onDismiss,
	    signupOptions = _ref.signupOptions,
	    googleOnClick = _ref.googleOnClick,
	    appleOnClick = _ref.appleOnClick,
	    facebookOnClick = _ref.facebookOnClick,
	    emailOnClick = _ref.emailOnClick,
	    other = _objectWithoutProperties(_ref, ['onDismiss', 'signupOptions', 'googleOnClick', 'appleOnClick', 'facebookOnClick', 'emailOnClick']);

	var apple = signupOptions.apple,
	    google = signupOptions.google,
	    facebook = signupOptions.facebook,
	    email = signupOptions.email,
	    login = signupOptions.login,
	    title = signupOptions.title;

	var btnClassName = 'tw-font-normal tw-box-border tw-border tw-border-gray2 tw-border-solid tw-p-4 tw-mb-4 tw-rounded-lg tw-flex tw-flex-row';

	return _react2.default.createElement(
		_Modal2.default,
		_extends({ className: SIGNUP_MODAL_CLASS, onDismiss: onDismiss, fixed: true }, other),
		_react2.default.createElement(
			'div',
			{ className: SIGNUP_MODAL_WRAPPER_CLASS },
			_react2.default.createElement(
				'div',
				{ className: 'tw-flex tw-flex-col tw-items-center tw-mb-8' },
				_react2.default.createElement('img', {
					alt: 'Meetup logo',
					src: _logoMSwarm2color2.default,
					className: 'tw-mb-2',
					height: '48',
					width: '48'
				}),
				_react2.default.createElement(
					'h1',
					{ className: 'text--big tw-mb-2' },
					title
				),
				_react2.default.createElement(
					'div',
					null,
					login.text,
					_react2.default.createElement(
						'a',
						{ href: login.link, className: 'tw-text-viridian tw-ml-1' },
						login.label
					)
				)
			),
			_react2.default.createElement(
				'a',
				{
					href: facebook.link,
					className: btnClassName,
					onClick: facebookOnClick
				},
				_react2.default.createElement('img', { src: _facebook2.default }),
				_react2.default.createElement(
					'div',
					{ className: 'tw-flex-grow tw-text-center' },
					facebook.label,
					' '
				)
			),
			_react2.default.createElement(
				'a',
				{ href: google.link, className: btnClassName, onClick: googleOnClick },
				_react2.default.createElement('img', { src: _google2.default }),
				_react2.default.createElement(
					'div',
					{ className: 'tw-flex-grow tw-text-center' },
					google.label,
					' '
				)
			),
			apple && apple.shouldRender && _react2.default.createElement(
				'a',
				{
					href: apple.link,
					className: btnClassName,
					onClick: appleOnClick,
					'data-testid': 'apple'
				},
				_react2.default.createElement('img', { src: _apple2.default }),
				_react2.default.createElement(
					'div',
					{ className: 'tw-flex-grow tw-text-center' },
					apple.label
				)
			),
			_react2.default.createElement(
				'a',
				{ href: email.link, className: btnClassName, onClick: emailOnClick },
				_react2.default.createElement('img', { src: _email2.default }),
				_react2.default.createElement(
					'div',
					{ className: 'tw-flex-grow tw-text-center' },
					email.label,
					' '
				)
			)
		)
	);
};

exports.SignupModal = SignupModal;
SignupModal.propTypes = {
	/** Callback that happens when a user dismisses the modal */
	onDismiss: _propTypes2.default.func,

	/** Ways a user can sign into Meetup (or sign up for Meetup) */
	signupOptions: _propTypes2.default.object
};

exports.default = SignupModal;
SignupModal.__docgenInfo = {
	'description': '@param {Object} props component properties\n@returns {React.element} SignupModal',
	'methods': [],
	'props': {
		'onDismiss': {
			'type': {
				'name': 'func'
			},
			'required': false,
			'description': 'Callback that happens when a user dismisses the modal'
		},
		'signupOptions': {
			'type': {
				'name': 'object'
			},
			'required': false,
			'description': 'Ways a user can sign into Meetup (or sign up for Meetup)'
		}
	}
};
//# sourceMappingURL=SignupModal.js.map