'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.Button = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Icon = require('../media/Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _swarmComponents = require('@meetup/swarm-components');

var _buttonUtils = require('@meetup/swarm-components/lib/utils/buttonUtils');

var _DeprecationWarning = require('../utils/components/DeprecationWarning');

var _DeprecationWarning2 = _interopRequireDefault(_DeprecationWarning);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * @module Button
 */
var Button = exports.Button = function (_React$PureComponent) {
	_inherits(Button, _React$PureComponent);

	function Button() {
		_classCallCheck(this, Button);

		return _possibleConstructorReturn(this, (Button.__proto__ || Object.getPrototypeOf(Button)).apply(this, arguments));
	}

	_createClass(Button, [{
		key: 'componentDidCatch',
		value: function componentDidCatch(error, info) {
			console.log(error + ': \n ' + info.componentStack);
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    fullWidth = _props.fullWidth,
			    component = _props.component,
			    icon = _props.icon,
			    hasHoverShadow = _props.hasHoverShadow,
			    to = _props.to,
			    other = _objectWithoutProperties(_props, ['fullWidth', 'component', 'icon', 'hasHoverShadow', 'to']);

			// checking for the icon component signature if passed as icon={<Icon shape="search"/>} and grabbing the shape prop


			var iconShape = icon && icon.props && icon.props.shape;

			if (!!component && to == undefined && this.props.href == undefined) {
				console.error('Invalid component prop for <Button>. All Swarm UI v2 Button components are button, anchor, or Link elements.');
			}

			// support for react-router Link component
			if (!!component && to !== undefined) {
				var children = other.children,
				    right = other.right,
				    primary = other.primary,
				    small = other.small,
				    bordered = other.bordered,
				    neutral = other.neutral,
				    inverted = other.inverted,
				    grow = other.grow,
				    linkProps = _objectWithoutProperties(other, ['children', 'right', 'primary', 'small', 'bordered', 'neutral', 'inverted', 'grow']);

				var buttonType = (0, _buttonUtils.getButtonType)(this.props);

				var Component = component;

				return _react2.default.createElement(
					Component,
					_extends({
						'data-swarm-button': buttonType,
						'data-swarm-size': (0, _buttonUtils.getSwarmSize)(this.props),
						'data-icon': (0, _buttonUtils.getIconPosition)(this.props),
						'data-swarm-width': fullWidth ? 'grow' : 'default',
						to: to
					}, linkProps),
					icon ? right ? _react2.default.createElement(
						_react2.default.Fragment,
						null,
						children,
						_react2.default.createElement(_Icon2.default, { shape: iconShape, size: 'xs' })
					) : _react2.default.createElement(
						_react2.default.Fragment,
						null,
						_react2.default.createElement(_Icon2.default, { shape: iconShape, size: 'xs' }),
						children
					) : children
				);
			} else if (component === 'a') {
				return _react2.default.createElement(_swarmComponents.LinkButton, _extends({ icon: iconShape, grow: fullWidth }, other));
			}

			return _react2.default.createElement(_swarmComponents.Button, _extends({ icon: iconShape, grow: fullWidth }, other));
		}
	}]);

	return Button;
}(_react2.default.PureComponent);

Button.propTypes = {
	/** Used to highlight the most important action on a screen. Not intended to be used more than once on a screen/modal/section. */
	primary: _propTypes2.default.bool,

	/** The standard button for most use cases. Other styles are available for buttons that need more visual weight */
	neutral: _propTypes2.default.bool,

	/** Takes an `Icon` element to render inside of the button */
	icon: _propTypes2.default.element,

	/** Renders the icon on the right side of the button text */
	right: _propTypes2.default.bool,

	/** Reduces the size of the button */
	small: _propTypes2.default.bool,

	/** Sometimes used in place of a Neutral button on shaded backgrounds to maintain the appropriate visual weight */
	bordered: _propTypes2.default.bool,

	/** Which component or html element type to use */
	component: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.func]),

	/** Whether to use disabled attribute and disabled button styles */
	disabled: _propTypes2.default.bool
};
exports.default = (0, _DeprecationWarning2.default)(Button);
Button.__docgenInfo = {
	'description': '@module Button',
	'methods': [{
		'name': 'componentDidCatch',
		'docblock': null,
		'modifiers': [],
		'params': [{
			'name': 'error',
			'type': null
		}, {
			'name': 'info',
			'type': null
		}],
		'returns': null
	}],
	'displayName': 'Button',
	'props': {
		'primary': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Used to highlight the most important action on a screen. Not intended to be used more than once on a screen/modal/section.'
		},
		'neutral': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'The standard button for most use cases. Other styles are available for buttons that need more visual weight'
		},
		'icon': {
			'type': {
				'name': 'element'
			},
			'required': false,
			'description': 'Takes an `Icon` element to render inside of the button'
		},
		'right': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Renders the icon on the right side of the button text'
		},
		'small': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Reduces the size of the button'
		},
		'bordered': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Sometimes used in place of a Neutral button on shaded backgrounds to maintain the appropriate visual weight'
		},
		'component': {
			'type': {
				'name': 'union',
				'value': [{
					'name': 'string'
				}, {
					'name': 'func'
				}]
			},
			'required': false,
			'description': 'Which component or html element type to use'
		},
		'disabled': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Whether to use disabled attribute and disabled button styles'
		}
	}
};
//# sourceMappingURL=Button.js.map