'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.CalendarComponent = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _withErrorList = require('../utils/components/withErrorList');

var _withErrorList2 = _interopRequireDefault(_withErrorList);

var _reactFlatpickr = require('react-flatpickr');

var _reactFlatpickr2 = _interopRequireDefault(_reactFlatpickr);

var _core = require('@js-joda/core');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/*
 * Single date picker component.
 * Wraps [react-flatpickr](github.com/coderhaoxin/react-flatpickr)
 *
 * For full documentation of available `datePickerOptions`, see:
 * https://chmln.github.io/flatpickr/options/
 */
var CalendarComponent = exports.CalendarComponent = function (_React$Component) {
	_inherits(CalendarComponent, _React$Component);

	function CalendarComponent(props) {
		_classCallCheck(this, CalendarComponent);

		// the wrapped Flatpickr requires a `value` that is a vanilla JS `Date`
		// instance, but `CalendarComponent` provides a `LocalDate` interface.
		// Converting between those two data types is relatively expensive, so
		// we define a memoized 'converter' instance method that will only calculate
		// a new `Date` value when `this.props.value` changes.
		var _this = _possibleConstructorReturn(this, (CalendarComponent.__proto__ || Object.getPrototypeOf(CalendarComponent)).call(this, props));

		_this.onFlatPickerChange = function (selectedDates, dateString, flatpickrInstance) {
			var _selectedDates = _slicedToArray(selectedDates, 1),
			    selectedDate = _selectedDates[0];

			var onChange = _this.props.onChange;
			/*
    * Seems like Flatpickr can have non-valid dates
    * js-joda fails to create intance in that case
    */

			if (!onChange || !selectedDate) {
				return;
			}
			onChange(_core.LocalDate.from((0, _core.nativeJs)(selectedDate)), dateString, flatpickrInstance);
		};

		var prevArg = void 0;
		var prevReturn = void 0;
		_this.getPickrValue = function (value) {
			if (value === prevArg) {
				return prevReturn;
			}
			prevArg = value;
			prevReturn = _this.props.value && (0, _core.convert)(_this.props.value).toDate();
			return prevReturn;
		};
		return _this;
	}

	/*
  * the Flatpickr component always passes an array of recently selected
  * dates to its onChange handler, with the most recent in first position of
  * the array. We are only interested in the most-recently-selected value.
  *
  * Flatpickr also provides a dateString and a reference to the flatpickr
  * instance, which can be used for more advanced behaviors, but should
  * generally be ignored. See flatpickr docs for details.
  */


	_createClass(CalendarComponent, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    id = _props.id,
			    name = _props.name,
			    label = _props.label,
			    labelClassName = _props.labelClassName,
			    helperText = _props.helperText,
			    error = _props.error,
			    datepickerOptions = _props.datepickerOptions,
			    className = _props.className,
			    onChange = _props.onChange,
			    required = _props.required,
			    requiredText = _props.requiredText,
			    value = _props.value,
			    other = _objectWithoutProperties(_props, ['id', 'name', 'label', 'labelClassName', 'helperText', 'error', 'datepickerOptions', 'className', 'onChange', 'required', 'requiredText', 'value']);

			var classNames = {
				label: (0, _classnames2.default)({
					'label--required': required,
					'flush--bottom': helperText
				}, labelClassName),
				helperText: (0, _classnames2.default)('helperTextContainer', { required: required }),
				field: (0, _classnames2.default)('input--dateTimePicker select--reset', { 'field--error': Boolean(error) }, className)
			};

			var options = _extends({
				altInput: true,
				altFormat: 'D M d, Y',
				ariaDateFormat: 'D M d, Y',
				nextArrow: '<span class="svg svg--chevron-right">\n\t\t\t\t<svg preserveAspectRatio="xMinYMin meet" width="12" height="12" viewBox="0 0 12 12" className="svg-icon valign--middle" role="img" aria-label="Next month">\n\t\t\t\t<title>Next month</title>\n\t\t\t\t<use xlink:href="#icon-chevron-right" />\n\t\t\t\t</svg>\n\t\t\t</span>',
				prevArrow: '<span class="svg svg--chevron-left">\n\t\t\t\t<svg preserveAspectRatio="xMinYMin meet" width="12" height="12" viewBox="0 0 12 12" className="svg-icon valign--middle" role="img" aria-label="Previous month">\n\t\t\t\t<title>Previous month</title>\n\t\t\t\t<use xlink:href="#icon-chevron-left" />\n\t\t\t\t</svg>\n\t\t\t</span>'
			}, datepickerOptions);

			// When using altInput, the Flatpickr must be re-mounted in order to apply
			// new classnames - this is only 'safe' when the picker has a supplied value
			if (value && !other.key) {
				other.key = classNames.field;
			}

			return React.createElement(
				'span',
				null,
				label && React.createElement(
					'label',
					{
						htmlFor: id || name,
						className: classNames.label,
						'data-requiredtext': required && requiredText
					},
					label
				),
				helperText && React.createElement(
					'div',
					{ className: classNames.helperText },
					helperText
				),
				React.createElement(_reactFlatpickr2.default, _extends({
					id: id || name,
					options: options,
					'aria-label': 'Use arrow keys to navigate the calendar',
					className: classNames.field,
					onChange: this.onFlatPickerChange,
					value: this.getPickrValue(value),
					onDayCreate: function onDayCreate(_, __, ___, dayElem) {
						var isSelected = dayElem.classList.contains('selected');
						dayElem.role = 'button';
						if (!dayElem.ariaCurrent) {
							dayElem.ariaPressed = isSelected;
						} else if (isSelected) {
							dayElem.ariaPressed = true; // apply aria-pressed attr to current date only in case it's currently selected
						}
					}
				}, other))
			);
		}
	}]);

	return CalendarComponent;
}(React.Component);

CalendarComponent.defaultProps = {
	requiredText: '*',
	datepickerOptions: {}
};
exports.default = (0, _withErrorList2.default)(CalendarComponent);
CalendarComponent.__docgenInfo = {
	'description': '',
	'methods': [{
		'name': 'onFlatPickerChange',
		'docblock': null,
		'modifiers': [],
		'params': [{
			'name': 'selectedDates',
			'type': {
				'name': 'Array',
				'elements': [{
					'name': 'Date'
				}],
				'raw': 'Array<Date>',
				'alias': 'Array'
			}
		}, {
			'name': 'dateString',
			'type': {
				'name': 'string'
			}
		}, {
			'name': 'flatpickrInstance',
			'type': {
				'name': 'signature',
				'type': 'object',
				'raw': '{}',
				'signature': {
					'properties': []
				}
			}
		}],
		'returns': null
	}],
	'displayName': 'CalendarComponent',
	'props': {
		'requiredText': {
			'defaultValue': {
				'value': '\'*\'',
				'computed': false
			},
			'flowType': {
				'name': 'union',
				'raw': 'string | React$Node',
				'elements': [{
					'name': 'string'
				}, {
					'name': 'React$Node'
				}]
			},
			'required': true,
			'description': ''
		},
		'datepickerOptions': {
			'defaultValue': {
				'value': '{}',
				'computed': false
			},
			'flowType': {
				'name': 'FlatpickrOptions'
			},
			'required': true,
			'description': ''
		},
		'labelClassName': {
			'flowType': {
				'name': 'string'
			},
			'required': true,
			'description': ''
		},
		'error': {
			'flowType': {
				'name': 'union',
				'raw': 'string | React$Node | boolean',
				'elements': [{
					'name': 'string'
				}, {
					'name': 'React$Node'
				}, {
					'name': 'boolean'
				}]
			},
			'required': true,
			'description': ''
		},
		'helperText': {
			'flowType': {
				'name': 'union',
				'raw': 'string | React$Node',
				'elements': [{
					'name': 'string'
				}, {
					'name': 'React$Node'
				}]
			},
			'required': true,
			'description': ''
		},
		'required': {
			'flowType': {
				'name': 'boolean'
			},
			'required': true,
			'description': ''
		},
		'onChange': {
			'flowType': {
				'name': 'signature',
				'type': 'function',
				'raw': '(LocalDate, ?string, ?FlatpickrInstance) => void',
				'signature': {
					'arguments': [{
						'name': '',
						'type': {
							'name': 'LocalDate'
						}
					}, {
						'name': '',
						'type': {
							'name': 'string',
							'nullable': true
						}
					}, {
						'name': '',
						'type': {
							'name': 'FlatpickrInstance',
							'nullable': true
						}
					}],
					'return': {
						'name': 'void'
					}
				}
			},
			'required': false,
			'description': ''
		},
		'value': {
			'flowType': {
				'name': 'LocalDate'
			},
			'required': false,
			'description': ''
		},
		'key': {
			'flowType': {
				'name': 'union',
				'raw': 'string | number',
				'elements': [{
					'name': 'string'
				}, {
					'name': 'number'
				}]
			},
			'required': false,
			'description': ''
		}
	}
};
//# sourceMappingURL=CalendarComponent.js.map