'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.CharCounter = undefined;

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _DeprecationWarning = require('../utils/components/DeprecationWarning');

var _DeprecationWarning2 = _interopRequireDefault(_DeprecationWarning);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var CharCounter = exports.CharCounter = function CharCounter(_ref) {
	var maxLength = _ref.maxLength,
	    valueLength = _ref.valueLength;

	var remainingChars = maxLength - valueLength;

	var classNames = (0, _classnames2.default)('text--tiny', 'text--secondary', 'align--right', 'charCount', {
		'text--error': remainingChars < 0
	});

	return _react2.default.createElement(
		'p',
		{ tabIndex: '-1', className: classNames },
		remainingChars
	);
};

CharCounter.propTypes = {
	maxLength: _propTypes2.default.number.isRequired,
	valueLength: _propTypes2.default.number.isRequired
};

exports.default = (0, _DeprecationWarning2.default)(CharCounter);
CharCounter.__docgenInfo = {
	'description': '',
	'methods': [],
	'props': {
		'maxLength': {
			'type': {
				'name': 'number'
			},
			'required': true,
			'description': ''
		},
		'valueLength': {
			'type': {
				'name': 'number'
			},
			'required': true,
			'description': ''
		}
	}
};
//# sourceMappingURL=CharCounter.js.map