'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.Checkbox = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Icon = require('@meetup/swarm-components/lib/Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _DeprecationWarning = require('../utils/components/DeprecationWarning');

var _DeprecationWarning2 = _interopRequireDefault(_DeprecationWarning);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * @module Checkbox
 */
var Checkbox = exports.Checkbox = function (_React$PureComponent) {
	_inherits(Checkbox, _React$PureComponent);

	function Checkbox(props) {
		_classCallCheck(this, Checkbox);

		var _this = _possibleConstructorReturn(this, (Checkbox.__proto__ || Object.getPrototypeOf(Checkbox)).call(this, props));

		_this.handleKeyPress = function (e) {
			if (e.key === ' ') {
				_this.props.onChange && _this.props.onChange(e);

				if (_this.props.controlled) {
					_this.setState({ checked: !_this.state.checked });
				}
			}
		};

		_this.state = {
			checked: props.checked || false
		};

		_this.onChange = _this.onChange.bind(_this);
		return _this;
	}

	_createClass(Checkbox, [{
		key: 'UNSAFE_componentWillReceiveProps',
		value: function UNSAFE_componentWillReceiveProps(nextProps) {
			var checked = nextProps.checked,
			    controlled = nextProps.controlled;


			if (this.props.controlled !== controlled && controlled) {
				this.setState({ checked: checked });
			}
		}
	}, {
		key: 'componentDidCatch',
		value: function componentDidCatch(error, info) {
			console.log(error + ': \n ' + info.componentStack);
		}
	}, {
		key: 'onChange',
		value: function onChange(e) {
			this.props.onChange && this.props.onChange(e);

			if (this.props.controlled) {
				this.setState({ checked: e.target.checked });
			}
		}
	}, {
		key: 'getChecked',
		value: function getChecked() {
			if (this.props.controlled) {
				return this.state.checked;
			}

			return this.props.checked;
		}
	}, {
		key: 'render',
		value: function render() {
			// use the "eslint-disable-line" because we don't want
			// the `checked` and `controlled` props passed in `other`
			var _props = this.props,
			    checked = _props.checked,
			    controlled = _props.controlled,
			    onChange = _props.onChange,
			    id = _props.id,
			    label = _props.label,
			    disabled = _props.disabled,
			    name = _props.name,
			    _props$value = _props.value,
			    value = _props$value === undefined ? '' : _props$value,
			    customStyle = _props.className,
			    ariaLabel = _props.ariaLabel,
			    other = _objectWithoutProperties(_props, ['checked', 'controlled', 'onChange', 'id', 'label', 'disabled', 'name', 'value', 'className', 'ariaLabel']);

			var elId = id || name + '-' + value;
			var stateChecked = this.getChecked();

			return _react2.default.createElement(
				'label',
				_extends({
					className: (0, _classnames2.default)('checkbox-container', customStyle),
					htmlFor: elId
				}, other),
				_react2.default.createElement(
					'span',
					{
						'data-swarm-checkbox-field': stateChecked ? 'checked' : undefined,
						className: 'checkbox',
						role: 'checkbox',
						'aria-checked': stateChecked,
						'aria-label': typeof label === 'string' ? label + ' - checkbox' : 'checkbox',
						tabIndex: 0,
						onKeyPress: this.handleKeyPress
					},
					stateChecked && _react2.default.createElement(_Icon2.default, {
						shape: 'check',
						color: disabled ? '#707070' : '#ffffff',
						'aria-label': (typeof label === 'string' ? label : 'checkbox') + ' - ' + (stateChecked ? 'checked' : 'unchecked')
					})
				),
				_react2.default.createElement('input', {
					type: 'checkbox',
					id: elId,
					checked: stateChecked,
					disabled: disabled,
					onChange: this.onChange,
					readOnly: !this.onChange || disabled,
					name: name,
					'aria-label': ariaLabel || (typeof label === 'string' ? label + ' - checkbox' : 'checkbox'),
					value: '' + value
				}),
				_react2.default.createElement(
					'span',
					null,
					label
				)
			);
		}
	}]);

	return Checkbox;
}(_react2.default.PureComponent);

Checkbox.propTypes = {
	checked: _propTypes2.default.bool,
	disabled: _propTypes2.default.bool,

	/** Whether the input's `checked` prop is handled outside the component or by using component's internal state */
	controlled: _propTypes2.default.bool,

	/** Adds an `id` attribute to the input, and associates it with the `<label />` */
	id: _propTypes2.default.string,

	/** What we render into the input's `<label />` */
	label: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element]),

	/** The `name` attribute for the input */
	name: _propTypes2.default.string.isRequired,

	/** The `value` attribute for the input */
	value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.bool]),

	/** Callback that happens when the input changes */
	onChange: _propTypes2.default.func,

	/** The `ariaLabel` attribute for the input */
	ariaLabel: _propTypes2.default.string
};

Checkbox.defaultProps = {
	controlled: true
};

exports.default = (0, _DeprecationWarning2.default)(Checkbox);
Checkbox.__docgenInfo = {
	'description': '@module Checkbox',
	'methods': [{
		'name': 'UNSAFE_componentWillReceiveProps',
		'docblock': null,
		'modifiers': [],
		'params': [{
			'name': 'nextProps',
			'type': null
		}],
		'returns': null
	}, {
		'name': 'componentDidCatch',
		'docblock': null,
		'modifiers': [],
		'params': [{
			'name': 'error',
			'type': null
		}, {
			'name': 'info',
			'type': null
		}],
		'returns': null
	}, {
		'name': 'onChange',
		'docblock': null,
		'modifiers': [],
		'params': [{
			'name': 'e',
			'type': null
		}],
		'returns': null
	}, {
		'name': 'handleKeyPress',
		'docblock': null,
		'modifiers': [],
		'params': [{
			'name': 'e',
			'type': null
		}],
		'returns': null
	}, {
		'name': 'getChecked',
		'docblock': null,
		'modifiers': [],
		'params': [],
		'returns': null
	}],
	'displayName': 'Checkbox',
	'props': {
		'controlled': {
			'defaultValue': {
				'value': 'true',
				'computed': false
			},
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Whether the input\'s `checked` prop is handled outside the component or by using component\'s internal state'
		},
		'checked': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': ''
		},
		'disabled': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': ''
		},
		'id': {
			'type': {
				'name': 'string'
			},
			'required': false,
			'description': 'Adds an `id` attribute to the input, and associates it with the `<label />`'
		},
		'label': {
			'type': {
				'name': 'union',
				'value': [{
					'name': 'string'
				}, {
					'name': 'element'
				}]
			},
			'required': false,
			'description': 'What we render into the input\'s `<label />`'
		},
		'name': {
			'type': {
				'name': 'string'
			},
			'required': true,
			'description': 'The `name` attribute for the input'
		},
		'value': {
			'type': {
				'name': 'union',
				'value': [{
					'name': 'string'
				}, {
					'name': 'bool'
				}]
			},
			'required': false,
			'description': 'The `value` attribute for the input'
		},
		'onChange': {
			'type': {
				'name': 'func'
			},
			'required': false,
			'description': 'Callback that happens when the input changes'
		},
		'ariaLabel': {
			'type': {
				'name': 'string'
			},
			'required': false,
			'description': 'The `ariaLabel` attribute for the input'
		}
	}
};
//# sourceMappingURL=Checkbox.js.map