'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var ERROR_CLASSNAME = 'text--error text--small';

/**
 * ErrorList
 *
 * Accessible list of errors for a form input.
 *
 * Currently supports only a single error due to a
 * limitation with `redux-form`.
 */
var ErrorList = function ErrorList(props) {
	var errorId = props.errorId,
	    error = props.error,
	    other = _objectWithoutProperties(props, ['errorId', 'error']);

	if (errorId) {
		other.id = errorId;
	}

	return _react2.default.createElement(
		'ul',
		_extends({ 'aria-live': 'assertive' }, other),
		error && _react2.default.createElement(
			'li',
			{ className: (0, _classnames2.default)(ERROR_CLASSNAME, 'text--small') },
			error
		)
	);
};
ErrorList.propTypes = {
	/** Unique identifier for the errors - used to associate form field with error */
	errorId: _propTypes2.default.string,

	/** Error content to render */
	error: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element, _propTypes2.default.bool])
};

exports.default = ErrorList;
ErrorList.__docgenInfo = {
	'description': 'ErrorList\n\nAccessible list of errors for a form input.\n\nCurrently supports only a single error due to a\nlimitation with `redux-form`.',
	'methods': [],
	'props': {
		'errorId': {
			'type': {
				'name': 'string'
			},
			'required': false,
			'description': 'Unique identifier for the errors - used to associate form field with error'
		},
		'error': {
			'type': {
				'name': 'union',
				'value': [{
					'name': 'string'
				}, {
					'name': 'element'
				}, {
					'name': 'bool'
				}]
			},
			'required': false,
			'description': 'Error content to render'
		}
	}
};
//# sourceMappingURL=ErrorList.js.map