'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.InputTimeComponent = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _withErrorList = require('../utils/components/withErrorList');

var _withErrorList2 = _interopRequireDefault(_withErrorList);

var _FieldsetTime = require('./FieldsetTime');

var _FieldsetTime2 = _interopRequireDefault(_FieldsetTime);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// determined at runtime

/*
 * All-purpose replacement for `<input type="time">` field, even for browsers
 * that don't support it
 */
var InputTimeComponent = exports.InputTimeComponent = function (_React$PureComponent) {
	_inherits(InputTimeComponent, _React$PureComponent);

	function InputTimeComponent() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, InputTimeComponent);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = InputTimeComponent.__proto__ || Object.getPrototypeOf(InputTimeComponent)).call.apply(_ref, [this].concat(args))), _this), _this.state = { forceTextInput: _this.props.forceTextInput }, _this.inputEl = null, _this.onChange = function (e) {
			return _this.props.onChange(e.currentTarget.value);
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(InputTimeComponent, [{
		key: 'componentDidMount',


		// determine runtime support for <input type='time'>
		value: function componentDidMount() {
			if ((this.inputEl || {}).type !== 'time') {
				this.setState(function () {
					return { forceTextInput: true };
				});
			}
		}
	}, {
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    id = _props.id,
			    forceTextInput = _props.forceTextInput,
			    label = _props.label,
			    labelClassName = _props.labelClassName,
			    name = _props.name,
			    className = _props.className,
			    error = _props.error,
			    disabled = _props.disabled,
			    is24Hr = _props.is24Hr,
			    helperText = _props.helperText,
			    required = _props.required,
			    value = _props.value,
			    onChange = _props.onChange,
			    other = _objectWithoutProperties(_props, ['id', 'forceTextInput', 'label', 'labelClassName', 'name', 'className', 'error', 'disabled', 'is24Hr', 'helperText', 'required', 'value', 'onChange']);

			var classNames = {
				field: (0, _classnames2.default)('input--time select--reset', { 'field--error': Boolean(error) }, className),
				label: (0, _classnames2.default)('label--field', {
					'label--disabled': disabled,
					'label--required': required,
					'flush--bottom': helperText
				}, labelClassName),
				helperText: (0, _classnames2.default)('helperTextContainer', { required: required, disabled: disabled })
			};
			var requiredText = typeof required === 'string' ? required : '*';

			var displayId = id || name;
			var errorId = displayId + '-error';

			if (error) {
				other['aria-invalid'] = true;
				other['aria-describedby'] = errorId;
			}

			return React.createElement(
				'div',
				null,
				label && React.createElement(
					'label',
					{
						htmlFor: displayId,
						className: classNames.label,
						'data-requiredtext': requiredText
					},
					label
				),
				helperText && React.createElement(
					'div',
					{ className: classNames.helperText },
					helperText
				),
				this.state.forceTextInput ? React.createElement(_FieldsetTime2.default, _extends({}, other, {
					value: value,
					id: displayId,
					name: name,
					required: Boolean(required),
					disabled: disabled,
					error: error,
					onChange: onChange,
					is24Hr: is24Hr
				})) : React.createElement('input', _extends({}, other, {
					value: value || '',
					id: displayId,
					name: name,
					type: 'time',
					className: classNames.field,
					required: Boolean(required),
					disabled: disabled,
					onChange: this.onChange,
					ref: function ref(input) {
						return _this2.inputEl = input;
					}
				}))
			);
		}
	}]);

	return InputTimeComponent;
}(React.PureComponent);

var InputTimeWithErrors = (0, _withErrorList2.default)(InputTimeComponent);
InputTimeWithErrors.displayName = 'InputTime';
exports.default = InputTimeWithErrors;
InputTimeComponent.__docgenInfo = {
	'description': '',
	'methods': [{
		'name': 'onChange',
		'docblock': null,
		'modifiers': [],
		'params': [{
			'name': 'e',
			'type': {
				'name': 'SyntheticEvent',
				'elements': [{
					'name': 'unknown'
				}],
				'raw': 'SyntheticEvent<*>',
				'alias': 'SyntheticEvent'
			}
		}],
		'returns': null
	}],
	'displayName': 'InputTimeComponent',
	'props': {
		'onChange': {
			'flowType': {
				'name': 'signature',
				'type': 'function',
				'raw': 'string => void',
				'signature': {
					'arguments': [{
						'name': '',
						'type': {
							'name': 'string'
						}
					}],
					'return': {
						'name': 'void'
					}
				}
			},
			'required': true,
			'description': 'onChange handler that receives a \'HH:mm\' string value (not a change event)'
		},
		'error': {
			'flowType': {
				'name': 'union',
				'raw': 'string | boolean',
				'elements': [{
					'name': 'string'
				}, {
					'name': 'boolean'
				}]
			},
			'required': false,
			'description': 'Error content to render'
		},
		'forceTextInput': {
			'flowType': {
				'name': 'boolean'
			},
			'required': false,
			'description': 'Force text fallback if native <input type="time" element should _not_ be used'
		},
		'helperText': {
			'flowType': {
				'name': 'ReactNode',
				'raw': 'React.Node'
			},
			'required': false,
			'description': 'An additional piece of helpful info rendered with the field'
		},
		'is24Hr': {
			'flowType': {
				'name': 'boolean'
			},
			'required': false,
			'description': 'Whether to render time in 24hr time format (e.g.: 02:00 PM => 14:00)'
		},
		'label': {
			'flowType': {
				'name': 'ReactNode',
				'raw': 'React.Node'
			},
			'required': false,
			'description': 'Label for the input'
		},
		'labelClassName': {
			'flowType': {
				'name': 'string'
			},
			'required': false,
			'description': ''
		},
		'required': {
			'flowType': {
				'name': 'union',
				'raw': 'boolean | string',
				'elements': [{
					'name': 'boolean'
				}, {
					'name': 'string'
				}]
			},
			'required': false,
			'description': ''
		}
	}
};
//# sourceMappingURL=InputTime.js.map