'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.LockedBadge = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Icon = require('../media/Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _Flex = require('../layout/Flex');

var _Flex2 = _interopRequireDefault(_Flex);

var _FlexItem = require('../layout/FlexItem');

var _FlexItem2 = _interopRequireDefault(_FlexItem);

var _DeprecationWarning = require('../utils/components/DeprecationWarning');

var _DeprecationWarning2 = _interopRequireDefault(_DeprecationWarning);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * @module LockedBadge
 */
var LockedBadge = exports.LockedBadge = function (_React$PureComponent) {
	_inherits(LockedBadge, _React$PureComponent);

	function LockedBadge(props) {
		_classCallCheck(this, LockedBadge);

		var _this = _possibleConstructorReturn(this, (LockedBadge.__proto__ || Object.getPrototypeOf(LockedBadge)).call(this, props));

		_this.variants = {
			default: {
				iconColor: '#00798A',
				labelColor: '#00798A',
				backgroundColor: '#e4f4f3'
			},
			neutral: {
				iconColor: '#000000',
				labelColor: '#212121',
				backgroundColor: '#f6f7f8'
			}
		};

		_this.handleClick = _this.handleClick.bind(_this);
		return _this;
	}

	_createClass(LockedBadge, [{
		key: 'componentDidCatch',
		value: function componentDidCatch(error, info) {
			console.log(error + ': \n ' + info.componentStack);
		}
	}, {
		key: 'handleClick',
		value: function handleClick(e) {
			if (this.props.preventDefault) {
				e.preventDefault();
			}

			this.props.onClick(e);
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    label = _props.label,
			    onClick = _props.onClick,
			    _props$variant = _props.variant,
			    variant = _props$variant === undefined ? 'default' : _props$variant;
			var _variants$variant = this.variants[variant],
			    iconColor = _variants$variant.iconColor,
			    labelColor = _variants$variant.labelColor,
			    backgroundColor = _variants$variant.backgroundColor;


			return _react2.default.createElement(
				_Flex2.default,
				null,
				_react2.default.createElement(
					_FlexItem2.default,
					{
						shrink: true,
						onClick: this.handleClick,
						className: 'lockedBadge-container',
						style: { backgroundColor: backgroundColor }
					},
					_react2.default.createElement(
						'div',
						{ className: 'lockedBadge-badge' },
						_react2.default.createElement(_Icon2.default, {
							shape: 'lock',
							size: 'xs',
							color: iconColor,
							className: 'lockedBadge-icon-container'
						}),
						_react2.default.createElement(
							'span',
							{ className: 'lockedBadge-label', style: { color: labelColor } },
							label
						)
					)
				)
			);
		}
	}]);

	return LockedBadge;
}(_react2.default.PureComponent);

LockedBadge.propTypes = {
	/** Style theme for badge */
	variant: _propTypes2.default.oneOf(['default', 'neutral']),

	/** Label of CTA badge for unlocking the panel */
	label: _propTypes2.default.string.isRequired,

	/** A callback that happens after the locked label has been clicked  */
	onClick: _propTypes2.default.func.isRequired,

	/** Optional flag for using 'event.preventDefault' method  */
	preventDefault: _propTypes2.default.bool
};

LockedBadge.defaultProps = {
	preventDefault: true
};

exports.default = (0, _DeprecationWarning2.default)(LockedBadge);
LockedBadge.__docgenInfo = {
	'description': '@module LockedBadge',
	'methods': [{
		'name': 'componentDidCatch',
		'docblock': null,
		'modifiers': [],
		'params': [{
			'name': 'error',
			'type': null
		}, {
			'name': 'info',
			'type': null
		}],
		'returns': null
	}, {
		'name': 'handleClick',
		'docblock': null,
		'modifiers': [],
		'params': [{
			'name': 'e',
			'type': null
		}],
		'returns': null
	}],
	'displayName': 'LockedBadge',
	'props': {
		'preventDefault': {
			'defaultValue': {
				'value': 'true',
				'computed': false
			},
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Optional flag for using \'event.preventDefault\' method'
		},
		'variant': {
			'type': {
				'name': 'enum',
				'value': [{
					'value': '\'default\'',
					'computed': false
				}, {
					'value': '\'neutral\'',
					'computed': false
				}]
			},
			'required': false,
			'description': 'Style theme for badge'
		},
		'label': {
			'type': {
				'name': 'string'
			},
			'required': true,
			'description': 'Label of CTA badge for unlocking the panel'
		},
		'onClick': {
			'type': {
				'name': 'func'
			},
			'required': true,
			'description': 'A callback that happens after the locked label has been clicked'
		}
	}
};
//# sourceMappingURL=LockedBadge.js.map