'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.NumberInput = exports.INCREMENT_BTN_CLASS = exports.FOCUSED_INPUT_CLASS = exports.FAUX_INPUT_CLASS = exports.DECREMENT_BTN_CLASS = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _swarmComponents = require('@meetup/swarm-components');

var _withErrorList = require('../utils/components/withErrorList');

var _withErrorList2 = _interopRequireDefault(_withErrorList);

var _DeprecationWarning = require('../utils/components/DeprecationWarning');

var _DeprecationWarning2 = _interopRequireDefault(_DeprecationWarning);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DECREMENT_BTN_CLASS = exports.DECREMENT_BTN_CLASS = 'decrementButton';
var FAUX_INPUT_CLASS = exports.FAUX_INPUT_CLASS = 'fauxInput';
var FOCUSED_INPUT_CLASS = exports.FOCUSED_INPUT_CLASS = 'focused';
var INCREMENT_BTN_CLASS = exports.INCREMENT_BTN_CLASS = 'incrementButton';

var NumberInput = exports.NumberInput = function (_React$PureComponent) {
	_inherits(NumberInput, _React$PureComponent);

	function NumberInput() {
		_classCallCheck(this, NumberInput);

		return _possibleConstructorReturn(this, (NumberInput.__proto__ || Object.getPrototypeOf(NumberInput)).apply(this, arguments));
	}

	_createClass(NumberInput, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    id = _props.id,
			    helperText = _props.helperText,
			    label = _props.label,
			    required = _props.required,
			    requiredText = _props.requiredText,
			    other = _objectWithoutProperties(_props, ['id', 'helperText', 'label', 'required', 'requiredText']);

			return _react2.default.createElement(
				_react2.default.Fragment,
				null,
				label && _react2.default.createElement(
					_swarmComponents.FieldLabel,
					{ htmlFor: id, 'data-requiredtext': required && requiredText },
					label
				),
				helperText && _react2.default.createElement(
					_swarmComponents.FieldHelper,
					null,
					helperText
				),
				_react2.default.createElement(_swarmComponents.NumericalInput, _extends({ id: id, required: required }, other))
			);
		}
	}]);

	return NumberInput;
}(_react2.default.PureComponent);

NumberInput.defaultProps = {
	requiredText: '*'
};
exports.default = (0, _withErrorList2.default)((0, _DeprecationWarning2.default)(NumberInput));
NumberInput.__docgenInfo = {
	'description': '',
	'methods': [],
	'displayName': 'NumberInput',
	'props': {
		'requiredText': {
			'defaultValue': {
				'value': '\'*\'',
				'computed': false
			},
			'flowType': {
				'name': 'union',
				'raw': 'string | React$Node',
				'elements': [{
					'name': 'string'
				}, {
					'name': 'React$Node'
				}]
			},
			'required': false,
			'description': ''
		},
		'className': {
			'flowType': {
				'name': 'string'
			},
			'required': false,
			'description': ''
		},
		'children': {
			'flowType': {
				'name': 'React$Node'
			},
			'required': false,
			'description': ''
		},
		'disabled': {
			'flowType': {
				'name': 'boolean'
			},
			'required': false,
			'description': ''
		},
		'error': {
			'flowType': {
				'name': 'React$Node'
			},
			'required': false,
			'description': ''
		},
		'fauxInputClassName': {
			'flowType': {
				'name': 'string'
			},
			'required': false,
			'description': ''
		},
		'helperText': {
			'flowType': {
				'name': 'union',
				'raw': 'string | React$Node',
				'elements': [{
					'name': 'string'
				}, {
					'name': 'React$Node'
				}]
			},
			'required': false,
			'description': ''
		},
		'id': {
			'flowType': {
				'name': 'string'
			},
			'required': true,
			'description': ''
		},
		'label': {
			'flowType': {
				'name': 'React$Node'
			},
			'required': false,
			'description': ''
		},
		'labelClassName': {
			'flowType': {
				'name': 'string'
			},
			'required': false,
			'description': ''
		},
		'max': {
			'flowType': {
				'name': 'number'
			},
			'required': false,
			'description': ''
		},
		'min': {
			'flowType': {
				'name': 'number'
			},
			'required': false,
			'description': ''
		},
		'name': {
			'flowType': {
				'name': 'string'
			},
			'required': true,
			'description': ''
		},
		'onChange': {
			'flowType': {
				'name': 'signature',
				'type': 'function',
				'raw': 'Value => void',
				'signature': {
					'arguments': [{
						'name': '',
						'type': {
							'name': 'union',
							'raw': 'number | null',
							'elements': [{
								'name': 'number'
							}, {
								'name': 'unknown'
							}]
						}
					}],
					'return': {
						'name': 'void'
					}
				}
			},
			'required': true,
			'description': ''
		},
		'onBlur': {
			'flowType': {
				'name': 'signature',
				'type': 'function',
				'raw': '(SyntheticInputEvent<HTMLInputElement>) => void',
				'signature': {
					'arguments': [{
						'name': '',
						'type': {
							'name': 'SyntheticInputEvent',
							'elements': [{
								'name': 'HTMLInputElement'
							}],
							'raw': 'SyntheticInputEvent<HTMLInputElement>'
						}
					}],
					'return': {
						'name': 'void'
					}
				}
			},
			'required': true,
			'description': ''
		},
		'required': {
			'flowType': {
				'name': 'boolean'
			},
			'required': false,
			'description': ''
		},
		'step': {
			'flowType': {
				'name': 'number'
			},
			'required': true,
			'description': ''
		},
		'value': {
			'flowType': {
				'name': 'union',
				'raw': 'number | null',
				'elements': [{
					'name': 'number'
				}, {
					'name': 'unknown'
				}]
			},
			'required': true,
			'description': ''
		}
	}
};
//# sourceMappingURL=NumberInput.js.map