'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.RadioButton = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RadioButton = exports.RadioButton = function (_React$PureComponent) {
	_inherits(RadioButton, _React$PureComponent);

	function RadioButton() {
		_classCallCheck(this, RadioButton);

		return _possibleConstructorReturn(this, (RadioButton.__proto__ || Object.getPrototypeOf(RadioButton)).apply(this, arguments));
	}

	_createClass(RadioButton, [{
		key: 'componentDidCatch',
		value: function componentDidCatch(error, info) {
			console.log(error + ': \n ' + info.componentStack);
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    checked = _props.checked,
			    label = _props.label,
			    id = _props.id,
			    disabled = _props.disabled,
			    value = _props.value,
			    children = _props.children,
			    name = _props.name,
			    labelClassName = _props.labelClassName,
			    other = _objectWithoutProperties(_props, ['checked', 'label', 'id', 'disabled', 'value', 'children', 'name', 'labelClassName']);

			return _react2.default.createElement(
				'label',
				{ className: (0, _classnames2.default)('radio-container', labelClassName) },
				_react2.default.createElement(
					'span',
					{
						className: (0, _classnames2.default)('radio', { checked: checked, disabled: disabled }),
						tabIndex: 0,
						role: 'checkbox',
						'aria-checked': checked,
						'aria-labelledby': id
					},
					checked && _react2.default.createElement('span', { className: 'radio-indicator' })
				),
				_react2.default.createElement('input', _extends({
					type: 'radio',
					id: id,
					name: name,
					checked: checked,
					disabled: disabled,
					value: value
				}, other)),
				_react2.default.createElement(
					'span',
					null,
					label || children
				)
			);
		}
	}]);

	return RadioButton;
}(_react2.default.PureComponent);

RadioButton.displayName = 'RadioButton';

RadioButton.propTypes = {
	/** What we render into the input's `<label />` */
	label: _propTypes2.default.string.isRequired,

	/** Class name for label wrapper */
	labelClassName: _propTypes2.default.string,

	/** Additional class name/s to add to the wrapper element  */
	className: _propTypes2.default.string,
	/**
  * Used to associate a group of radio buttons.
  * Only one radio button in a group can be selected.
  */
	name: _propTypes2.default.string,
	/**
  * Value of the input.
  */
	value: _propTypes2.default.string
};

exports.default = RadioButton;
RadioButton.__docgenInfo = {
	'description': '',
	'methods': [{
		'name': 'componentDidCatch',
		'docblock': null,
		'modifiers': [],
		'params': [{
			'name': 'error',
			'type': null
		}, {
			'name': 'info',
			'type': null
		}],
		'returns': null
	}],
	'displayName': 'RadioButton',
	'props': {
		'label': {
			'type': {
				'name': 'string'
			},
			'required': true,
			'description': 'What we render into the input\'s `<label />`'
		},
		'labelClassName': {
			'type': {
				'name': 'string'
			},
			'required': false,
			'description': 'Class name for label wrapper'
		},
		'className': {
			'type': {
				'name': 'string'
			},
			'required': false,
			'description': 'Additional class name/s to add to the wrapper element'
		},
		'name': {
			'type': {
				'name': 'string'
			},
			'required': false,
			'description': 'Used to associate a group of radio buttons.\nOnly one radio button in a group can be selected.'
		},
		'value': {
			'type': {
				'name': 'string'
			},
			'required': false,
			'description': 'Value of the input.'
		}
	}
};
//# sourceMappingURL=RadioButton.js.map