'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.RadioButtonGroup = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Flex = require('../layout/Flex');

var _Flex2 = _interopRequireDefault(_Flex);

var _FlexItem = require('../layout/FlexItem');

var _FlexItem2 = _interopRequireDefault(_FlexItem);

var _DeprecationWarning = require('../utils/components/DeprecationWarning');

var _DeprecationWarning2 = _interopRequireDefault(_DeprecationWarning);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * @class RadioButtonGroup
 */
var RadioButtonGroup = exports.RadioButtonGroup = function (_PureComponent) {
	_inherits(RadioButtonGroup, _PureComponent);

	function RadioButtonGroup(props) {
		_classCallCheck(this, RadioButtonGroup);

		var _this = _possibleConstructorReturn(this, (RadioButtonGroup.__proto__ || Object.getPrototypeOf(RadioButtonGroup)).call(this, props));

		_this.state = {
			selectedValue: props.selectedValue
		};

		_this.handleChange = _this.handleChange.bind(_this);
		return _this;
	}

	_createClass(RadioButtonGroup, [{
		key: 'UNSAFE_componentWillReceiveProps',
		value: function UNSAFE_componentWillReceiveProps(nextProps) {
			if ('selectedValue' in nextProps) {
				this.setState({
					selectedValue: nextProps.selectedValue
				});
			}
		}
	}, {
		key: 'handleChange',
		value: function handleChange(e) {
			var value = e.target.value;

			this.props.onChange && this.props.onChange(e);

			// THIS IS AN INTENTIONAL TERRIBLE HACK
			// WE WANT TO SUPPORT OLD BEHAVIOR FOR NOW
			if (e.target.value === undefined) {
				value = e.target.parentNode.value;
			}

			this.setState({
				selectedValue: value
			});
		}
	}, {
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    children = _props.children,
			    className = _props.className,
			    direction = _props.direction;


			return _react2.default.createElement(
				_Flex2.default,
				{ direction: direction, className: className },
				_react2.default.Children.map(children, function (child) {
					var childProps = {};
					var isSelected = child.props.value === _this2.state.selectedValue;

					if (child.type.name === 'TogglePill') {
						childProps = _extends({
							onClick: _this2.handleChange
						}, child.props, {
							isActive: isSelected
						});
					} else {
						childProps = _extends({
							onChange: _this2.handleChange
						}, child.props, {
							checked: isSelected
						});
					}
					return _react2.default.createElement(
						_FlexItem2.default,
						{ shrink: true },
						_react2.default.cloneElement(child, childProps)
					);
				})
			);
		}
	}]);

	return RadioButtonGroup;
}(_react.PureComponent);

RadioButtonGroup.propTypes = {
	children: _propTypes2.default.arrayOf(_propTypes2.default.element).isRequired,

	/** The value of the selected input in the radio group */
	selectedValue: _propTypes2.default.string,

	/** The name attribute on each radio in the group */
	name: _propTypes2.default.string.isRequired,

	/** Additional class name/s to add to the wrapper element */
	className: _propTypes2.default.string,

	/** The axis the radio buttons will be layed out on */
	direction: _propTypes2.default.oneOf(['row', 'column']),

	/** Callback that happens when the input changes */
	onChange: _propTypes2.default.func
};

RadioButtonGroup.defaultProps = {
	direction: 'row'
};

exports.default = (0, _DeprecationWarning2.default)(RadioButtonGroup);
RadioButtonGroup.__docgenInfo = {
	'description': '@class RadioButtonGroup',
	'methods': [{
		'name': 'UNSAFE_componentWillReceiveProps',
		'docblock': null,
		'modifiers': [],
		'params': [{
			'name': 'nextProps',
			'type': null
		}],
		'returns': null
	}, {
		'name': 'handleChange',
		'docblock': null,
		'modifiers': [],
		'params': [{
			'name': 'e',
			'type': null
		}],
		'returns': null
	}],
	'displayName': 'RadioButtonGroup',
	'props': {
		'direction': {
			'defaultValue': {
				'value': '\'row\'',
				'computed': false
			},
			'type': {
				'name': 'enum',
				'value': [{
					'value': '\'row\'',
					'computed': false
				}, {
					'value': '\'column\'',
					'computed': false
				}]
			},
			'required': false,
			'description': 'The axis the radio buttons will be layed out on'
		},
		'children': {
			'type': {
				'name': 'arrayOf',
				'value': {
					'name': 'element'
				}
			},
			'required': true,
			'description': ''
		},
		'selectedValue': {
			'type': {
				'name': 'string'
			},
			'required': false,
			'description': 'The value of the selected input in the radio group'
		},
		'name': {
			'type': {
				'name': 'string'
			},
			'required': true,
			'description': 'The name attribute on each radio in the group'
		},
		'className': {
			'type': {
				'name': 'string'
			},
			'required': false,
			'description': 'Additional class name/s to add to the wrapper element'
		},
		'onChange': {
			'type': {
				'name': 'func'
			},
			'required': false,
			'description': 'Callback that happens when the input changes'
		}
	}
};
//# sourceMappingURL=RadioButtonGroup.js.map