'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.SelectInput = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _swarmComponents = require('@meetup/swarm-components');

var _Icon = require('../media/Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _withErrorList = require('../utils/components/withErrorList');

var _withErrorList2 = _interopRequireDefault(_withErrorList);

var _a11yPassThrough = require('../utils/a11yPassThrough');

var _a11yPassThrough2 = _interopRequireDefault(_a11yPassThrough);

var _DeprecationWarning = require('../utils/components/DeprecationWarning');

var _DeprecationWarning2 = _interopRequireDefault(_DeprecationWarning);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/*
 * MWC custom <select> component
 */
var SelectInput = exports.SelectInput = function (_React$PureComponent) {
	_inherits(SelectInput, _React$PureComponent);

	function SelectInput() {
		_classCallCheck(this, SelectInput);

		return _possibleConstructorReturn(this, (SelectInput.__proto__ || Object.getPrototypeOf(SelectInput)).apply(this, arguments));
	}

	_createClass(SelectInput, [{
		key: 'componentDidCatch',
		value: function componentDidCatch(error, info) {
			console.log(error + ': \n ' + info.componentStack);
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    labelClassName = _props.labelClassName,
			    id = _props.id,
			    label = _props.label,
			    name = _props.name,
			    error = _props.error,
			    helperText = _props.helperText,
			    required = _props.required,
			    disabled = _props.disabled,
			    other = _objectWithoutProperties(_props, ['labelClassName', 'id', 'label', 'name', 'error', 'helperText', 'required', 'disabled']);

			var requiredProps = required ? { required: typeof required === 'string' ? required : '*' } : {};

			var fieldId = id || name;
			var selectState = disabled ? 'disabled' : error ? 'error' : 'default';

			return React.createElement(
				React.Fragment,
				null,
				label && React.createElement(
					_swarmComponents.FieldLabel,
					{
						htmlFor: fieldId,
						className: (0, _a11yPassThrough2.default)(labelClassName)
					},
					label
				),
				helperText && React.createElement(
					_swarmComponents.FieldHelper,
					null,
					helperText
				),
				React.createElement(
					'div',
					{ 'data-swarm-select': selectState },
					React.createElement(
						'div',
						{ 'data-swarm-select-wrapper': true },
						React.createElement('select', _extends({
							name: name,
							id: id || name,
							disabled: disabled
						}, requiredProps, other)),
						React.createElement(
							'span',
							{ 'data-swarm-select-arrow': 'arrow-down' },
							React.createElement(_Icon2.default, { shape: 'chevron-down', ariaLabel: 'Open select' })
						)
					)
				)
			);
		}
	}]);

	return SelectInput;
}(React.PureComponent);

var SelectWithErrors = (0, _withErrorList2.default)((0, _DeprecationWarning2.default)(SelectInput));
SelectWithErrors.displayName = 'Select';

exports.default = SelectWithErrors;
SelectInput.__docgenInfo = {
	'description': '',
	'methods': [{
		'name': 'componentDidCatch',
		'docblock': null,
		'modifiers': [],
		'params': [{
			'name': 'error',
			'type': {
				'name': 'any'
			}
		}, {
			'name': 'info',
			'type': {
				'name': 'any'
			}
		}],
		'returns': null
	}],
	'displayName': 'SelectInput',
	'props': {
		'id': {
			'flowType': {
				'name': 'string'
			},
			'required': false,
			'description': 'Optional `id` attribute for the input, and associates it with the `<label />`'
		},
		'name': {
			'flowType': {
				'name': 'string'
			},
			'required': true,
			'description': 'The `name` attribute for the input, and associates it with the `<label />`'
		},
		'onChange': {
			'flowType': {
				'name': 'signature',
				'type': 'function',
				'raw': '(e: SyntheticInputEvent<*>) => void',
				'signature': {
					'arguments': [{
						'name': 'e',
						'type': {
							'name': 'SyntheticInputEvent',
							'elements': [{
								'name': 'unknown'
							}],
							'raw': 'SyntheticInputEvent<*>'
						}
					}],
					'return': {
						'name': 'void'
					}
				}
			},
			'required': true,
			'description': 'Required - this component is stateless. A callback that happens when the input changes'
		},
		'error': {
			'flowType': {
				'name': 'ReactNode',
				'raw': 'React.Node'
			},
			'required': false,
			'description': 'Supplied by withErrorList'
		},
		'helperText': {
			'flowType': {
				'name': 'string'
			},
			'required': false,
			'description': 'An additional piece of helpful info rendered with the field'
		},
		'label': {
			'flowType': {
				'name': 'string'
			},
			'required': false,
			'description': 'What we render into the input\'s `<label />`'
		},
		'required': {
			'flowType': {
				'name': 'union',
				'raw': 'boolean | string',
				'elements': [{
					'name': 'boolean'
				}, {
					'name': 'string'
				}]
			},
			'required': false,
			'description': 'What to render in order to indicate the field is required. Supply a string for a custom error message'
		},
		'disabled': {
			'flowType': {
				'name': 'union',
				'raw': 'boolean | string',
				'elements': [{
					'name': 'boolean'
				}, {
					'name': 'string'
				}]
			},
			'required': false,
			'description': 'Disabled input status'
		},
		'labelClassName': {
			'flowType': {
				'name': 'string'
			},
			'required': false,
			'description': 'DEPRECATED'
		}
	}
};
//# sourceMappingURL=Select.js.map