'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.SelectInput = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Select = require('./Select');

var _Select2 = _interopRequireDefault(_Select);

var _DeprecationWarning = require('../utils/components/DeprecationWarning');

var _DeprecationWarning2 = _interopRequireDefault(_DeprecationWarning);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Deprecated - use <Select> directly, supply `value` from parent
 * @module SelectInput
 * @deprecated
 */
var SelectInput = exports.SelectInput = function (_React$PureComponent) {
	_inherits(SelectInput, _React$PureComponent);

	function SelectInput(props) {
		_classCallCheck(this, SelectInput);

		var _this = _possibleConstructorReturn(this, (SelectInput.__proto__ || Object.getPrototypeOf(SelectInput)).call(this, props));

		_this.state = {
			value: props.value || (props.options[0] || {}).value
		};
		_this.onChange = _this.onChange.bind(_this);
		return _this;
	}

	_createClass(SelectInput, [{
		key: 'onChange',
		value: function onChange(e) {
			this.setState({ value: e.target.value });
			if (this.props.onChange) {
				this.props.onChange(e);
			}
		}
	}, {
		key: 'UNSAFE_componentWillReceiveProps',
		value: function UNSAFE_componentWillReceiveProps(nextProps) {
			if (nextProps.value !== this.props.value) {
				this.setState(function () {
					return { value: nextProps.value };
				});
			}
		}
	}, {
		key: 'render',
		value: function render() {
			// eslint-disable-next-line no-unused-vars
			var _props = this.props,
			    options = _props.options,
			    error = _props.error,
			    errors = _props.errors,
			    requiredText = _props.requiredText,
			    required = _props.required,
			    other = _objectWithoutProperties(_props, ['options', 'error', 'errors', 'requiredText', 'required']);

			var value = this.state.value;

			var actualRequired = required && requiredText;

			return _react2.default.createElement(
				_Select2.default,
				_extends({}, other, {
					value: value,
					required: actualRequired,
					error: errors && errors.length > 0 || error,
					onChange: this.onChange
				}),
				options.map(function (option, key) {
					return _react2.default.createElement(
						'option',
						{ key: key, value: option.value, disabled: option.disabled },
						option.label
					);
				})
			);
		}
	}]);

	return SelectInput;
}(_react2.default.PureComponent);

SelectInput.defaultProps = {
	requiredText: '*'
};

SelectInput.propTypes = {
	/** The `name` attribute for the input */
	name: _propTypes2.default.string.isRequired,

	/** Adds an `id` attribute to the `<select />`, and associates it with the `<label />` */
	id: _propTypes2.default.string,

	/** Provides a list of option data to render each `<option />` in the `<select />` */
	options: _propTypes2.default.arrayOf(_propTypes2.default.shape({
		label: _propTypes2.default.string.isRequired,
		value: _propTypes2.default.string.isRequired
	})).isRequired,

	/** Error content to render */
	error: _propTypes2.default.string,

	/** A list of errors */
	errors: _propTypes2.default.array,

	/** What we render into the input's `<label />` */
	label: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element]),

	/** The class name/s to add to the `<label />` element */
	labelClassName: _propTypes2.default.string,

	/** Which `<option />` is selected */
	value: function value(props, propName, componentName) {
		var validValues = props.options.map(function (opt) {
			return opt.value;
		});

		if (props[propName] && !validValues.includes(props[propName])) {
			return new Error(propName + ' prop supplied to ' + componentName + ' does not match any supplied options values');
		}
	},

	/** An additional piece of helpful info rendered with the field */
	helperText: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element]),

	/** Whether the field is required to have a value */
	required: _propTypes2.default.bool,

	/** What to render in order to indicate the field is required */
	requiredText: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element])
};

exports.default = (0, _DeprecationWarning2.default)(SelectInput);
SelectInput.__docgenInfo = {
	'description': 'Deprecated - use <Select> directly, supply `value` from parent\n@module SelectInput\n@deprecated',
	'methods': [{
		'name': 'onChange',
		'docblock': null,
		'modifiers': [],
		'params': [{
			'name': 'e',
			'type': null
		}],
		'returns': null
	}, {
		'name': 'UNSAFE_componentWillReceiveProps',
		'docblock': null,
		'modifiers': [],
		'params': [{
			'name': 'nextProps',
			'type': null
		}],
		'returns': null
	}],
	'displayName': 'SelectInput',
	'props': {
		'requiredText': {
			'defaultValue': {
				'value': '\'*\'',
				'computed': false
			},
			'type': {
				'name': 'union',
				'value': [{
					'name': 'string'
				}, {
					'name': 'element'
				}]
			},
			'required': false,
			'description': 'What to render in order to indicate the field is required'
		},
		'name': {
			'type': {
				'name': 'string'
			},
			'required': true,
			'description': 'The `name` attribute for the input'
		},
		'id': {
			'type': {
				'name': 'string'
			},
			'required': false,
			'description': 'Adds an `id` attribute to the `<select />`, and associates it with the `<label />`'
		},
		'options': {
			'type': {
				'name': 'arrayOf',
				'value': {
					'name': 'shape',
					'value': {
						'label': {
							'name': 'string',
							'required': true
						},
						'value': {
							'name': 'string',
							'required': true
						}
					}
				}
			},
			'required': true,
			'description': 'Provides a list of option data to render each `<option />` in the `<select />`'
		},
		'error': {
			'type': {
				'name': 'string'
			},
			'required': false,
			'description': 'Error content to render'
		},
		'errors': {
			'type': {
				'name': 'array'
			},
			'required': false,
			'description': 'A list of errors'
		},
		'label': {
			'type': {
				'name': 'union',
				'value': [{
					'name': 'string'
				}, {
					'name': 'element'
				}]
			},
			'required': false,
			'description': 'What we render into the input\'s `<label />`'
		},
		'labelClassName': {
			'type': {
				'name': 'string'
			},
			'required': false,
			'description': 'The class name/s to add to the `<label />` element'
		},
		'value': {
			'type': {
				'name': 'custom',
				'raw': '(props, propName, componentName) => {\n    const validValues = props.options.map(opt => opt.value);\n\n    if (props[propName] && !validValues.includes(props[propName])) {\n        return new Error(\n            `${propName} prop supplied to ${componentName} does not match any supplied options values`\n        );\n    }\n}'
			},
			'required': false,
			'description': 'Which `<option />` is selected'
		},
		'helperText': {
			'type': {
				'name': 'union',
				'value': [{
					'name': 'string'
				}, {
					'name': 'element'
				}]
			},
			'required': false,
			'description': 'An additional piece of helpful info rendered with the field'
		},
		'required': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Whether the field is required to have a value'
		}
	}
};
//# sourceMappingURL=SelectInput.js.map