'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.TextInput = exports.FIELD_WITH_ICON_CLASS = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _swarmComponents = require('@meetup/swarm-components');

var _SwarmTextInput = require('./SwarmTextInput');

var _SwarmTextInput2 = _interopRequireDefault(_SwarmTextInput);

var _withErrorList = require('../utils/components/withErrorList');

var _withErrorList2 = _interopRequireDefault(_withErrorList);

var _DeprecationWarning = require('../utils/components/DeprecationWarning');

var _DeprecationWarning2 = _interopRequireDefault(_DeprecationWarning);

var _a11yPassThrough = require('../utils/a11yPassThrough');

var _a11yPassThrough2 = _interopRequireDefault(_a11yPassThrough);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FIELD_WITH_ICON_CLASS = exports.FIELD_WITH_ICON_CLASS = 'field--withIcon';

/**
 * @module TextInput
 */
var TextInput = exports.TextInput = function (_React$Component) {
	_inherits(TextInput, _React$Component);

	function TextInput() {
		_classCallCheck(this, TextInput);

		return _possibleConstructorReturn(this, (TextInput.__proto__ || Object.getPrototypeOf(TextInput)).apply(this, arguments));
	}

	_createClass(TextInput, [{
		key: 'componentDidCatch',
		value: function componentDidCatch(error, info) {
			console.log(error + ': \n ' + info.componentStack);
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    disabled = _props.disabled,
			    error = _props.error,
			    helperText = _props.helperText,
			    id = _props.id,
			    isSearch = _props.isSearch,
			    name = _props.name,
			    label = _props.label,
			    labelClassName = _props.labelClassName,
			    onChange = _props.onChange,
			    pattern = _props.pattern,
			    refCallback = _props.refCallback,
			    required = _props.required,
			    _props$requiredText = _props.requiredText,
			    requiredText = _props$requiredText === undefined ? '*' : _props$requiredText,
			    validityMessage = _props.validityMessage,
			    placeholder = _props.placeholder,
			    currencyLabel = _props.currencyLabel,
			    currencyLabelStyle = _props.currencyLabelStyle,
			    value = _props.value,
			    other = _objectWithoutProperties(_props, ['disabled', 'error', 'helperText', 'id', 'isSearch', 'name', 'label', 'labelClassName', 'onChange', 'pattern', 'refCallback', 'required', 'requiredText', 'validityMessage', 'placeholder', 'currencyLabel', 'currencyLabelStyle', 'value']);

			var handleOnChange = function handleOnChange(e) {
				if (onChange) {
					onChange(e);
				}

				e.target.setCustomValidity('');
			};

			var handleInvalid = function handleInvalid(e) {
				if (!validityMessage) return;
				e.target.setCustomValidity(validityMessage);
			};

			var optionalInputProps = {};
			// WC-158
			// Only add a `value` prop if it is defined.
			// Workaround for IE11 support (see ticket)
			if (value !== undefined) {
				optionalInputProps.value = value;
			}

			// If a refCallback is provided in input props
			// add a ref to the <input> tag
			if (refCallback) {
				optionalInputProps.ref = refCallback;
			}

			return _react2.default.createElement(
				'div',
				null,
				label && _react2.default.createElement(
					_swarmComponents.FieldLabel,
					{
						htmlFor: id || name,
						className: (0, _a11yPassThrough2.default)(labelClassName)
					},
					label,
					required && _react2.default.createElement(
						'span',
						null,
						' ',
						requiredText
					)
				),
				helperText && _react2.default.createElement(
					'p',
					{ 'data-swarm-select-helper-text': '1' },
					helperText
				),
				_react2.default.createElement(_SwarmTextInput2.default, _extends({
					isSearch: isSearch,
					name: name,
					error: !!error,
					required: required,
					placeholder: placeholder,
					onChange: handleOnChange,
					onInvalid: handleInvalid,
					pattern: pattern,
					disabled: disabled,
					currencyLabel: currencyLabel,
					currencyLabelStyle: currencyLabelStyle,
					id: id || '',
					'aria-label': label ? undefined : id || name
				}, optionalInputProps, other))
			);
		}
	}]);

	return TextInput;
}(_react2.default.Component);

TextInput.propTypes = {
	/** The `name` attribute for the input */
	name: _propTypes2.default.string.isRequired,

	/** Error content to render */
	error: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element]),

	/** Adds an `id` attribute to the input, and associates it with the `<label />` */
	id: _propTypes2.default.string,

	/** Maximum number of characters for the input value */
	maxLength: _propTypes2.default.number,

	/** Regex pattern that the input value must match */
	pattern: _propTypes2.default.string,

	/** What we render into the input's `<label />` */
	label: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element]),

	/** The class name/s to add to the `<label />` element */
	labelClassName: _propTypes2.default.string,

	/** The hint text to display inside the input using the input's `placeholder` attribute */
	placeholder: _propTypes2.default.string,

	/** Whether the input type is 'search' */
	isSearch: _propTypes2.default.bool,

	/** Callback that happens when the input changes */
	onChange: _propTypes2.default.func,

	/** Whether to use disabled attribute and disabled field styles */
	disabled: _propTypes2.default.bool,

	/** Name of the shape of the icon to render inside the input */
	iconShape: _propTypes2.default.string,

	/** The key for the size to render an icon inside the input */
	iconSize: _propTypes2.default.oneOf(['xs', 's', 'm', 'l', 'xl']),

	/** An additional piece of helpful info rendered with the field */
	helperText: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element]),

	/** Whether the field is required to have a value */
	required: _propTypes2.default.bool,

	/** What to render in order to indicate the field is required */
	requiredText: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element]),

	/** Currency right label for price input */
	currencyLabel: _propTypes2.default.string
};

exports.default = (0, _withErrorList2.default)((0, _DeprecationWarning2.default)(TextInput));
TextInput.__docgenInfo = {
	'description': '@module TextInput',
	'methods': [{
		'name': 'componentDidCatch',
		'docblock': null,
		'modifiers': [],
		'params': [{
			'name': 'error',
			'type': {
				'name': 'any'
			}
		}, {
			'name': 'info',
			'type': {
				'name': 'any'
			}
		}],
		'returns': null
	}],
	'displayName': 'TextInput',
	'props': {
		'name': {
			'type': {
				'name': 'string'
			},
			'required': true,
			'description': 'The `name` attribute for the input',
			'flowType': {
				'name': 'string'
			}
		},
		'error': {
			'type': {
				'name': 'union',
				'value': [{
					'name': 'string'
				}, {
					'name': 'element'
				}]
			},
			'required': false,
			'description': 'Error content to render',
			'flowType': {
				'name': 'union',
				'raw': 'string | React$Node',
				'elements': [{
					'name': 'string'
				}, {
					'name': 'React$Node'
				}]
			}
		},
		'id': {
			'type': {
				'name': 'string'
			},
			'required': false,
			'description': 'Adds an `id` attribute to the input, and associates it with the `<label />`',
			'flowType': {
				'name': 'string'
			}
		},
		'maxLength': {
			'type': {
				'name': 'number'
			},
			'required': false,
			'description': 'Maximum number of characters for the input value',
			'flowType': {
				'name': 'number'
			}
		},
		'pattern': {
			'type': {
				'name': 'string'
			},
			'required': false,
			'description': 'Regex pattern that the input value must match',
			'flowType': {
				'name': 'string'
			}
		},
		'label': {
			'type': {
				'name': 'union',
				'value': [{
					'name': 'string'
				}, {
					'name': 'element'
				}]
			},
			'required': false,
			'description': 'What we render into the input\'s `<label />`',
			'flowType': {
				'name': 'union',
				'raw': 'string | React$Node',
				'elements': [{
					'name': 'string'
				}, {
					'name': 'React$Node'
				}]
			}
		},
		'labelClassName': {
			'type': {
				'name': 'string'
			},
			'required': false,
			'description': 'The class name/s to add to the `<label />` element',
			'flowType': {
				'name': 'string'
			}
		},
		'placeholder': {
			'type': {
				'name': 'string'
			},
			'required': false,
			'description': 'The hint text to display inside the input using the input\'s `placeholder` attribute',
			'flowType': {
				'name': 'string'
			}
		},
		'isSearch': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Whether the input type is \'search\'',
			'flowType': {
				'name': 'boolean'
			}
		},
		'onChange': {
			'type': {
				'name': 'func'
			},
			'required': true,
			'description': 'Callback that happens when the input changes',
			'flowType': {
				'name': 'signature',
				'type': 'function',
				'raw': 'string => void',
				'signature': {
					'arguments': [{
						'name': '',
						'type': {
							'name': 'string'
						}
					}],
					'return': {
						'name': 'void'
					}
				}
			}
		},
		'disabled': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Whether to use disabled attribute and disabled field styles',
			'flowType': {
				'name': 'boolean'
			}
		},
		'iconShape': {
			'type': {
				'name': 'string'
			},
			'required': false,
			'description': 'Name of the shape of the icon to render inside the input',
			'flowType': {
				'name': 'string'
			}
		},
		'iconSize': {
			'type': {
				'name': 'enum',
				'value': [{
					'value': '\'xs\'',
					'computed': false
				}, {
					'value': '\'s\'',
					'computed': false
				}, {
					'value': '\'m\'',
					'computed': false
				}, {
					'value': '\'l\'',
					'computed': false
				}, {
					'value': '\'xl\'',
					'computed': false
				}]
			},
			'required': false,
			'description': 'The key for the size to render an icon inside the input',
			'flowType': {
				'name': 'union',
				'raw': '\'xs\' | \'s\' | \'m\' | \'l\' | \'xl\'',
				'elements': [{
					'name': 'literal',
					'value': '\'xs\''
				}, {
					'name': 'literal',
					'value': '\'s\''
				}, {
					'name': 'literal',
					'value': '\'m\''
				}, {
					'name': 'literal',
					'value': '\'l\''
				}, {
					'name': 'literal',
					'value': '\'xl\''
				}]
			}
		},
		'helperText': {
			'type': {
				'name': 'union',
				'value': [{
					'name': 'string'
				}, {
					'name': 'element'
				}]
			},
			'required': false,
			'description': 'An additional piece of helpful info rendered with the field',
			'flowType': {
				'name': 'union',
				'raw': 'string | React$Node',
				'elements': [{
					'name': 'string'
				}, {
					'name': 'React$Node'
				}]
			}
		},
		'required': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Whether the field is required to have a value',
			'flowType': {
				'name': 'boolean'
			}
		},
		'requiredText': {
			'type': {
				'name': 'union',
				'value': [{
					'name': 'string'
				}, {
					'name': 'element'
				}]
			},
			'required': false,
			'description': 'What to render in order to indicate the field is required',
			'flowType': {
				'name': 'union',
				'raw': 'string | React$Node',
				'elements': [{
					'name': 'string'
				}, {
					'name': 'React$Node'
				}]
			}
		},
		'currencyLabel': {
			'type': {
				'name': 'string'
			},
			'required': false,
			'description': 'Currency right label for price input',
			'flowType': {
				'name': 'string'
			}
		},
		'children': {
			'flowType': {
				'name': 'React$Node'
			},
			'required': false,
			'description': ''
		},
		'refCallback': {
			'flowType': {
				'name': 'signature',
				'type': 'function',
				'raw': 'React$Node => void',
				'signature': {
					'arguments': [{
						'name': '',
						'type': {
							'name': 'React$Node'
						}
					}],
					'return': {
						'name': 'void'
					}
				}
			},
			'required': true,
			'description': ''
		},
		'validityMessage': {
			'flowType': {
				'name': 'string'
			},
			'required': false,
			'description': ''
		},
		'value': {
			'flowType': {
				'name': 'string'
			},
			'required': true,
			'description': ''
		},
		'currencyLabelStyle': {
			'flowType': {
				'name': 'string'
			},
			'required': false,
			'description': ''
		},
		'defaultValue': {
			'flowType': {
				'name': 'string'
			},
			'required': false,
			'description': ''
		}
	}
};
//# sourceMappingURL=TextInput.js.map