'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.Textarea = exports.overrideValue = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _withErrorList = require('../utils/components/withErrorList');

var _withErrorList2 = _interopRequireDefault(_withErrorList);

var _a11yPassThrough = require('../utils/a11yPassThrough');

var _a11yPassThrough2 = _interopRequireDefault(_a11yPassThrough);

var _swarmComponents = require('@meetup/swarm-components');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Should override value with info from state
 * @return {Object} the new state for the component
 */
var overrideValue = exports.overrideValue = function overrideValue(nextProps) {
	return {
		value: nextProps.value || ''
	};
};

/**
 * @module Textarea
 */

var Textarea = exports.Textarea = function (_React$PureComponent) {
	_inherits(Textarea, _React$PureComponent);

	function Textarea() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, Textarea);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Textarea.__proto__ || Object.getPrototypeOf(Textarea)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
			value: ''
		}, _this.onChange = function (e) {
			var onChange = _this.props.onChange;
			var value = e.target.value;


			_this.setState(function () {
				return {
					value: value
				};
			});

			if (onChange) {
				onChange(e);
			}
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(Textarea, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    name = _props.name,
			    value = _props.value,
			    label = _props.label,
			    labelClassName = _props.labelClassName,
			    rows = _props.rows,
			    _props$style = _props.style,
			    style = _props$style === undefined ? {} : _props$style,
			    maxHeight = _props.maxHeight,
			    minHeight = _props.minHeight,
			    id = _props.id,
			    onChange = _props.onChange,
			    helperText = _props.helperText,
			    required = _props.required,
			    requiredText = _props.requiredText,
			    disableResize = _props.disableResize,
			    other = _objectWithoutProperties(_props, ['name', 'value', 'label', 'labelClassName', 'rows', 'style', 'maxHeight', 'minHeight', 'id', 'onChange', 'helperText', 'required', 'requiredText', 'disableResize']);

			return React.createElement(
				'div',
				{ className: 'inputContainer' },
				label && React.createElement(
					_swarmComponents.FieldLabel,
					{ htmlFor: id, className: (0, _a11yPassThrough2.default)(labelClassName) },
					label
				),
				helperText && React.createElement(
					_swarmComponents.FieldHelper,
					null,
					helperText
				),
				React.createElement(_swarmComponents.Textarea, _extends({
					type: 'text',
					name: name,
					required: required,
					onChange: this.onChange,
					rows: rows,
					style: _extends({
						minHeight: minHeight,
						maxHeight: maxHeight,
						resize: disableResize ? 'none' : 'auto'
					}, style),
					id: id,
					value: this.state.value,
					'aria-label': label ? undefined : id
				}, other))
			);
		}
	}], [{
		key: 'getDerivedStateFromProps',


		/**
   * @param {Object} nextProps the incoming props
   * @return {undefined} side effect only
   */
		value: function getDerivedStateFromProps(nextProps) {
			return overrideValue(nextProps);
		}

		/**
   * called as user changes value, updates state with new value
   * @param  {Object} e Event object
   * @return {undefined}
   */

	}]);

	return Textarea;
}(React.PureComponent);

Textarea.defaultProps = {
	requiredText: '*'
};
exports.default = (0, _withErrorList2.default)(Textarea);
//# sourceMappingURL=Textarea.js.map