'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _InputTime = require('./InputTime');

var _InputTime2 = _interopRequireDefault(_InputTime);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// Deprecated - use <InputTime> directly, supply `value` from parent
var TimeInput = function (_React$PureComponent) {
	_inherits(TimeInput, _React$PureComponent);

	function TimeInput() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, TimeInput);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = TimeInput.__proto__ || Object.getPrototypeOf(TimeInput)).call.apply(_ref, [this].concat(args))), _this), _this.state = { supportsTime: true, value: _this.props.value }, _this.onChange = function (value) {
			_this.setState({ value: value }, function () {
				_this.props.onChange && _this.props.onChange(value);
				_this.props.onChangeCallback && _this.props.onChangeCallback();
			});
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	// consume the `value` returned to InputTime's onChange callback


	_createClass(TimeInput, [{
		key: 'UNSAFE_componentWillReceiveProps',


		// description updates state to stay in sync with new props from the parent
		value: function UNSAFE_componentWillReceiveProps(nextProps) {
			if (this.props.value !== nextProps.value) {
				this.setState({ value: nextProps.value });
			}
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    value = _props.value,
			    onChange = _props.onChange,
			    onChangeCallback = _props.onChangeCallback,
			    required = _props.required,
			    requiredText = _props.requiredText,
			    other = _objectWithoutProperties(_props, ['value', 'onChange', 'onChangeCallback', 'required', 'requiredText']);

			return _react2.default.createElement(_InputTime2.default, _extends({}, other, {
				required: required && (requiredText || '*'),
				value: this.state.value,
				onChange: this.onChange
			}));
		}
	}]);

	return TimeInput;
}(_react2.default.PureComponent);

exports.default = TimeInput;


TimeInput.propTypes = {
	/** The `name` attribute for the input */
	name: _propTypes2.default.string.isRequired,

	/** Error content to render */
	error: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.bool]),

	/** Whether to render time in 24hr time format (e.g.: 02:00 PM => 14:00) */
	is24Hr: _propTypes2.default.bool,

	/** What we render into the input's `<label />` */
	label: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element]),

	/** The class name/s to add to the `<label />` element */
	labelClassName: _propTypes2.default.string,

	/** onChange function that happens when input value changes */
	onChange: _propTypes2.default.func, // redux-form or DateTimePicker provides an onChange prop

	/** Callback that happens after onChange is complete */
	onChangeCallback: _propTypes2.default.func,

	/** An additional piece of helpful info rendered with the field */
	helperText: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element]),

	/** Whether the field is required to have a value */
	required: _propTypes2.default.bool,

	/** What to render in order to indicate the field is required */
	requiredText: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element])
};
TimeInput.__docgenInfo = {
	'description': '',
	'methods': [{
		'name': 'onChange',
		'docblock': null,
		'modifiers': [],
		'params': [{
			'name': 'value',
			'type': null
		}],
		'returns': null
	}, {
		'name': 'UNSAFE_componentWillReceiveProps',
		'docblock': null,
		'modifiers': [],
		'params': [{
			'name': 'nextProps',
			'type': null
		}],
		'returns': null
	}],
	'displayName': 'TimeInput',
	'props': {
		'name': {
			'type': {
				'name': 'string'
			},
			'required': true,
			'description': 'The `name` attribute for the input'
		},
		'error': {
			'type': {
				'name': 'union',
				'value': [{
					'name': 'string'
				}, {
					'name': 'bool'
				}]
			},
			'required': false,
			'description': 'Error content to render'
		},
		'is24Hr': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Whether to render time in 24hr time format (e.g.: 02:00 PM => 14:00)'
		},
		'label': {
			'type': {
				'name': 'union',
				'value': [{
					'name': 'string'
				}, {
					'name': 'element'
				}]
			},
			'required': false,
			'description': 'What we render into the input\'s `<label />`'
		},
		'labelClassName': {
			'type': {
				'name': 'string'
			},
			'required': false,
			'description': 'The class name/s to add to the `<label />` element'
		},
		'onChange': {
			'type': {
				'name': 'func'
			},
			'required': false,
			'description': 'onChange function that happens when input value changes'
		},
		'onChangeCallback': {
			'type': {
				'name': 'func'
			},
			'required': false,
			'description': 'Callback that happens after onChange is complete'
		},
		'helperText': {
			'type': {
				'name': 'union',
				'value': [{
					'name': 'string'
				}, {
					'name': 'element'
				}]
			},
			'required': false,
			'description': 'An additional piece of helpful info rendered with the field'
		},
		'required': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Whether the field is required to have a value'
		},
		'requiredText': {
			'type': {
				'name': 'union',
				'value': [{
					'name': 'string'
				}, {
					'name': 'element'
				}]
			},
			'required': false,
			'description': 'What to render in order to indicate the field is required'
		}
	}
};
//# sourceMappingURL=TimeInput.js.map