'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.TogglePill = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _swarmComponents = require('@meetup/swarm-components');

var _DeprecationWarning = require('../utils/components/DeprecationWarning');

var _DeprecationWarning2 = _interopRequireDefault(_DeprecationWarning);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Toggle Pill component
 * @module TogglePill
 */
var TogglePill = exports.TogglePill = function (_React$PureComponent) {
	_inherits(TogglePill, _React$PureComponent);

	function TogglePill() {
		_classCallCheck(this, TogglePill);

		return _possibleConstructorReturn(this, (TogglePill.__proto__ || Object.getPrototypeOf(TogglePill)).apply(this, arguments));
	}

	_createClass(TogglePill, [{
		key: 'componentDidCatch',
		value: function componentDidCatch(error, info) {
			console.log(error + ': \n ' + info.componentStack);
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    isActive = _props.isActive,
			    labelClassName = _props.labelClassName,
			    onChange = _props.onChange,
			    onClick = _props.onClick,
			    other = _objectWithoutProperties(_props, ['isActive', 'labelClassName', 'onChange', 'onClick']);

			var clickCallback = onClick ? onClick : onChange ? onChange : false;
			return _react2.default.createElement(_swarmComponents.TogglePill, _extends({ checked: isActive, onClick: clickCallback }, other));
		}
	}]);

	return TogglePill;
}(_react2.default.PureComponent);

TogglePill.propTypes = {
	/** Adds an `id` attribute to the input, and associates it with the `<label />` */
	id: _propTypes2.default.string.isRequired,

	/** The `name` attribute for the input */
	name: _propTypes2.default.string.isRequired,

	/** The `value` attribute for the input */
	value: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.bool]).isRequired,

	children: _propTypes2.default.node.isRequired,

	/** Whether the pill is toggled on/selected */
	isActive: _propTypes2.default.bool,

	/** Deprecated; use `onClick` */
	onChange: _propTypes2.default.func,

	/** Custom callback when clicked */
	onClick: _propTypes2.default.func
};

TogglePill.defaultProps = {
	isActive: false
};

exports.default = (0, _DeprecationWarning2.default)(TogglePill);
TogglePill.__docgenInfo = {
	'description': 'Toggle Pill component\n@module TogglePill',
	'methods': [{
		'name': 'componentDidCatch',
		'docblock': null,
		'modifiers': [],
		'params': [{
			'name': 'error',
			'type': null
		}, {
			'name': 'info',
			'type': null
		}],
		'returns': null
	}],
	'displayName': 'TogglePill',
	'props': {
		'isActive': {
			'defaultValue': {
				'value': 'false',
				'computed': false
			},
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Whether the pill is toggled on/selected'
		},
		'id': {
			'type': {
				'name': 'string'
			},
			'required': true,
			'description': 'Adds an `id` attribute to the input, and associates it with the `<label />`'
		},
		'name': {
			'type': {
				'name': 'string'
			},
			'required': true,
			'description': 'The `name` attribute for the input'
		},
		'value': {
			'type': {
				'name': 'union',
				'value': [{
					'name': 'string'
				}, {
					'name': 'bool'
				}]
			},
			'required': true,
			'description': 'The `value` attribute for the input'
		},
		'children': {
			'type': {
				'name': 'node'
			},
			'required': true,
			'description': ''
		},
		'onChange': {
			'type': {
				'name': 'func'
			},
			'required': false,
			'description': 'Deprecated; use `onClick`'
		},
		'onClick': {
			'type': {
				'name': 'func'
			},
			'required': false,
			'description': 'Custom callback when clicked'
		}
	}
};
//# sourceMappingURL=TogglePill.js.map