'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Icon = require('../media/Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _DeprecationWarning = require('../utils/components/DeprecationWarning');

var _DeprecationWarning2 = _interopRequireDefault(_DeprecationWarning);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * @module ToggleSwitch
 */
var ToggleSwitch = function (_React$Component) {
	_inherits(ToggleSwitch, _React$Component);

	function ToggleSwitch() {
		_classCallCheck(this, ToggleSwitch);

		return _possibleConstructorReturn(this, (ToggleSwitch.__proto__ || Object.getPrototypeOf(ToggleSwitch)).apply(this, arguments));
	}

	_createClass(ToggleSwitch, [{
		key: 'componentDidCatch',
		value: function componentDidCatch(error, info) {
			console.log(error + ': \n ' + info.componentStack);
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    labelClassName = _props.labelClassName,
			    _props$isActive = _props.isActive,
			    checked = _props$isActive === undefined ? false : _props$isActive,
			    label = _props.label,
			    labelledBy = _props.labelledBy,
			    id = _props.id,
			    name = _props.name,
			    disabled = _props.disabled,
			    other = _objectWithoutProperties(_props, ['labelClassName', 'isActive', 'label', 'labelledBy', 'id', 'name', 'disabled']);

			var labelProps = labelledBy ? { 'aria-labelledby': labelledBy } : {};

			var checkedStatus = checked ? 'checked' : 'unchecked';
			var fillIcon = checked ? 'check' : 'cross';

			return _react2.default.createElement(
				'div',
				null,
				label && _react2.default.createElement(
					'label',
					{ htmlFor: id || name },
					label
				),
				_react2.default.createElement(
					'button',
					_extends({
						'data-swarm-toggle': checkedStatus,
						role: 'checkbox',
						type: 'button',
						className: 'toggleSwitch',
						'aria-checked': checked,
						'aria-readonly': disabled,
						disabled: disabled
					}, labelProps, other),
					_react2.default.createElement(
						'span',
						{ 'data-swarm-toggle-switch-disc': true },
						_react2.default.createElement(_Icon2.default, { shape: fillIcon })
					)
				)
			);
		}
	}]);

	return ToggleSwitch;
}(_react2.default.Component);

ToggleSwitch.propTypes = {
	/** Whether to use disabled attribute on the button element and apply disabled switch styles */
	disabled: _propTypes2.default.bool,

	/** Whether the switch is toggled on */
	isActive: _propTypes2.default.bool,

	/** What we render into the input's `<label />` */
	label: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element]),

	/** The id of the element that labels the toggle switch */
	labelledBy: _propTypes2.default.string,

	/** The identifier used to associate a label with a toggle switch */
	name: _propTypes2.default.string.isRequired
};

exports.default = (0, _DeprecationWarning2.default)(ToggleSwitch);
ToggleSwitch.__docgenInfo = {
	'description': '@module ToggleSwitch',
	'methods': [{
		'name': 'componentDidCatch',
		'docblock': null,
		'modifiers': [],
		'params': [{
			'name': 'error',
			'type': null
		}, {
			'name': 'info',
			'type': null
		}],
		'returns': null
	}],
	'displayName': 'ToggleSwitch',
	'props': {
		'disabled': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Whether to use disabled attribute on the button element and apply disabled switch styles'
		},
		'isActive': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Whether the switch is toggled on'
		},
		'label': {
			'type': {
				'name': 'union',
				'value': [{
					'name': 'string'
				}, {
					'name': 'element'
				}]
			},
			'required': false,
			'description': 'What we render into the input\'s `<label />`'
		},
		'labelledBy': {
			'type': {
				'name': 'string'
			},
			'required': false,
			'description': 'The id of the element that labels the toggle switch'
		},
		'name': {
			'type': {
				'name': 'string'
			},
			'required': true,
			'description': 'The identifier used to associate a label with a toggle switch'
		}
	}
};
//# sourceMappingURL=ToggleSwitch.js.map