'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.TA_ITEM_CLASSNAME = exports.TA_DROPDOWN_CLASSNAME = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _downshift = require('downshift');

var _downshift2 = _interopRequireDefault(_downshift);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _swarmComponents = require('@meetup/swarm-components');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TA_DROPDOWN_CLASSNAME = exports.TA_DROPDOWN_CLASSNAME = 'typeahead-dropdown';
var TA_ITEM_CLASSNAME = exports.TA_ITEM_CLASSNAME = 'typeahead-item';

var defaultItemToString = function defaultItemToString(itemValue) {
	return typeof itemValue === 'string' ? itemValue : '';
};

/**
 * @module typeahead
 */

var Typeahead = function (_React$PureComponent) {
	_inherits(Typeahead, _React$PureComponent);

	function Typeahead(props) {
		_classCallCheck(this, Typeahead);

		var _this = _possibleConstructorReturn(this, (Typeahead.__proto__ || Object.getPrototypeOf(Typeahead)).call(this, props));

		_this.handleSelection = _this.handleSelection.bind(_this);
		_this.stateReducer = _this.stateReducer.bind(_this);
		return _this;
	}

	/**
  * @description calls onSelect prop, but passes a selectedItem along with the
  * value of the `multiSelectValue` prop for multiselection
  * @parm {(object|string|array)} selectedItem - the previously selected item
  * @parm {object} stateAndHelpers - Downshift's internal state
  * @returns undefined
  */


	_createClass(Typeahead, [{
		key: 'handleSelection',
		value: function handleSelection(selectedItem, stateAndHelpers) {
			if (this.props.multiSelect) {
				this.props.onSelect(selectedItem, [].concat(_toConsumableArray(this.props.multiSelectValues), [selectedItem]));
			} else {
				this.props.onSelect && this.props.onSelect(selectedItem, stateAndHelpers);
			}
		}

		/**
   * @parm {object} state - Downshift's internal state
   * @parm {object} changes - Changes in Downshift's internal state
   * @returns {object} changes - Changes being passed to Downshift's internal state
   */

	}, {
		key: 'stateReducer',
		value: function stateReducer(state, changes) {
			switch (changes.type) {
				case _downshift2.default.stateChangeTypes.keyDownEnter:
				case _downshift2.default.stateChangeTypes.clickItem:
					this.handleSelection(changes.selectedItem);

					return _extends({}, changes, {
						selectedItem: this.props.multiSelectValues ? this.props.multiSelectValues : changes.selectedItem,
						isOpen: this.props.openOnSelect
					});

				case _downshift2.default.stateChangeTypes.blurInput:
					return _extends({}, changes, {
						isOpen: this.props.openOnSelect
					});

				default:
					return changes;
			}
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    inputProps = _props.inputProps,
			    height = _props.height,
			    items = _props.items,
			    multiSelect = _props.multiSelect,
			    multiSelectValues = _props.multiSelectValues,
			    openOnFocus = _props.openOnFocus,
			    openOnSelect = _props.openOnSelect,
			    openInline = _props.openInline,
			    itemToString = _props.itemToString,
			    onSelect = _props.onSelect,
			    other = _objectWithoutProperties(_props, ['inputProps', 'height', 'items', 'multiSelect', 'multiSelectValues', 'openOnFocus', 'openOnSelect', 'openInline', 'itemToString', 'onSelect']);

			return _react2.default.createElement(
				_downshift2.default,
				_extends({
					onSelect: this.handleSelection,
					selectedItem: multiSelectValues,
					stateReducer: openOnSelect && this.stateReducer,
					itemToString: itemToString
				}, other),
				function (_ref) {
					var getInputProps = _ref.getInputProps,
					    getItemProps = _ref.getItemProps,
					    isOpen = _ref.isOpen,
					    highlightedIndex = _ref.highlightedIndex,
					    selectedItem = _ref.selectedItem,
					    openMenu = _ref.openMenu;
					return _react2.default.createElement(
						'div',
						{ className: 'typeahead' },
						_react2.default.createElement(_swarmComponents.TextInput, getInputProps(_extends({}, inputProps, {
							onFocus: openOnFocus && openMenu
						}))),
						Boolean(isOpen && items && items.length) && _react2.default.createElement(
							'ul',
							{
								className: (0, _classnames2.default)(TA_DROPDOWN_CLASSNAME, _defineProperty({}, TA_DROPDOWN_CLASSNAME + '--inline', openInline)),
								role: 'list',
								style: height && {
									height: height,
									overflowY: 'scroll'
								}
							},
							items && items.map(function (item, i) {
								var selected = multiSelect && selectedItem && selectedItem.includes(item.props.value);

								return _react2.default.createElement(
									'li',
									_extends({
										role: 'listitem'
									}, getItemProps(_extends({
										item: item.props.value,
										i: i,
										key: 'typeaheadItem-' + i,
										id: 'typeaheadItem-' + i,
										className: (0, _classnames2.default)(TA_ITEM_CLASSNAME, item.props.className, {
											'typeahead-item--isActive': highlightedIndex == i
										})
									}, item.props))),
									typeof item.props.children === 'function' ? item.props.children({
										isSelected: selected
									}) : item.props.children
								);
							})
						)
					);
				}
			);
		}
	}]);

	return Typeahead;
}(_react2.default.PureComponent);

Typeahead.defaultProps = {
	itemToString: defaultItemToString
};

Typeahead.propTypes = {
	/** Props to pass to the TextInput */
	inputProps: _propTypes2.default.object,

	/** List of items to render into the dropdown menu area */
	items: _propTypes2.default.arrayOf(_propTypes2.default.element),

	/** A function to pass to Typeahead to make sure all item values are strings */
	itemToString: _propTypes2.default.func,

	/** Height of the dropdown menu of selectable items */
	height: _propTypes2.default.string,

	/** Whether there can be more than one selected value */
	multiSelect: _propTypes2.default.bool,

	/** Whether the dropdown menu shows when the TextInput is focused */
	openOnFocus: _propTypes2.default.bool,

	/** Whether the dropdown menu remains open after an item is selected */
	openOnSelect: _propTypes2.default.bool,

	/** Whether the dropdown menu opens in document flow */
	openInline: _propTypes2.default.bool,

	/** A callback that happens when an item is selected from the dropdown menu */
	onSelect: function onSelect(props, propName, componentName) {
		if (props['multiSelect'] && !props[propName]) {
			return new Error(propName + ' handler must be passed to ' + componentName + ' when \'multiSelect\' is passed');
		}
	}
};

exports.default = Typeahead;
Typeahead.__docgenInfo = {
	'description': '@module typeahead',
	'methods': [{
		'name': 'handleSelection',
		'docblock': '@description calls onSelect prop, but passes a selectedItem along with the\nvalue of the `multiSelectValue` prop for multiselection\n@parm {(object|string|array)} selectedItem - the previously selected item\n@parm {object} stateAndHelpers - Downshift\'s internal state\n@returns undefined',
		'modifiers': [],
		'params': [{
			'name': 'selectedItem'
		}, {
			'name': 'stateAndHelpers'
		}],
		'returns': {
			'description': 'undefined',
			'type': null
		},
		'description': null
	}, {
		'name': 'stateReducer',
		'docblock': '@parm {object} state - Downshift\'s internal state\n@parm {object} changes - Changes in Downshift\'s internal state\n@returns {object} changes - Changes being passed to Downshift\'s internal state',
		'modifiers': [],
		'params': [{
			'name': 'state'
		}, {
			'name': 'changes'
		}],
		'returns': {
			'description': 'changes - Changes being passed to Downshift\'s internal state',
			'type': {
				'name': 'object'
			}
		},
		'description': null
	}],
	'displayName': 'Typeahead',
	'props': {
		'itemToString': {
			'defaultValue': {
				'value': 'itemValue => (typeof itemValue === \'string\' ? itemValue : \'\')',
				'computed': false
			},
			'type': {
				'name': 'func'
			},
			'required': false,
			'description': 'A function to pass to Typeahead to make sure all item values are strings'
		},
		'inputProps': {
			'type': {
				'name': 'object'
			},
			'required': false,
			'description': 'Props to pass to the TextInput'
		},
		'items': {
			'type': {
				'name': 'arrayOf',
				'value': {
					'name': 'element'
				}
			},
			'required': false,
			'description': 'List of items to render into the dropdown menu area'
		},
		'height': {
			'type': {
				'name': 'string'
			},
			'required': false,
			'description': 'Height of the dropdown menu of selectable items'
		},
		'multiSelect': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Whether there can be more than one selected value'
		},
		'openOnFocus': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Whether the dropdown menu shows when the TextInput is focused'
		},
		'openOnSelect': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Whether the dropdown menu remains open after an item is selected'
		},
		'openInline': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Whether the dropdown menu opens in document flow'
		},
		'onSelect': {
			'type': {
				'name': 'custom',
				'raw': '(props, propName, componentName) => {\n    if (props[\'multiSelect\'] && !props[propName]) {\n        return new Error(\n            `${propName} handler must be passed to ${componentName} when \'multiSelect\' is passed`\n        );\n    }\n}'
			},
			'required': false,
			'description': 'A callback that happens when an item is selected from the dropdown menu'
		}
	}
};
//# sourceMappingURL=Typeahead.js.map