'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _core = require('@js-joda/core');

var _CalendarComponent = require('../CalendarComponent');

var _CalendarComponent2 = _interopRequireDefault(_CalendarComponent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

/*
 * wraps standard TextInput web component for use with redux-form
 * deconstructs props that redux-forms sets and sets them on TextInput
 */
var ReduxFormCalendarComponent = function ReduxFormCalendarComponent(props) {
	var meta = props.meta,
	    input = props.input,
	    other = _objectWithoutProperties(props, ['meta', 'input']);

	var error = meta.touched || meta.submitFailed ? meta.error : null;

	var jodaVal = input.value && _core.LocalDate.from((0, _core.nativeJs)(input.value));
	var jodaOnChange = function jodaOnChange(localDate, dateString, flatpickr) {
		var date = (0, _core.convert)(localDate).toDate();
		if (input.onChange) {
			input.onChange(date, dateString, flatpickr);
		}
	};
	return _react2.default.createElement(_CalendarComponent2.default, _extends({
		error: error
	}, input, {
		value: jodaVal,
		onChange: jodaOnChange
	}, other));
};

ReduxFormCalendarComponent.displayName = 'ReduxFormCalendarComponent';

exports.default = ReduxFormCalendarComponent;
ReduxFormCalendarComponent.__docgenInfo = {
	'description': '',
	'methods': [],
	'displayName': 'ReduxFormCalendarComponent',
	'props': {
		'input': {
			'flowType': {
				'name': 'signature',
				'type': 'object',
				'raw': '{\n    value?: Date,\n    onChange?: (Date, ?string, ?FlatpickrInstance) => void,\n}',
				'signature': {
					'properties': [{
						'key': 'value',
						'value': {
							'name': 'Date',
							'required': false
						}
					}, {
						'key': 'onChange',
						'value': {
							'name': 'signature',
							'type': 'function',
							'raw': '(Date, ?string, ?FlatpickrInstance) => void',
							'signature': {
								'arguments': [{
									'name': '',
									'type': {
										'name': 'Date'
									}
								}, {
									'name': '',
									'type': {
										'name': 'string',
										'nullable': true
									}
								}, {
									'name': '',
									'type': {
										'name': 'FlatpickrInstance',
										'nullable': true
									}
								}],
								'return': {
									'name': 'void'
								}
							},
							'required': false
						}
					}]
				}
			},
			'required': true,
			'description': ''
		},
		'meta': {
			'flowType': {
				'name': 'signature',
				'type': 'object',
				'raw': '{\n    touched?: boolean,\n    submitFailed?: boolean,\n    error?: string,\n}',
				'signature': {
					'properties': [{
						'key': 'touched',
						'value': {
							'name': 'boolean',
							'required': false
						}
					}, {
						'key': 'submitFailed',
						'value': {
							'name': 'boolean',
							'required': false
						}
					}, {
						'key': 'error',
						'value': {
							'name': 'string',
							'required': false
						}
					}]
				}
			},
			'required': true,
			'description': ''
		}
	}
};
//# sourceMappingURL=CalendarComponent.js.map