'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _TextInput = require('../TextInput');

var _TextInput2 = _interopRequireDefault(_TextInput);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

/**
 * @param {Object} props - props passed in from parent and redux-form
 * @description wraps standard TextInput web component for use with redux-form
 * deconstructs props that redux-forms sets and sets them on TextInput
 * @return {Component} TextInput
 */
var ReduxFormTextInput = function ReduxFormTextInput(props) {
  var meta = props.meta,
      input = props.input,
      other = _objectWithoutProperties(props, ['meta', 'input']);

  var error = meta.touched || meta.submitFailed ? meta.error : null;

  return _react2.default.createElement(_TextInput2.default, _extends({ error: error }, input, other));
};

ReduxFormTextInput.propTypes = {
  meta: _propTypes2.default.object.isRequired,
  input: _propTypes2.default.oneOfType([_propTypes2.default.element, _propTypes2.default.object]).isRequired
};

ReduxFormTextInput.displayName = 'ReduxFormTextInput';

exports.default = ReduxFormTextInput;
ReduxFormTextInput.__docgenInfo = {
  'description': '@param {Object} props - props passed in from parent and redux-form\n@description wraps standard TextInput web component for use with redux-form\ndeconstructs props that redux-forms sets and sets them on TextInput\n@return {Component} TextInput',
  'methods': [],
  'displayName': 'ReduxFormTextInput',
  'props': {
    'meta': {
      'type': {
        'name': 'object'
      },
      'required': true,
      'description': ''
    },
    'input': {
      'type': {
        'name': 'union',
        'value': [{
          'name': 'element'
        }, {
          'name': 'object'
        }]
      },
      'required': true,
      'description': ''
    }
  }
};
//# sourceMappingURL=TextInput.js.map