'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Textarea = require('../Textarea');

var _Textarea2 = _interopRequireDefault(_Textarea);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

/**
 * This component wraps the standard Textarea component for use with redux-form.
 * It deconstructs props that redux-form sets and re-sets them on Textarea.
 * @param {object} props React component props
 * @return {React.Component} Textarea
 */
var ReduxFormTextarea = function ReduxFormTextarea(props) {
  var meta = props.meta,
      input = props.input,
      other = _objectWithoutProperties(props, ['meta', 'input']);

  var error = meta.touched || meta.submitFailed ? meta.error : null;

  return _react2.default.createElement(_Textarea2.default, _extends({ error: error }, input, other));
};

ReduxFormTextarea.propTypes = {
  meta: _propTypes2.default.object.isRequired,
  input: _propTypes2.default.oneOfType([_propTypes2.default.element, _propTypes2.default.object]).isRequired
};

ReduxFormTextarea.displayName = 'ReduxFormTextarea';

exports.default = ReduxFormTextarea;
ReduxFormTextarea.__docgenInfo = {
  'description': 'This component wraps the standard Textarea component for use with redux-form.\nIt deconstructs props that redux-form sets and re-sets them on Textarea.\n@param {object} props React component props\n@return {React.Component} Textarea',
  'methods': [],
  'displayName': 'ReduxFormTextarea',
  'props': {
    'meta': {
      'type': {
        'name': 'object'
      },
      'required': true,
      'description': ''
    },
    'input': {
      'type': {
        'name': 'union',
        'value': [{
          'name': 'element'
        }, {
          'name': 'object'
        }]
      },
      'required': true,
      'description': ''
    }
  }
};
//# sourceMappingURL=Textarea.js.map