'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _TimeInput = require('../TimeInput');

var _TimeInput2 = _interopRequireDefault(_TimeInput);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

/**
 * This component wraps the standard TimeInput for use with redux-form.
 * It deconstructs props that redux-form sets and re-sets them on TimeInput.
 * @param {object} props React component props
 * @return {React.Component} TimeInput
 */
var ReduxFormTimeInput = function ReduxFormTimeInput(props) {
  var input = props.input,
      meta = props.meta,
      other = _objectWithoutProperties(props, ['input', 'meta']);

  var error = meta.touched || meta.submitFailed ? meta.error : null;

  return _react2.default.createElement(_TimeInput2.default, _extends({}, input, { error: error }, other));
};

ReduxFormTimeInput.propTypes = {
  meta: _propTypes2.default.object.isRequired,
  input: _propTypes2.default.oneOfType([_propTypes2.default.element, _propTypes2.default.object]).isRequired
};

ReduxFormTimeInput.displayName = 'ReduxFormTimeInput';

exports.default = ReduxFormTimeInput;
ReduxFormTimeInput.__docgenInfo = {
  'description': 'This component wraps the standard TimeInput for use with redux-form.\nIt deconstructs props that redux-form sets and re-sets them on TimeInput.\n@param {object} props React component props\n@return {React.Component} TimeInput',
  'methods': [],
  'displayName': 'ReduxFormTimeInput',
  'props': {
    'meta': {
      'type': {
        'name': 'object'
      },
      'required': true,
      'description': ''
    },
    'input': {
      'type': {
        'name': 'union',
        'value': [{
          'name': 'element'
        }, {
          'name': 'object'
        }]
      },
      'required': true,
      'description': ''
    }
  }
};
//# sourceMappingURL=TimeInput.js.map