'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _TogglePill = require('../TogglePill');

var _TogglePill2 = _interopRequireDefault(_TogglePill);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

/**
 * @param {Object} props - props passed in from parent and redux-form
 * @description wraps standard TogglePill web component for use with redux-form
 * deconstructs props that redux-forms sets and sets them on TogglePill
 *
 * NOTE: redux-form expects checkboxes value to be true/false and will set them as so
 * https://github.com/erikras/redux-form/issues/2922, therefore using the value here to
 * set isActive
 *
 * @return {Component} TogglePill
 */
var ReduxFormTogglePill = function ReduxFormTogglePill(props) {
  // not adding meta error to TogglePill prop for now
  // since TogglePills should function in a group with one error
  var meta = props.meta,
      input = props.input,
      other = _objectWithoutProperties(props, ['meta', 'input']);

  return _react2.default.createElement(_TogglePill2.default, _extends({}, input, { isActive: input.value === true }, other));
};

ReduxFormTogglePill.displayName = 'ReduxFormTogglePill';

exports.default = ReduxFormTogglePill;
ReduxFormTogglePill.__docgenInfo = {
  'description': '@param {Object} props - props passed in from parent and redux-form\n@description wraps standard TogglePill web component for use with redux-form\ndeconstructs props that redux-forms sets and sets them on TogglePill\n\nNOTE: redux-form expects checkboxes value to be true/false and will set them as so\nhttps://github.com/erikras/redux-form/issues/2922, therefore using the value here to\nset isActive\n\n@return {Component} TogglePill',
  'methods': [],
  'displayName': 'ReduxFormTogglePill'
};
//# sourceMappingURL=TogglePill.js.map