'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.AdminBar = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Button = require('../forms/Button');

var _Button2 = _interopRequireDefault(_Button);

var _Flex = require('../layout/Flex');

var _Flex2 = _interopRequireDefault(_Flex);

var _FlexItem = require('../layout/FlexItem');

var _FlexItem2 = _interopRequireDefault(_FlexItem);

var _Icon = require('../media/Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _Section = require('../layout/Section');

var _Section2 = _interopRequireDefault(_Section);

var _Tooltip = require('./Tooltip');

var _Tooltip2 = _interopRequireDefault(_Tooltip);

var _SelectInput = require('../forms/SelectInput');

var _SelectInput2 = _interopRequireDefault(_SelectInput);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DropdownContent = function DropdownContent(_ref) {
	var group = _ref.group,
	    event = _ref.event,
	    host = _ref.host;
	return _react2.default.createElement(
		'ul',
		{ className: 'padding--all' },
		group.organizer && _react2.default.createElement(
			'li',
			null,
			_react2.default.createElement(
				'a',
				{
					href: 'https://www.' + host + '/ql/?qlMemberId=' + group.organizer.id,
					className: 'link',
					target: '_blank',
					rel: 'noopener noreferrer'
				},
				'QL Org'
			)
		),
		_react2.default.createElement(
			'li',
			null,
			_react2.default.createElement(
				'a',
				{
					href: 'https://admin.' + host + '/admin/group.jsp?g=' + group.id + '&op=search',
					className: 'link',
					target: '_blank',
					rel: 'noopener noreferrer'
				},
				'Group'
			)
		),
		group.organizer && _react2.default.createElement(
			'li',
			null,
			_react2.default.createElement(
				'a',
				{
					href: 'https://admin.' + host + '/admin/member.jsp?m=' + group.organizer.id,
					className: 'link',
					target: '_blank',
					rel: 'noopener noreferrer'
				},
				'Org'
			)
		),
		event !== undefined && event.id && _react2.default.createElement(
			'li',
			null,
			_react2.default.createElement(
				'a',
				{
					href: 'https://admin.' + host + '/admin/events.jsp?eventIdOrUrl=' + event.id,
					className: 'link',
					target: '_blank',
					rel: 'noopener noreferrer'
				},
				'Event'
			)
		),
		_react2.default.createElement(
			'li',
			null,
			_react2.default.createElement(
				'a',
				{
					href: 'https://admin.' + host + '/admin/events.jsp?groupIdOrUrl=' + group.id,
					className: 'link',
					target: '_blank',
					rel: 'noopener noreferrer'
				},
				'Group Events'
			)
		),
		_react2.default.createElement(
			'li',
			null,
			_react2.default.createElement(
				'a',
				{
					href: 'https://admin.' + host + '/admin/notifications/chapter/' + group.id,
					className: 'link',
					target: '_blank',
					rel: 'noopener noreferrer'
				},
				'Notifs'
			)
		)
	);
};

var AdminBar = exports.AdminBar = function (_React$PureComponent) {
	_inherits(AdminBar, _React$PureComponent);

	function AdminBar(props) {
		_classCallCheck(this, AdminBar);

		var _this = _possibleConstructorReturn(this, (AdminBar.__proto__ || Object.getPrototypeOf(AdminBar)).call(this, props));

		_this.onHighlightValueChange = function (e) {
			_this.setState({ highlightValue: e.target.value });
		};

		_this.highlightGroup = function (host, group) {
			fetch('https://admin.' + host + '/admin_api/index/highlight/', {
				method: 'POST',
				headers: { 'content-type': 'application/x-www-form-urlencoded' },
				body: 'chapter_id=' + group.id + '&value=' + _this.state.highlightValue,
				credentials: 'include'
			}).then(function () {
				_this.toggleHighlighter();
			});
		};

		_this.toggleHighlighter = function () {
			_this.setState(function (state) {
				return { showHighlighter: !state.showHighlighter };
			});
		};

		_this.state = {
			highlightValue: '1',
			showHighlighter: false
		};
		return _this;
	}

	_createClass(AdminBar, [{
		key: 'render',
		value: function render() {
			var _cx;

			var _props = this.props,
			    group = _props.group,
			    event = _props.event,
			    isQL = _props.isQL,
			    isAdmin = _props.isAdmin,
			    self = _props.self,
			    isProdApi = _props.isProdApi,
			    nodeEnv = _props.nodeEnv;

			var isProdEnv = nodeEnv === 'production';
			if (!isAdmin && isProdEnv) {
				return null;
			}

			var host = nodeEnv === 'production' || isProdApi ? 'meetup.com' : 'dev.meetup.com';
			var highlightOptions = ['1', '2', '3', '4', '5', 'lowlight'].map(function (h) {
				return {
					label: h,
					value: h
				};
			});

			return _react2.default.createElement(
				_Flex2.default,
				{
					className: (0, _classnames2.default)('groupAdminLinks', (_cx = {}, _defineProperty(_cx, 'redbar', isProdApi), _defineProperty(_cx, 'greenbar', isQL && !isProdApi), _cx))
				},
				isQL && isAdmin && _react2.default.createElement(
					_FlexItem2.default,
					{ className: 'inverted padding--top-half' },
					_react2.default.createElement(
						'p',
						{ className: 'text--display3' },
						'QL:',
						' ',
						_react2.default.createElement(
							'a',
							{
								href: 'https://admin.' + host + '/admin/member.jsp?m=' + self.id,
								className: 'link',
								target: '_blank',
								rel: 'noopener noreferrer'
							},
							self.name
						)
					)
				),
				isProdApi && !isProdEnv && _react2.default.createElement(
					_FlexItem2.default,
					{ className: 'inverted padding--top-half' },
					_react2.default.createElement(
						'p',
						{ className: 'text--display4' },
						'You are using production data.'
					)
				),
				group !== undefined && isAdmin && _react2.default.createElement(
					_FlexItem2.default,
					{ shrink: true },
					_react2.default.createElement(_Tooltip2.default, {
						direction: 'top',
						align: 'left',
						minWidth: '100px',
						withClose: true,
						noPortal: true,
						id: 'admin-label-btn',
						trigger: _react2.default.createElement(
							_Button2.default,
							{
								id: 'admin-label-btn',
								icon: _react2.default.createElement(_Icon2.default, { shape: 'cog', size: 'xs' })
							},
							'Admin'
						),
						content: group !== undefined && _react2.default.createElement(DropdownContent, {
							host: host,
							group: group,
							event: event
						})
					})
				),
				group !== undefined && isAdmin && _react2.default.createElement(
					_FlexItem2.default,
					{ shrink: true },
					_react2.default.createElement(_Tooltip2.default, {
						direction: 'top',
						align: 'left',
						withClose: true,
						noPortal: true,
						id: 'highlight-label-btn',
						isActive: this.state.showHighlighter,
						trigger: _react2.default.createElement(
							_Button2.default,
							{ id: 'highlight-label-btn' },
							'Highlight ',
							'' + this.state.highlightValue
						),
						content: _react2.default.createElement(
							_Section2.default,
							null,
							_react2.default.createElement(_SelectInput2.default, {
								name: 'highlightValue',
								onChange: this.onHighlightValueChange,
								options: highlightOptions,
								value: this.state.highlightValue
							}),
							_react2.default.createElement(
								'a',
								{
									className: 'button margin--bottom',
									onClick: this.highlightGroup.bind(this, host, group)
								},
								'submit'
							)
						)
					})
				)
			);
		}
	}]);

	return AdminBar;
}(_react2.default.PureComponent);

exports.default = AdminBar;
AdminBar.__docgenInfo = {
	'description': '',
	'methods': [{
		'name': 'onHighlightValueChange',
		'docblock': null,
		'modifiers': [],
		'params': [{
			'name': 'e',
			'type': {
				'name': 'SyntheticInputEvent',
				'elements': [{
					'name': 'EventTarget'
				}],
				'raw': 'SyntheticInputEvent<EventTarget>',
				'alias': 'SyntheticInputEvent'
			}
		}],
		'returns': null
	}, {
		'name': 'highlightGroup',
		'docblock': null,
		'modifiers': [],
		'params': [{
			'name': 'host',
			'type': {
				'name': 'string'
			}
		}, {
			'name': 'group',
			'type': {
				'name': 'Group',
				'alias': 'Group'
			}
		}],
		'returns': null
	}, {
		'name': 'toggleHighlighter',
		'docblock': null,
		'modifiers': [],
		'params': [],
		'returns': null
	}],
	'displayName': 'AdminBar',
	'props': {
		'group': {
			'flowType': {
				'name': 'Group'
			},
			'required': false,
			'description': 'The group for which to render the admin bar'
		},
		'event': {
			'flowType': {
				'name': 'EventInfo'
			},
			'required': false,
			'description': 'The event for which to render the admin bar'
		},
		'isQL': {
			'flowType': {
				'name': 'boolean'
			},
			'required': true,
			'description': 'Whether the user is QL\'ed into somebody else'
		},
		'isAdmin': {
			'flowType': {
				'name': 'boolean'
			},
			'required': true,
			'description': 'Whether the user is logged into Meetup\'s admin tools'
		},
		'isProdApi': {
			'flowType': {
				'name': 'boolean'
			},
			'required': true,
			'description': 'Whether the data being rendered is from production'
		},
		'self': {
			'flowType': {
				'name': 'Self'
			},
			'required': true,
			'description': 'Info about the current user'
		},
		'nodeEnv': {
			'flowType': {
				'name': 'string'
			},
			'required': true,
			'description': 'Environment the component is being rendered in. e.g.: production'
		}
	}
};
//# sourceMappingURL=AdminBar.js.map