'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.DROPDOWN_MENU_ITEM_CLASS = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _downshift = require('downshift');

var _downshift2 = _interopRequireDefault(_downshift);

var _FloatingPosition = require('../utils/components/FloatingPosition');

var _FloatingPosition2 = _interopRequireDefault(_FloatingPosition);

var _constants = require('swarm-constants/dist/js/constants.js');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DROPDOWN_MENU_ITEM_CLASS = exports.DROPDOWN_MENU_ITEM_CLASS = 'dropdownMenu-item';

var Dropdown = function (_React$PureComponent) {
	_inherits(Dropdown, _React$PureComponent);

	function Dropdown() {
		var _ref;

		var _temp, _this, _ret;

		_classCallCheck(this, Dropdown);

		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Dropdown.__proto__ || Object.getPrototypeOf(Dropdown)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
			isActive: _this.props.isActive || false,
			isKeyPressed: false
		}, _this.closeContent = function (e) {
			if (_this.props.manualToggle && _this.props.isActive) {
				_this.props.manualToggle(e);
			} else {
				_this.setState(function () {
					return { isActive: false };
				});
			}
		}, _this.toggleContent = function (e) {
			if (_this.props.manualToggle) {
				_this.props.manualToggle(e);
			} else {
				_this.setState(function () {
					return { isActive: !_this.state.isActive };
				});
			}
		}, _this.onClick = function (e) {
			e.preventDefault();
			_this.toggleContent(e);

			if (_this.props.onClick) {
				_this.props.onClick(e);
			}
		}, _this.onKeyDown = function (e) {
			if (e.key === 'Enter' && _this.state.isActive) {
				setTimeout(function () {
					_this.closeContent(e);
				}, 0);
			}
			_this.setState({ isKeyPressed: true });
		}, _this.onBodyClick = function (e) {
			if (!_this.contentRef || !_this.triggerRef) {
				return;
			}

			var isNotDropdownClick = [_this.contentRef, _this.triggerRef].every(function (ref) {
				return !ref.contains(e.target);
			});

			if (isNotDropdownClick) {
				_this.closeContent(e);
			}
		}, _this.onBodyKeyDown = function (e) {
			if (e.key === 'Escape') {
				_this.closeContent(e);
			}
		}, _this.onMouseLeave = function () {
			return _this.setState({ isKeyPressed: false });
		}, _temp), _possibleConstructorReturn(_this, _ret);
	}

	_createClass(Dropdown, [{
		key: 'componentDidMount',
		value: function componentDidMount() {
			if (document.body) {
				document.body.addEventListener('click', this.onBodyClick);
			}
			if (document.body) {
				document.body.addEventListener('keydown', this.onBodyKeyDown);
			}
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			if (document.body) {
				document.body.removeEventListener('click', this.onBodyClick);
			}
			if (document.body) {
				document.body.removeEventListener('keydown', this.onBodyKeyDown);
			}
		}
	}, {
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    className = _props.className,
			    trigger = _props.trigger,
			    content = _props.content,
			    align = _props.align,
			    direction = _props.direction,
			    offset = _props.offset,
			    maxWidth = _props.maxWidth,
			    minWidth = _props.minWidth,
			    noPortal = _props.noPortal,
			    menuItems = _props.menuItems,
			    downshiftProps = _props.downshiftProps,
			    other = _objectWithoutProperties(_props, ['className', 'trigger', 'content', 'align', 'direction', 'offset', 'maxWidth', 'minWidth', 'noPortal', 'menuItems', 'downshiftProps']);

			// Do not pass along to children


			delete other.manualToggle;
			delete other.isActive;

			var classNames = {
				dropdown: (0, _classnames2.default)(className, 'popup', {
					'popup--noPortal': noPortal
				})
			};

			var isActive = this.props.manualToggle ? this.props.isActive : this.state.isActive;

			var getTrigger = function getTrigger() {
				return _this2.triggerRef;
			};

			var getContent = function getContent() {
				return _this2.contentRef;
			};

			return _react2.default.createElement(
				_downshift2.default,
				_extends({ menuItems: menuItems, isOpen: isActive }, downshiftProps),
				function (_ref2) {
					var isOpen = _ref2.isOpen,
					    getButtonProps = _ref2.getButtonProps,
					    getItemProps = _ref2.getItemProps,
					    highlightedIndex = _ref2.highlightedIndex,
					    openMenu = _ref2.openMenu;
					return _react2.default.createElement(
						'div',
						_extends({
							className: classNames.dropdown,
							onKeyDown: _this2.onKeyDown,
							onMouseLeave: _this2.onMouseLeave
						}, other),
						_react2.default.createElement(
							'div',
							_extends({}, getButtonProps(), {
								ref: function ref(el) {
									return _this2.triggerRef = el;
								},
								className: (0, _classnames2.default)('popup-trigger', {
									'popup-trigger--active': isOpen
								}),
								onClick: _this2.onClick,
								role: 'tooltip',
								type: undefined
							}),
							trigger
						),
						isOpen && _react2.default.createElement(
							_FloatingPosition2.default,
							{
								getTrigger: getTrigger,
								getContent: getContent,
								noPortal: noPortal,
								align: align,
								offset: offset,
								direction: direction
							},
							function (_ref3) {
								var top = _ref3.top,
								    left = _ref3.left,
								    align = _ref3.align,
								    boundedMaxWidth = _ref3.boundedMaxWidth;
								return _react2.default.createElement(
									'div',
									{
										ref: function ref(el) {
											return _this2.contentRef = el;
										},
										className: (0, _classnames2.default)('popup-content', {
											'popup-content--right': align === 'right',
											'popup-content--left': align === 'left',
											'popup-content--center': align === 'center',
											'popup-content--top': direction === 'top',
											'display--none': !isOpen,
											'display--block': isOpen,
											dropdownMenu: Boolean(menuItems)
										}),
										'aria-hidden': !isOpen,
										style: {
											left: left,
											top: top,
											minWidth: minWidth,
											maxWidth: maxWidth || boundedMaxWidth
										}
									},
									_react2.default.createElement(
										'div',
										{
											className: (0, _classnames2.default)('popup-bubble', {
												'popup-bubble--right': align === 'right',
												'popup-bubble--left': align === 'left',
												'popup-bubble--center': align === 'center',
												'popup-bubble--top': direction === 'top'
											})
										},
										menuItems ? menuItems.map(function (item, index) {
											var _item$props = item.props,
											    className = _item$props.className,
											    other = _objectWithoutProperties(_item$props, ['className']);

											return _react2.default.cloneElement(item, _extends({}, getItemProps(_extends({
												item: item,
												key: 'menuItem-' + index,
												className: (0, _classnames2.default)(className, DROPDOWN_MENU_ITEM_CLASS, 'display--flex span--100'),
												style: {
													backgroundColor: _this2.state.isKeyPressed && highlightedIndex === index && _constants.C_COOLGRAYLIGHTTRANSP
												}
											}, other))));
										}) : content
									)
								);
							}
						)
					);
				}
			);
		}
	}]);

	return Dropdown;
}(_react2.default.PureComponent);

Dropdown.defaultProps = {
	direction: 'bottom',
	minWidth: '0px',
	noPortal: false
};
exports.default = Dropdown;
Dropdown.__docgenInfo = {
	'description': '',
	'methods': [{
		'name': 'closeContent',
		'docblock': null,
		'modifiers': [],
		'params': [{
			'name': 'e',
			'type': {
				'name': 'union',
				'raw': 'SyntheticKeyboardEvent<*> | SyntheticMouseEvent<*>',
				'elements': [{
					'name': 'SyntheticKeyboardEvent',
					'elements': [{
						'name': 'unknown'
					}],
					'raw': 'SyntheticKeyboardEvent<*>'
				}, {
					'name': 'SyntheticMouseEvent',
					'elements': [{
						'name': 'unknown'
					}],
					'raw': 'SyntheticMouseEvent<*>'
				}]
			}
		}],
		'returns': null
	}, {
		'name': 'toggleContent',
		'docblock': null,
		'modifiers': [],
		'params': [{
			'name': 'e',
			'type': {
				'name': 'SyntheticMouseEvent',
				'elements': [{
					'name': 'unknown'
				}],
				'raw': 'SyntheticMouseEvent<*>',
				'alias': 'SyntheticMouseEvent'
			}
		}],
		'returns': null
	}, {
		'name': 'onClick',
		'docblock': null,
		'modifiers': [],
		'params': [{
			'name': 'e',
			'type': {
				'name': 'SyntheticMouseEvent',
				'elements': [{
					'name': 'unknown'
				}],
				'raw': 'SyntheticMouseEvent<*>',
				'alias': 'SyntheticMouseEvent'
			}
		}],
		'returns': null
	}, {
		'name': 'onKeyDown',
		'docblock': null,
		'modifiers': [],
		'params': [{
			'name': 'e',
			'type': {
				'name': 'SyntheticKeyboardEvent',
				'elements': [{
					'name': 'unknown'
				}],
				'raw': 'SyntheticKeyboardEvent<*>',
				'alias': 'SyntheticKeyboardEvent'
			}
		}],
		'returns': null
	}, {
		'name': 'onBodyClick',
		'docblock': null,
		'modifiers': [],
		'params': [{
			'name': 'e',
			'type': {
				'name': 'SyntheticMouseEvent',
				'elements': [{
					'name': 'unknown'
				}],
				'raw': 'SyntheticMouseEvent<*>',
				'alias': 'SyntheticMouseEvent'
			}
		}],
		'returns': null
	}, {
		'name': 'onBodyKeyDown',
		'docblock': null,
		'modifiers': [],
		'params': [{
			'name': 'e',
			'type': {
				'name': 'SyntheticKeyboardEvent',
				'elements': [{
					'name': 'unknown'
				}],
				'raw': 'SyntheticKeyboardEvent<*>',
				'alias': 'SyntheticKeyboardEvent'
			}
		}],
		'returns': null
	}, {
		'name': 'onMouseLeave',
		'docblock': null,
		'modifiers': [],
		'params': [],
		'returns': null
	}],
	'displayName': 'Dropdown',
	'props': {
		'direction': {
			'defaultValue': {
				'value': '\'bottom\'',
				'computed': false
			},
			'flowType': {
				'name': 'union',
				'raw': '\'top\' | \'bottom\'',
				'elements': [{
					'name': 'literal',
					'value': '\'top\''
				}, {
					'name': 'literal',
					'value': '\'bottom\''
				}]
			},
			'required': true,
			'description': 'Which side of the dropdown trigger the dropdown content bubble renders on'
		},
		'minWidth': {
			'defaultValue': {
				'value': '\'0px\'',
				'computed': false
			},
			'flowType': {
				'name': 'union',
				'raw': 'string | number',
				'elements': [{
					'name': 'string'
				}, {
					'name': 'number'
				}]
			},
			'required': false,
			'description': 'The smallest width the dropdown content can be'
		},
		'noPortal': {
			'defaultValue': {
				'value': 'false',
				'computed': false
			},
			'flowType': {
				'name': 'boolean'
			},
			'required': false,
			'description': 'Whether to render the dropdown content directly in the component instead of building it out and attaching to the document root'
		},
		'trigger': {
			'flowType': {
				'name': 'React$Node'
			},
			'required': true,
			'description': 'The element that opens the dropdown when clicked'
		},
		'content': {
			'flowType': {
				'name': 'React$Node'
			},
			'required': false,
			'description': 'The content that\'s rendered inside the dropdown'
		},
		'menuItems': {
			'flowType': {
				'name': 'Array',
				'elements': [{
					'name': 'React$Element',
					'elements': [{
						'name': 'unknown'
					}],
					'raw': 'React$Element<*>'
				}],
				'raw': 'Array<React$Element<*>>'
			},
			'required': false,
			'description': 'An array of elements that are rendered as a menu inside the dropdown'
		},
		'align': {
			'flowType': {
				'name': 'union',
				'raw': '\'left\' | \'right\' | \'center\'',
				'elements': [{
					'name': 'literal',
					'value': '\'left\''
				}, {
					'name': 'literal',
					'value': '\'right\''
				}, {
					'name': 'literal',
					'value': '\'center\''
				}]
			},
			'required': true,
			'description': 'The horizontal alignment of the dropdown content bubble to the dropdown trigger'
		},
		'offset': {
			'flowType': {
				'name': 'signature',
				'type': 'object',
				'raw': '{\n    left: number,\n    top: number,\n}',
				'signature': {
					'properties': [{
						'key': 'left',
						'value': {
							'name': 'number',
							'required': true
						}
					}, {
						'key': 'top',
						'value': {
							'name': 'number',
							'required': true
						}
					}]
				}
			},
			'required': false,
			'description': 'How many additional pixels to push the dropdown content bubble'
		},
		'className': {
			'flowType': {
				'name': 'string'
			},
			'required': false,
			'description': 'Class names to add to the wrapper of the dropdown trigger and content'
		},
		'isActive': {
			'flowType': {
				'name': 'boolean'
			},
			'required': false,
			'description': 'Whether the dropdown content is being shown'
		},
		'manualToggle': {
			'flowType': {
				'name': 'signature',
				'type': 'function',
				'raw': '(e: SyntheticKeyboardEvent<*> | SyntheticMouseEvent<*>) => void',
				'signature': {
					'arguments': [{
						'name': 'e',
						'type': {
							'name': 'union',
							'raw': 'SyntheticKeyboardEvent<*> | SyntheticMouseEvent<*>',
							'elements': [{
								'name': 'SyntheticKeyboardEvent',
								'elements': [{
									'name': 'unknown'
								}],
								'raw': 'SyntheticKeyboardEvent<*>'
							}, {
								'name': 'SyntheticMouseEvent',
								'elements': [{
									'name': 'unknown'
								}],
								'raw': 'SyntheticMouseEvent<*>'
							}]
						}
					}],
					'return': {
						'name': 'void'
					}
				}
			},
			'required': false,
			'description': 'A function that is used to control the toggling of the dropdown'
		},
		'maxWidth': {
			'flowType': {
				'name': 'union',
				'raw': 'string | number',
				'elements': [{
					'name': 'string'
				}, {
					'name': 'number'
				}]
			},
			'required': false,
			'description': 'The largest width the dropdown content can be'
		},
		'downshiftProps': {
			'flowType': {
				'name': 'Object'
			},
			'required': false,
			'description': 'Props to pass to the `Downshift` component'
		},
		'onClick': {
			'flowType': {
				'name': 'signature',
				'type': 'function',
				'raw': '(e: SyntheticMouseEvent<*>) => void',
				'signature': {
					'arguments': [{
						'name': 'e',
						'type': {
							'name': 'SyntheticMouseEvent',
							'elements': [{
								'name': 'unknown'
							}],
							'raw': 'SyntheticMouseEvent<*>'
						}
					}],
					'return': {
						'name': 'void'
					}
				}
			},
			'required': false,
			'description': 'Optional custom function to execute on dropdown click'
		}
	}
};
//# sourceMappingURL=Dropdown.js.map