'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.InfoTooltipTrigger = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Button = require('../forms/Button');

var _Button2 = _interopRequireDefault(_Button);

var _Tooltip = require('./Tooltip');

var _Tooltip2 = _interopRequireDefault(_Tooltip);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var InfoTooltipTrigger = exports.InfoTooltipTrigger = function InfoTooltipTrigger(props) {
	return _react2.default.createElement(
		_Button2.default,
		{
			reset: true,
			onClick: function onClick(e) {
				e.preventDefault();
				props.onClick(e);
			},
			'aria-label': 'Help'
		},
		_react2.default.createElement(
			'span',
			{
				className: 'infoToggle-trigger align--center',
				'aria-label': 'infoToggle-icon',
				role: 'img'
			},
			'?'
		)
	);
};

var InfoToggle = function InfoToggle(_ref) {
	var className = _ref.className,
	    label = _ref.label,
	    tooltipId = _ref.tooltipId,
	    tooltipProps = _ref.tooltipProps,
	    tooltipContent = _ref.tooltipContent,
	    onClick = _ref.onClick,
	    other = _objectWithoutProperties(_ref, ['className', 'label', 'tooltipId', 'tooltipProps', 'tooltipContent', 'onClick']);

	return _react2.default.createElement(
		'div',
		_extends({ className: className }, other),
		_react2.default.createElement(
			'span',
			{ className: 'infoToggle-label' },
			label
		),
		_react2.default.createElement(_Tooltip2.default, _extends({
			id: tooltipId,
			trigger: _react2.default.createElement(InfoTooltipTrigger, { onClick: onClick }),
			content: tooltipContent
		}, tooltipProps))
	);
};

InfoToggle.defaultProps = {
	tooltipProps: {
		align: 'right'
	}
};

InfoToggle.propTypes = {
	/** The content that's rendered inside the tooltip's content bubble */
	tooltipContent: _propTypes2.default.element,

	/** The label rendered next to the Tooltip's trigger */
	label: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.element]),

	/** The unique identifier for the Tooltip */
	tooltipId: _propTypes2.default.string.isRequired,

	/** Props to pass to the Tooltip component */
	tooltipProps: _propTypes2.default.object
};

exports.default = InfoToggle;
InfoTooltipTrigger.__docgenInfo = {
	'description': '',
	'methods': []
};
InfoToggle.__docgenInfo = {
	'description': '',
	'methods': [],
	'props': {
		'tooltipProps': {
			'defaultValue': {
				'value': '{\n    align: \'right\',\n}',
				'computed': false
			},
			'type': {
				'name': 'object'
			},
			'required': false,
			'description': 'Props to pass to the Tooltip component'
		},
		'tooltipContent': {
			'type': {
				'name': 'element'
			},
			'required': false,
			'description': 'The content that\'s rendered inside the tooltip\'s content bubble'
		},
		'label': {
			'type': {
				'name': 'union',
				'value': [{
					'name': 'string'
				}, {
					'name': 'element'
				}]
			},
			'required': false,
			'description': 'The label rendered next to the Tooltip\'s trigger'
		},
		'tooltipId': {
			'type': {
				'name': 'string'
			},
			'required': true,
			'description': 'The unique identifier for the Tooltip'
		}
	}
};
//# sourceMappingURL=InfoToggle.js.map