'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.Tabs = exports.TabsTab = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * @module TabsTab
 */
var TabsTab = exports.TabsTab = function (_React$Component) {
	_inherits(TabsTab, _React$Component);

	function TabsTab() {
		_classCallCheck(this, TabsTab);

		return _possibleConstructorReturn(this, (TabsTab.__proto__ || Object.getPrototypeOf(TabsTab)).apply(this, arguments));
	}

	_createClass(TabsTab, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    children = _props.children,
			    isSelected = _props.isSelected,
			    className = _props.className,
			    isLeft = _props.isLeft,
			    other = _objectWithoutProperties(_props, ['children', 'isSelected', 'className', 'isLeft']);

			var classNames = (0, _classnames2.default)('tabs-tab', className, {
				'tabs-tab--selectedLeft': isSelected && isLeft,
				'tabs-tab--notSelectedLeft': !isSelected && isLeft,
				'tabs-tab--selected': isSelected && !isLeft
			});

			return _react2.default.createElement(
				'li',
				_extends({ className: classNames }, other),
				children
			);
		}
	}]);

	return TabsTab;
}(_react2.default.Component);

TabsTab.propTypes = {
	/** Whether the Tab is selected */
	isSelected: _propTypes2.default.bool,

	/** Whether the Tabs selector is layed on left or right part*/
	isLeft: _propTypes2.default.bool
};

/**
 * @module Tabs
 */

var Tabs = exports.Tabs = function (_React$Component2) {
	_inherits(Tabs, _React$Component2);

	function Tabs() {
		_classCallCheck(this, Tabs);

		return _possibleConstructorReturn(this, (Tabs.__proto__ || Object.getPrototypeOf(Tabs)).apply(this, arguments));
	}

	_createClass(Tabs, [{
		key: 'render',
		value: function render() {
			var _props2 = this.props,
			    children = _props2.children,
			    className = _props2.className,
			    bordered = _props2.bordered,
			    noBorder = _props2.noBorder,
			    full = _props2.full,
			    isVertical = _props2.isVertical,
			    other = _objectWithoutProperties(_props2, ['children', 'className', 'bordered', 'noBorder', 'full', 'isVertical']);

			var ulClasses = (0, _classnames2.default)('tabs', {
				'tabs--noBorder': noBorder,
				'tabs--full': full,
				'tabs--isVertical': isVertical
			});

			return _react2.default.createElement(
				'nav',
				{ className: className },
				_react2.default.createElement(
					'ul',
					_extends({ className: ulClasses }, other),
					children
				)
			);
		}
	}]);

	return Tabs;
}(_react2.default.Component);

Tabs.propTypes = {
	/** Individual tabs to render */
	children: function children(props, propName, componentName) {
		var children = props[propName];

		if (_react2.default.Children.count(children) < 2) {
			return new Error('At least two children of type TabsTab required');
		}

		var validChildren = _react2.default.Children.map(children, function (child) {
			return child && child.type.name === 'TabsTab';
		}).every(function (child) {
			return child;
		});

		if (!validChildren) {
			return new Error('Children must be React elements of type TabsTab');
		}
	},

	/** Whether the Tabs bar spans the full width of it's container */
	full: _propTypes2.default.bool,

	/** DEPRECATED */
	bordered: _propTypes2.default.bool, // deprecating in favor of bordered being default

	/** Whether the Tabs bar excludes a bottom or right border */
	noBorder: _propTypes2.default.bool,

	/** Whether the Tabs bar is layed out on the Y axis */
	isVertical: _propTypes2.default.bool
};
TabsTab.__docgenInfo = {
	'description': '@module TabsTab',
	'methods': [],
	'displayName': 'TabsTab',
	'props': {
		'isSelected': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Whether the Tab is selected'
		},
		'isLeft': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Whether the Tabs selector is layed on left or right part'
		}
	}
};
Tabs.__docgenInfo = {
	'description': '@module Tabs',
	'methods': [],
	'displayName': 'Tabs',
	'props': {
		'children': {
			'type': {
				'name': 'custom',
				'raw': '(props, propName, componentName) => {\n    const children = props[propName];\n\n    if (React.Children.count(children) < 2) {\n        return new Error(\'At least two children of type TabsTab required\');\n    }\n\n    const validChildren = React.Children.map(\n        children,\n        child => child && child.type.name === \'TabsTab\'\n    ).every(child => child);\n\n    if (!validChildren) {\n        return new Error(\'Children must be React elements of type TabsTab\');\n    }\n}'
			},
			'required': false,
			'description': 'Individual tabs to render'
		},
		'full': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Whether the Tabs bar spans the full width of it\'s container'
		},
		'bordered': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'DEPRECATED'
		},
		'noBorder': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Whether the Tabs bar excludes a bottom or right border'
		},
		'isVertical': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Whether the Tabs bar is layed out on the Y axis'
		}
	}
};
//# sourceMappingURL=Tabs.js.map