'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.HIDDEN_TOAST_CLASS = exports.ERROR_TOAST_CLASS = exports.SUCCESS_TOAST_CLASS = exports.TOAST_DISMISS_BTN_CLASS = exports.TOAST_ACTION_CLASS = exports.TOAST_CLASS = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Button = require('../forms/Button');

var _Button2 = _interopRequireDefault(_Button);

var _Flex = require('../layout/Flex');

var _Flex2 = _interopRequireDefault(_Flex);

var _FlexItem = require('../layout/FlexItem');

var _FlexItem2 = _interopRequireDefault(_FlexItem);

var _Icon = require('../media/Icon');

var _Icon2 = _interopRequireDefault(_Icon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TOAST_CLASS = exports.TOAST_CLASS = 'toast';
var TOAST_ACTION_CLASS = exports.TOAST_ACTION_CLASS = TOAST_CLASS + '-action';
var TOAST_DISMISS_BTN_CLASS = exports.TOAST_DISMISS_BTN_CLASS = TOAST_CLASS + '-dismissBtn';
var SUCCESS_TOAST_CLASS = exports.SUCCESS_TOAST_CLASS = TOAST_CLASS + '--success';
var ERROR_TOAST_CLASS = exports.ERROR_TOAST_CLASS = TOAST_CLASS + '--error';
var HIDDEN_TOAST_CLASS = exports.HIDDEN_TOAST_CLASS = TOAST_CLASS + '--hide';

/**
 * @module Toast
 */

var Toast = function (_React$PureComponent) {
	_inherits(Toast, _React$PureComponent);

	function Toast(props) {
		_classCallCheck(this, Toast);

		var _this = _possibleConstructorReturn(this, (Toast.__proto__ || Object.getPrototypeOf(Toast)).call(this, props));

		_this.handleDismiss = _this.handleDismiss.bind(_this);
		return _this;
	}

	/**
  * @returns undefined
  *
  * tells `Toaster` component which toast was clicked to be dismissed
  */


	_createClass(Toast, [{
		key: 'handleDismiss',
		value: function handleDismiss() {
			this.props.dismissToast && this.props.dismissToast(this);
			this.props.onDismiss && this.props.onDismiss(this);
		}
	}, {
		key: 'render',
		value: function render() {
			var _cx;

			var _props = this.props,
			    children = _props.children,
			    className = _props.className,
			    action = _props.action,
			    actionLabel = _props.actionLabel,
			    dismissable = _props.dismissable,
			    dismissToast = _props.dismissToast,
			    autodismiss = _props.autodismiss,
			    onDismiss = _props.onDismiss,
			    success = _props.success,
			    error = _props.error,
			    other = _objectWithoutProperties(_props, ['children', 'className', 'action', 'actionLabel', 'dismissable', 'dismissToast', 'autodismiss', 'onDismiss', 'success', 'error']);

			var classNames = (0, _classnames2.default)(TOAST_CLASS, 'inverted', (_cx = {}, _defineProperty(_cx, SUCCESS_TOAST_CLASS, success), _defineProperty(_cx, ERROR_TOAST_CLASS, error), _cx), className);

			return _react2.default.createElement(
				'span',
				_extends({
					className: classNames,
					role: error ? 'alert' : 'log',
					'aria-relevant': 'all',
					'aria-atomic': 'true'
				}, other),
				_react2.default.createElement(
					_Flex2.default,
					{ align: 'center' },
					_react2.default.createElement(
						_FlexItem2.default,
						null,
						children
					),
					action && _react2.default.createElement(
						_FlexItem2.default,
						{ shrink: true },
						_react2.default.createElement(
							_Button2.default,
							{ reset: true, onClick: action, className: TOAST_ACTION_CLASS },
							actionLabel
						)
					),
					dismissable && _react2.default.createElement(
						_FlexItem2.default,
						{
							shrink: true,
							className: TOAST_DISMISS_BTN_CLASS,
							onClick: this.handleDismiss
						},
						_react2.default.createElement(
							_Button2.default,
							{ reset: true },
							_react2.default.createElement(_Icon2.default, { shape: 'cross', size: 's' })
						)
					)
				)
			);
		}
	}]);

	return Toast;
}(_react2.default.PureComponent);

Toast.propTypes = {
	/** Function that gets called when clicking the action in a toast */
	action: _propTypes2.default.func,

	/** Element that can be clicked to call the function passed to the `action` prop */
	actionLabel: _propTypes2.default.node,

	/** Whether the Toast can be dismissed */
	dismissable: _propTypes2.default.bool,

	/** Whether the Toast is automatically dismissed after a period of time */
	autodismiss: _propTypes2.default.bool,

	/** Callback that happens when the Toast is dismissed */
	onDismiss: _propTypes2.default.func
};

Toast.defaultProps = {
	autodismiss: true,
	dismissable: true
};

exports.default = Toast;
Toast.__docgenInfo = {
	'description': '@module Toast',
	'methods': [{
		'name': 'handleDismiss',
		'docblock': '@returns undefined\n\ntells `Toaster` component which toast was clicked to be dismissed',
		'modifiers': [],
		'params': [],
		'returns': {
			'description': 'undefined\n\ntells `Toaster` component which toast was clicked to be dismissed',
			'type': null
		},
		'description': null
	}],
	'displayName': 'Toast',
	'props': {
		'autodismiss': {
			'defaultValue': {
				'value': 'true',
				'computed': false
			},
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Whether the Toast is automatically dismissed after a period of time'
		},
		'dismissable': {
			'defaultValue': {
				'value': 'true',
				'computed': false
			},
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Whether the Toast can be dismissed'
		},
		'action': {
			'type': {
				'name': 'func'
			},
			'required': false,
			'description': 'Function that gets called when clicking the action in a toast'
		},
		'actionLabel': {
			'type': {
				'name': 'node'
			},
			'required': false,
			'description': 'Element that can be clicked to call the function passed to the `action` prop'
		},
		'onDismiss': {
			'type': {
				'name': 'func'
			},
			'required': false,
			'description': 'Callback that happens when the Toast is dismissed'
		}
	}
};
//# sourceMappingURL=Toast.js.map