'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.DELAY_TIME = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _CSSTransition = require('react-transition-group/CSSTransition');

var _CSSTransition2 = _interopRequireDefault(_CSSTransition);

var _TransitionGroup = require('react-transition-group/TransitionGroup');

var _TransitionGroup2 = _interopRequireDefault(_TransitionGroup);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DELAY_TIME = exports.DELAY_TIME = 3000;
var MARGINAL_DELAY = 1000; // each additional toast will wait this much longer than the previous one
var currentId = 0;

/**
 * @module Toaster
 */

var Toaster = function (_React$PureComponent) {
	_inherits(Toaster, _React$PureComponent);

	function Toaster(props) {
		_classCallCheck(this, Toaster);

		var _this = _possibleConstructorReturn(this, (Toaster.__proto__ || Object.getPrototypeOf(Toaster)).call(this, props));

		_this.timeouts = [];

		_this.cloneToast = _this.cloneToast.bind(_this);
		_this.dismissToast = _this.dismissToast.bind(_this);
		_this.clearTimeouts = _this.clearTimeouts.bind(_this);
		_this.restartTimeouts = _this.restartTimeouts.bind(_this);
		_this.setTimer = _this.setTimer.bind(_this);

		_this.state = {
			toasts: _this.props.toasts.map(_this.cloneToast)
		};
		return _this;
	}

	/**
  * @param {Object} dismissedToast - `Toast` component to remove from state
  * @returns undefined
  */


	_createClass(Toaster, [{
		key: 'dismissToast',
		value: function dismissToast(dismissedToast) {
			var _this2 = this;

			this.setState(function () {
				return {
					toasts: _this2.state.toasts.filter(function (toast) {
						return dismissedToast.props.id !== toast.props.id;
					})
				};
			});
		}

		/**
   * @param {Object} toast - `Toast` component to set a timeout on before passing to `dismissToast`
   * @returns undefined
   *
   * sets timers to delay a toast's dismissal
   */

	}, {
		key: 'setTimer',
		value: function setTimer(toast) {
			var _this3 = this;

			toast.props.autodismiss && this.timeouts.push(setTimeout(function () {
				_this3.dismissToast(toast);
			}, DELAY_TIME + MARGINAL_DELAY * toast.key));
		}

		/**
   * @returns undefined
   *
   * removes timers in order to prevent toasts from being automatically dismissed
   */

	}, {
		key: 'restartTimeouts',
		value: function restartTimeouts() {
			this.state.toasts && this.state.toasts.map(this.setTimer);
		}

		/**
   * @returns undefined
   *
   * removes timers in order to prevent toasts from being automatically dismissed
   */

	}, {
		key: 'clearTimeouts',
		value: function clearTimeouts() {
			this.timeouts.forEach(clearTimeout);
		}
	}, {
		key: 'componentWillUnmount',
		value: function componentWillUnmount() {
			this.clearTimeouts();
		}
	}, {
		key: 'componentDidMount',
		value: function componentDidMount() {
			this.restartTimeouts();
		}
	}, {
		key: 'UNSAFE_componentWillReceiveProps',
		value: function UNSAFE_componentWillReceiveProps(nextProps) {
			var _this4 = this;

			var currentToasts = this.state.toasts;
			var allToasts = currentToasts.concat(nextProps.toasts);

			if (nextProps.toasts !== this.state.toasts) {
				this.setState(function () {
					return { toasts: allToasts.map(_this4.cloneToast) };
				}, function () {
					_this4.state.toasts && _this4.state.toasts.filter(function (t) {
						return t.props.autodismiss;
					}).map(_this4.setTimer);
				});
			}
		}

		/**
   * @param {Object} Toast - `Toast` components to clone
   * @param {number} i - index of the `toast`
   * @returns {Array} `Toast` components with props from `Toaster`
   */

	}, {
		key: 'cloneToast',
		value: function cloneToast(toast, i) {
			currentId++;

			var toastProps = {
				key: i,
				id: toast.props.id || 'toast-' + currentId,
				dismissToast: this.dismissToast
			};
			return _react2.default.cloneElement(toast, toastProps);
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    className = _props.className,
			    toasts = _props.toasts,
			    other = _objectWithoutProperties(_props, ['className', 'toasts']);

			var classNames = (0, _classnames2.default)('toaster', className);

			return _react2.default.createElement(
				'div',
				_extends({
					className: classNames,
					onMouseEnter: this.clearTimeouts,
					onMouseLeave: this.restartTimeouts,
					'aria-live': 'assertive'
				}, other),
				_react2.default.createElement(
					_TransitionGroup2.default,
					null,
					this.state.toasts.map(function (toast, i) {
						return _react2.default.createElement(
							_CSSTransition2.default,
							{
								key: 'csstrns-' + i,
								appear: true,
								timeout: 250,
								classNames: 'slide'
							},
							toast
						);
					})
				)
			);
		}
	}]);

	return Toaster;
}(_react2.default.PureComponent);

Toaster.propTypes = {
	/** Which toasts to be rendered */
	toasts: _propTypes2.default.arrayOf(_propTypes2.default.element).isRequired
};

exports.default = Toaster;
Toaster.__docgenInfo = {
	'description': '@module Toaster',
	'methods': [{
		'name': 'dismissToast',
		'docblock': '@param {Object} dismissedToast - `Toast` component to remove from state\n@returns undefined',
		'modifiers': [],
		'params': [{
			'name': 'dismissedToast',
			'description': '`Toast` component to remove from state',
			'type': {
				'name': 'Object'
			}
		}],
		'returns': {
			'description': 'undefined',
			'type': null
		},
		'description': null
	}, {
		'name': 'setTimer',
		'docblock': '@param {Object} toast - `Toast` component to set a timeout on before passing to `dismissToast`\n@returns undefined\n\nsets timers to delay a toast\'s dismissal',
		'modifiers': [],
		'params': [{
			'name': 'toast',
			'description': '`Toast` component to set a timeout on before passing to `dismissToast`',
			'type': {
				'name': 'Object'
			}
		}],
		'returns': {
			'description': 'undefined\n\nsets timers to delay a toast\'s dismissal',
			'type': null
		},
		'description': null
	}, {
		'name': 'restartTimeouts',
		'docblock': '@returns undefined\n\nremoves timers in order to prevent toasts from being automatically dismissed',
		'modifiers': [],
		'params': [],
		'returns': {
			'description': 'undefined\n\nremoves timers in order to prevent toasts from being automatically dismissed',
			'type': null
		},
		'description': null
	}, {
		'name': 'clearTimeouts',
		'docblock': '@returns undefined\n\nremoves timers in order to prevent toasts from being automatically dismissed',
		'modifiers': [],
		'params': [],
		'returns': {
			'description': 'undefined\n\nremoves timers in order to prevent toasts from being automatically dismissed',
			'type': null
		},
		'description': null
	}, {
		'name': 'UNSAFE_componentWillReceiveProps',
		'docblock': null,
		'modifiers': [],
		'params': [{
			'name': 'nextProps',
			'type': null
		}],
		'returns': null
	}, {
		'name': 'cloneToast',
		'docblock': '@param {Object} Toast - `Toast` components to clone\n@param {number} i - index of the `toast`\n@returns {Array} `Toast` components with props from `Toaster`',
		'modifiers': [],
		'params': [{
			'name': 'toast'
		}, {
			'name': 'i',
			'description': 'index of the `toast`',
			'type': {
				'name': 'number'
			}
		}],
		'returns': {
			'description': '`Toast` components with props from `Toaster`',
			'type': {
				'name': 'Array'
			}
		},
		'description': null
	}],
	'displayName': 'Toaster',
	'props': {
		'toasts': {
			'type': {
				'name': 'arrayOf',
				'value': {
					'name': 'element'
				}
			},
			'required': true,
			'description': 'Which toasts to be rendered'
		}
	}
};
//# sourceMappingURL=Toaster.js.map