'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Button = require('../forms/Button');

var _Button2 = _interopRequireDefault(_Button);

var _Icon = require('../media/Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _FloatingPosition = require('../utils/components/FloatingPosition');

var _FloatingPosition2 = _interopRequireDefault(_FloatingPosition);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * @module Tooltip
 */
var Tooltip = function (_React$PureComponent) {
	_inherits(Tooltip, _React$PureComponent);

	function Tooltip(props) {
		_classCallCheck(this, Tooltip);

		var _this = _possibleConstructorReturn(this, (Tooltip.__proto__ || Object.getPrototypeOf(Tooltip)).call(this, props));

		_this.onBlur = _this.onBlur.bind(_this);
		_this.closeContent = _this.closeContent.bind(_this);
		_this.openContent = _this.openContent.bind(_this);
		_this.handleClose = _this.handleClose.bind(_this);

		_this.state = {
			isActive: props.isActive || false
		};
		return _this;
	}

	_createClass(Tooltip, [{
		key: 'closeContent',
		value: function closeContent(e) {
			if (this.props.manualToggle) {
				if (this.props.onClick) {
					this.props.onClick(e);
					return;
				}
				this.props.onClose && this.props.onClose(e);
				return;
			}

			this.setState(function () {
				return { isActive: false };
			});

			if (this.props.onBlur) {
				this.props.onBlur(e);
			}
			if (this.props.onMouseLeave) {
				this.props.onMouseLeave(e);
			}
		}
	}, {
		key: 'openContent',
		value: function openContent(e) {
			this.setState(function () {
				return { isActive: true };
			});

			if (this.props.onFocus) {
				this.props.onFocus(e);
			}
			if (this.props.onMouseEnter) {
				this.props.onMouseEnter(e);
			}
		}
	}, {
		key: 'onBlur',
		value: function onBlur(e) {
			var _this2 = this;

			if (!this.contentRef) return;

			setTimeout(function () {
				if (!_this2.contentRef.contains(document.activeElement)) {
					_this2.closeContent(e);
				}
			}, 0);
		}
	}, {
		key: 'handleClose',
		value: function handleClose(e) {
			if (e.key === 'Escape') {
				this.props.onClose && this.props.onClose(e);
				this.setState(function () {
					return { isActive: false };
				});
			}
		}
	}, {
		key: 'render',
		value: function render() {
			var _this3 = this;

			var _props = this.props,
			    className = _props.className,
			    trigger = _props.trigger,
			    content = _props.content,
			    align = _props.align,
			    offset = _props.offset,
			    maxWidth = _props.maxWidth,
			    minWidth = _props.minWidth,
			    noPortal = _props.noPortal,
			    id = _props.id,
			    direction = _props.direction,
			    manualToggle = _props.manualToggle,
			    withClose = _props.withClose,
			    other = _objectWithoutProperties(_props, ['className', 'trigger', 'content', 'align', 'offset', 'maxWidth', 'minWidth', 'noPortal', 'id', 'direction', 'manualToggle', 'withClose']);

			var isActive = this.state.isActive;

			// Do not pass along to children

			delete other.isActive;
			delete other.onClick;

			var classNames = {
				dropdown: (0, _classnames2.default)(className, 'popup', {
					'popup--noPortal': noPortal
				})
			};

			var getTrigger = function getTrigger() {
				return _this3.triggerRef;
			};

			var getContent = function getContent() {
				return _this3.contentRef;
			};

			return _react2.default.createElement(
				'div',
				_extends({
					className: classNames.dropdown,
					onMouseLeave: manualToggle ? undefined : this.closeContent
				}, other),
				_react2.default.createElement(
					'div',
					{
						ref: function ref(el) {
							return _this3.triggerRef = el;
						},
						className: 'popup-trigger',
						onFocus: manualToggle ? undefined : this.openContent,
						onBlur: manualToggle ? undefined : this.onBlur,
						onMouseEnter: manualToggle ? undefined : this.openContent,
						'aria-labelledby': isActive ? id : undefined,
						role: isActive ? 'button' : undefined
					},
					trigger
				),
				isActive && _react2.default.createElement(
					_FloatingPosition2.default,
					{
						getTrigger: getTrigger,
						getContent: getContent,
						noPortal: noPortal,
						align: align,
						offset: offset,
						direction: direction,
						handleClose: this.handleClose
					},
					function (_ref) {
						var top = _ref.top,
						    left = _ref.left,
						    align = _ref.align,
						    boundedMaxWidth = _ref.boundedMaxWidth;
						return _react2.default.createElement(
							'div',
							{
								ref: function ref(el) {
									return _this3.contentRef = el;
								},
								className: (0, _classnames2.default)('popup-content tooltip-content', {
									'popup-content--right': align === 'right',
									'popup-content--left': align === 'left',
									'popup-content--center': align === 'center',
									'popup-content--top': direction === 'top',
									'display--none': !isActive,
									'display--block': isActive
								}),
								'aria-hidden': !isActive,
								id: id,
								role: 'tooltip',
								style: {
									left: left,
									top: top,
									minWidth: minWidth,
									maxWidth: maxWidth || boundedMaxWidth
								}
							},
							_react2.default.createElement(
								'div',
								{
									className: (0, _classnames2.default)('popup-bubble tooltip-bubble inverted', {
										'popup-bubble--active': isActive,
										'popup-bubble--right': align === 'right',
										'popup-bubble--left': align === 'left',
										'popup-bubble--center': align === 'center',
										'popup-bubble--top': direction === 'top'
									})
								},
								withClose && _react2.default.createElement(_Button2.default, {
									className: 'tooltip-closeBtn',
									onClick: _this3.closeContent,
									icon: _react2.default.createElement(_Icon2.default, {
										shape: 'cross',
										className: 'text--secondary'
									}),
									reset: true,
									'aria-label': 'Close',
									role: 'button'
								}),
								content
							)
						);
					}
				)
			);
		}
	}], [{
		key: 'getDerivedStateFromProps',
		value: function getDerivedStateFromProps(nextProps, state) {
			if (nextProps.manualToggle && state.isActive !== nextProps.isActive) {
				return { isActive: nextProps.isActive };
			}
			return null;
		}
	}]);

	return Tooltip;
}(_react2.default.PureComponent);

Tooltip.defaultProps = {
	direction: 'bottom',
	minWidth: '0px',
	noPortal: false
};

Tooltip.propTypes = {
	/** The unique identifier for the Tooltip */
	id: _propTypes2.default.string.isRequired,

	/** The element that opens the tooltip when hovered or focused */
	trigger: _propTypes2.default.element.isRequired,

	/** The content that's rendered inside the tooltip */
	content: _propTypes2.default.element,

	/** The horizontal alignment of the tooltip content bubble to the dropdown trigger (defaults to right) */
	align: _propTypes2.default.oneOf(['left', 'right', 'center']),

	/** How many additional pixels to push the tooltip content bubble */
	offset: _propTypes2.default.shape({
		left: _propTypes2.default.number,
		top: _propTypes2.default.number
	}),

	/** Which side of the tooltip trigger the dropdown content bubble renders on */
	direction: _propTypes2.default.oneOf(['top', 'bottom']).isRequired,

	/** Class names to add to the wrapper of the tooltip trigger and content */
	className: _propTypes2.default.string,

	/** Whether the tooltip content is being shown */
	isActive: _propTypes2.default.bool,

	/** Whether the Tooltip is a controlled component, relying on `isActive` prop for toggling */
	manualToggle: _propTypes2.default.bool,

	/** The largest width the tooltip content can be */
	maxWidth: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),

	/** The smallest width the tooltip content can be */
	minWidth: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),

	/** Whether to render the dropdown content directly in the component instead of bulling it out and attaching to the document root */
	noPortal: _propTypes2.default.bool,
	/** Required function to close the dropdown when working with a manually toggled tooltip */
	onClose: function onClose(props, propName, componentName) {
		if (props.manualToggle === true && (props[propName] === undefined || typeof props[propName] !== 'function')) {
			return new Error('The ' + propName + ' function is required when manualToggle is true in this component!');
		}
	}
};

exports.default = Tooltip;
Tooltip.__docgenInfo = {
	'description': '@module Tooltip',
	'methods': [{
		'name': 'getDerivedStateFromProps',
		'docblock': null,
		'modifiers': ['static'],
		'params': [{
			'name': 'nextProps',
			'type': null
		}, {
			'name': 'state',
			'type': null
		}],
		'returns': null
	}, {
		'name': 'closeContent',
		'docblock': null,
		'modifiers': [],
		'params': [{
			'name': 'e',
			'type': null
		}],
		'returns': null
	}, {
		'name': 'openContent',
		'docblock': null,
		'modifiers': [],
		'params': [{
			'name': 'e',
			'type': null
		}],
		'returns': null
	}, {
		'name': 'onBlur',
		'docblock': null,
		'modifiers': [],
		'params': [{
			'name': 'e',
			'type': null
		}],
		'returns': null
	}, {
		'name': 'handleClose',
		'docblock': null,
		'modifiers': [],
		'params': [{
			'name': 'e',
			'type': null
		}],
		'returns': null
	}],
	'displayName': 'Tooltip',
	'props': {
		'direction': {
			'defaultValue': {
				'value': '\'bottom\'',
				'computed': false
			},
			'type': {
				'name': 'enum',
				'value': [{
					'value': '\'top\'',
					'computed': false
				}, {
					'value': '\'bottom\'',
					'computed': false
				}]
			},
			'required': true,
			'description': 'Which side of the tooltip trigger the dropdown content bubble renders on'
		},
		'minWidth': {
			'defaultValue': {
				'value': '\'0px\'',
				'computed': false
			},
			'type': {
				'name': 'union',
				'value': [{
					'name': 'string'
				}, {
					'name': 'number'
				}]
			},
			'required': false,
			'description': 'The smallest width the tooltip content can be'
		},
		'noPortal': {
			'defaultValue': {
				'value': 'false',
				'computed': false
			},
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Whether to render the dropdown content directly in the component instead of bulling it out and attaching to the document root'
		},
		'id': {
			'type': {
				'name': 'string'
			},
			'required': true,
			'description': 'The unique identifier for the Tooltip'
		},
		'trigger': {
			'type': {
				'name': 'element'
			},
			'required': true,
			'description': 'The element that opens the tooltip when hovered or focused'
		},
		'content': {
			'type': {
				'name': 'element'
			},
			'required': false,
			'description': 'The content that\'s rendered inside the tooltip'
		},
		'align': {
			'type': {
				'name': 'enum',
				'value': [{
					'value': '\'left\'',
					'computed': false
				}, {
					'value': '\'right\'',
					'computed': false
				}, {
					'value': '\'center\'',
					'computed': false
				}]
			},
			'required': false,
			'description': 'The horizontal alignment of the tooltip content bubble to the dropdown trigger (defaults to right)'
		},
		'offset': {
			'type': {
				'name': 'shape',
				'value': {
					'left': {
						'name': 'number',
						'required': false
					},
					'top': {
						'name': 'number',
						'required': false
					}
				}
			},
			'required': false,
			'description': 'How many additional pixels to push the tooltip content bubble'
		},
		'className': {
			'type': {
				'name': 'string'
			},
			'required': false,
			'description': 'Class names to add to the wrapper of the tooltip trigger and content'
		},
		'isActive': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Whether the tooltip content is being shown'
		},
		'manualToggle': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Whether the Tooltip is a controlled component, relying on `isActive` prop for toggling'
		},
		'maxWidth': {
			'type': {
				'name': 'union',
				'value': [{
					'name': 'string'
				}, {
					'name': 'number'
				}]
			},
			'required': false,
			'description': 'The largest width the tooltip content can be'
		},
		'onClose': {
			'type': {
				'name': 'custom',
				'raw': '(props, propName, componentName) => {\n    if (\n        props.manualToggle === true &&\n        (props[propName] === undefined || typeof props[propName] !== \'function\')\n    ) {\n        return new Error(\n            `The ${propName} function is required when manualToggle is true in this component!`\n        );\n    }\n}'
			},
			'required': false,
			'description': 'Required function to close the dropdown when working with a manually toggled tooltip'
		}
	}
};
//# sourceMappingURL=Tooltip.js.map