'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.CardComponent = exports.VALID_BREAKPOINTS = exports.CARD_HOVER_PLUS_SHADOW_CLASS = exports.CARD_FLUSH_CLASS = exports.CARD_CLASS = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _withLoading = require('../utils/components/withLoading');

var _withLoading2 = _interopRequireDefault(_withLoading);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CARD_CLASS = exports.CARD_CLASS = 'card';
var CARD_FLUSH_CLASS = exports.CARD_FLUSH_CLASS = CARD_CLASS + '--flush';
var CARD_HOVER_PLUS_SHADOW_CLASS = exports.CARD_HOVER_PLUS_SHADOW_CLASS = CARD_CLASS + '--hasShadowPlusHover';
var VALID_BREAKPOINTS = exports.VALID_BREAKPOINTS = {
	all: 'atAll',
	medium: 'atMedium',
	large: 'atLarge'
};

/**
 * @module CardComponent
 */
var CardComponent = exports.CardComponent = function (_React$PureComponent) {
	_inherits(CardComponent, _React$PureComponent);

	function CardComponent() {
		_classCallCheck(this, CardComponent);

		return _possibleConstructorReturn(this, (CardComponent.__proto__ || Object.getPrototypeOf(CardComponent)).apply(this, arguments));
	}

	_createClass(CardComponent, [{
		key: 'render',
		value: function render() {
			var _cx;

			var _props = this.props,
			    children = _props.children,
			    className = _props.className,
			    initialHeight = _props.initialHeight,
			    hasShadow = _props.hasShadow,
			    hasHoverShadow = _props.hasHoverShadow,
			    flushUntil = _props.flushUntil,
			    _props$loadingProps = _props.loadingProps,
			    loadingProps = _props$loadingProps === undefined ? {} : _props$loadingProps,
			    isLoading = _props.isLoading,
			    other = _objectWithoutProperties(_props, ['children', 'className', 'initialHeight', 'hasShadow', 'hasHoverShadow', 'flushUntil', 'loadingProps', 'isLoading']);

			var flushBreakpoint = flushUntil ? VALID_BREAKPOINTS[flushUntil] : VALID_BREAKPOINTS['all'];

			var classNames = (0, _classnames2.default)(CARD_CLASS, (_cx = {}, _defineProperty(_cx, CARD_CLASS + '--initialHeight', initialHeight), _defineProperty(_cx, flushBreakpoint + '_' + CARD_FLUSH_CLASS + ' ' + CARD_FLUSH_CLASS, flushUntil), _defineProperty(_cx, CARD_CLASS + '--hasShadow', hasShadow), _defineProperty(_cx, CARD_CLASS + '--hasHoverShadow', hasHoverShadow && !hasShadow), _defineProperty(_cx, CARD_HOVER_PLUS_SHADOW_CLASS, hasHoverShadow && hasShadow), _defineProperty(_cx, 'card--isLoading component--isLoading', isLoading), _cx), className);

			return _react2.default.createElement(
				'div',
				_extends({ className: classNames }, other),
				children
			);
		}
	}]);

	return CardComponent;
}(_react2.default.PureComponent);

var Card = (0, _withLoading2.default)(CardComponent);
Card.displayName = 'Card';
exports.default = Card;
CardComponent.__docgenInfo = {
	'description': '@module CardComponent',
	'methods': [],
	'displayName': 'CardComponent',
	'props': {
		'children': {
			'flowType': {
				'name': 'React$Node'
			},
			'required': true,
			'description': 'The child elements of the component'
		},
		'className': {
			'flowType': {
				'name': 'string'
			},
			'required': false,
			'description': ''
		},
		'initialHeight': {
			'flowType': {
				'name': 'boolean'
			},
			'required': false,
			'description': 'Whether the card\'s height is be determined by it\'s content instead of having a minimum height'
		},
		'hasShadow': {
			'flowType': {
				'name': 'boolean'
			},
			'required': false,
			'description': 'The card has a dropshadow'
		},
		'hasHoverShadow': {
			'flowType': {
				'name': 'boolean'
			},
			'required': false,
			'description': 'The card has a dropshadow only on hover'
		},
		'flushUntil': {
			'flowType': {
				'name': 'union',
				'raw': '\'all\' | \'medium\' | \'large\'',
				'elements': [{
					'name': 'literal',
					'value': '\'all\''
				}, {
					'name': 'literal',
					'value': '\'medium\''
				}, {
					'name': 'literal',
					'value': '\'large\''
				}]
			},
			'required': false,
			'description': 'Breakpoint at which the card should be inset from it\'s container instead of being flushed to the left and right edges of it\'s container'
		},
		'isLoading': {
			'flowType': {
				'name': 'boolean'
			},
			'required': false,
			'description': 'Whether the component is in a loading state'
		},
		'loadingProps': {
			'flowType': {
				'name': 'signature',
				'type': 'object',
				'raw': '{\n    color?: string,\n    scrimColor?: string,\n    size?: MediaSizes,\n}',
				'signature': {
					'properties': [{
						'key': 'color',
						'value': {
							'name': 'string',
							'required': false
						}
					}, {
						'key': 'scrimColor',
						'value': {
							'name': 'string',
							'required': false
						}
					}, {
						'key': 'size',
						'value': {
							'name': 'MediaSizes',
							'required': false
						}
					}]
				}
			},
			'required': false,
			'description': 'Props to pass to the `<Loading />` component'
		}
	}
};
//# sourceMappingURL=Card.js.map