'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.ChunkComponent = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _withLoading = require('../utils/components/withLoading');

var _withLoading2 = _interopRequireDefault(_withLoading);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Design System Component: Provides `stripe` styled container for components
 * @module ChunkComponent
 */
var ChunkComponent = exports.ChunkComponent = function (_React$Component) {
	_inherits(ChunkComponent, _React$Component);

	function ChunkComponent() {
		_classCallCheck(this, ChunkComponent);

		return _possibleConstructorReturn(this, (ChunkComponent.__proto__ || Object.getPrototypeOf(ChunkComponent)).apply(this, arguments));
	}

	_createClass(ChunkComponent, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    children = _props.children,
			    className = _props.className,
			    _props$loadingProps = _props.loadingProps,
			    loadingProps = _props$loadingProps === undefined ? {} : _props$loadingProps,
			    isLoading = _props.isLoading,
			    other = _objectWithoutProperties(_props, ['children', 'className', 'loadingProps', 'isLoading']);

			var classNames = (0, _classnames2.default)('chunk', { 'component--isLoading': isLoading }, className);

			return _react2.default.createElement(
				'div',
				_extends({ className: classNames }, other),
				children
			);
		}
	}]);

	return ChunkComponent;
}(_react2.default.Component);

var Chunk = (0, _withLoading2.default)(ChunkComponent);
Chunk.displayName = 'Chunk';
exports.default = Chunk;
ChunkComponent.__docgenInfo = {
	'description': 'Design System Component: Provides `stripe` styled container for components\n@module ChunkComponent',
	'methods': [],
	'displayName': 'ChunkComponent',
	'props': {
		'children': {
			'flowType': {
				'name': 'React$Node'
			},
			'required': true,
			'description': 'The child elements of the component'
		},
		'className': {
			'flowType': {
				'name': 'string'
			},
			'required': false,
			'description': ''
		},
		'isLoading': {
			'flowType': {
				'name': 'boolean'
			},
			'required': false,
			'description': 'Whether the component is in a loading state'
		},
		'loadingProps': {
			'flowType': {
				'name': 'signature',
				'type': 'object',
				'raw': '{\n    color?: string,\n    scrimColor?: string,\n    size?: MediaSizes,\n}',
				'signature': {
					'properties': [{
						'key': 'color',
						'value': {
							'name': 'string',
							'required': false
						}
					}, {
						'key': 'scrimColor',
						'value': {
							'name': 'string',
							'required': false
						}
					}, {
						'key': 'size',
						'value': {
							'name': 'MediaSizes',
							'required': false
						}
					}]
				}
			},
			'required': false,
			'description': 'Props to pass to the `<Loading />` component'
		}
	}
};
//# sourceMappingURL=Chunk.js.map