'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.FlexComponent = exports.FLEX_JUSTIFY_CENTER_CLASS = exports.FLEX_JUSTIFY_RIGHT_CLASS = exports.FLEX_JUSTIFY_LEFT_CLASS = exports.FLEX_ALIGN_CLASS = exports.FLEX_NOGUTTER_CLASS = exports.FLEX_WRAP_CLASS = exports.FLEX_COLUMN_CLASS = exports.FLEX_ROW_CLASS = exports.FLEX_CLASS = exports.DIRECTION_COLUMN = exports.DIRECTION_ROW = exports.VALID_ITEM_JUSTIFY = exports.VALID_SPACE = exports.VALID_BREAKPOINTS = exports.VALID_ALIGNMENTS = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _withLoading = require('../utils/components/withLoading');

var _withLoading2 = _interopRequireDefault(_withLoading);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var VALID_ALIGNMENTS = exports.VALID_ALIGNMENTS = {
	top: 'Top',
	bottom: 'Bottom',
	center: 'Center'
};

var VALID_BREAKPOINTS = exports.VALID_BREAKPOINTS = {
	all: 'atAll',
	medium: 'atMedium',
	large: 'atLarge'
};

var VALID_SPACE = exports.VALID_SPACE = {
	center: 'center',
	spaceAround: 'spaceAround',
	spaceBetween: 'spaceBetween',
	flexEnd: 'flexEnd',
	flexStart: 'flexStart'
};

var VALID_ITEM_JUSTIFY = exports.VALID_ITEM_JUSTIFY = {
	left: 'left',
	right: 'right',
	center: 'center'
};

var DIRECTION_ROW = exports.DIRECTION_ROW = 'row';
var DIRECTION_COLUMN = exports.DIRECTION_COLUMN = 'column';

var FLEX_CLASS = exports.FLEX_CLASS = 'flex';
var FLEX_ROW_CLASS = exports.FLEX_ROW_CLASS = FLEX_CLASS + '--' + DIRECTION_ROW;
var FLEX_COLUMN_CLASS = exports.FLEX_COLUMN_CLASS = FLEX_CLASS + '--' + DIRECTION_COLUMN;
var FLEX_WRAP_CLASS = exports.FLEX_WRAP_CLASS = FLEX_CLASS + '--wrap';
var FLEX_NOGUTTER_CLASS = exports.FLEX_NOGUTTER_CLASS = FLEX_CLASS + '--noGutters';
var FLEX_ALIGN_CLASS = exports.FLEX_ALIGN_CLASS = FLEX_CLASS + '--align';
var FLEX_JUSTIFY_LEFT_CLASS = exports.FLEX_JUSTIFY_LEFT_CLASS = FLEX_CLASS + '--justifyLeft';
var FLEX_JUSTIFY_RIGHT_CLASS = exports.FLEX_JUSTIFY_RIGHT_CLASS = FLEX_CLASS + '--justifyRight';
var FLEX_JUSTIFY_CENTER_CLASS = exports.FLEX_JUSTIFY_CENTER_CLASS = FLEX_CLASS + '--justifyCenter';

/**
 * Design System Component: Provides `Flex` styled container for ideal use with `FlexItem` content
 * @module FlexComponent
 */
var FlexComponent = exports.FlexComponent = function (_React$Component) {
	_inherits(FlexComponent, _React$Component);

	function FlexComponent() {
		_classCallCheck(this, FlexComponent);

		return _possibleConstructorReturn(this, (FlexComponent.__proto__ || Object.getPrototypeOf(FlexComponent)).apply(this, arguments));
	}

	_createClass(FlexComponent, [{
		key: 'render',

		/**
   * @return {React.element} the commend form React element
   */
		value: function render() {
			var _cx;

			var _props = this.props,
			    direction = _props.direction,
			    switchDirection = _props.switchDirection,
			    wrap = _props.wrap,
			    noGutters = _props.noGutters,
			    justify = _props.justify,
			    align = _props.align,
			    rowReverse = _props.rowReverse,
			    columnReverse = _props.columnReverse,
			    children = _props.children,
			    className = _props.className,
			    _props$loadingProps = _props.loadingProps,
			    loadingProps = _props$loadingProps === undefined ? {} : _props$loadingProps,
			    isLoading = _props.isLoading,
			    justifyItems = _props.justifyItems,
			    other = _objectWithoutProperties(_props, ['direction', 'switchDirection', 'wrap', 'noGutters', 'justify', 'align', 'rowReverse', 'columnReverse', 'children', 'className', 'loadingProps', 'isLoading', 'justifyItems']);

			var columnReverseBreakpoint = void 0;
			if (typeof columnReverse === 'string') {
				columnReverseBreakpoint = VALID_BREAKPOINTS[columnReverse];
			} else {
				columnReverseBreakpoint = VALID_BREAKPOINTS['all'];
			}

			var rowReverseBreakpoint = void 0;
			if (typeof rowReverse === 'string') {
				rowReverseBreakpoint = VALID_BREAKPOINTS[rowReverse];
			} else {
				rowReverseBreakpoint = VALID_BREAKPOINTS['all'];
			}

			var isColumn = direction === DIRECTION_COLUMN;
			var classNames = (0, _classnames2.default)(FLEX_CLASS, (_cx = {}, _defineProperty(_cx, FLEX_ROW_CLASS, !isColumn), _defineProperty(_cx, VALID_BREAKPOINTS[switchDirection] + '_' + FLEX_COLUMN_CLASS, !isColumn && switchDirection), _defineProperty(_cx, FLEX_COLUMN_CLASS, isColumn), _defineProperty(_cx, VALID_BREAKPOINTS[switchDirection] + '_' + FLEX_ROW_CLASS, isColumn && switchDirection), _defineProperty(_cx, rowReverseBreakpoint + '_flex--rowReverse', rowReverse), _defineProperty(_cx, columnReverseBreakpoint + '_flex--columnReverse', columnReverse), _defineProperty(_cx, FLEX_WRAP_CLASS, wrap), _defineProperty(_cx, FLEX_NOGUTTER_CLASS, noGutters), _defineProperty(_cx, FLEX_CLASS + '--' + VALID_SPACE[justify], justify), _defineProperty(_cx, '' + FLEX_ALIGN_CLASS + VALID_ALIGNMENTS[align], align), _defineProperty(_cx, FLEX_WRAP_CLASS, wrap), _defineProperty(_cx, 'component--isLoading', isLoading), _defineProperty(_cx, FLEX_JUSTIFY_LEFT_CLASS, justifyItems === VALID_ITEM_JUSTIFY.left), _defineProperty(_cx, FLEX_JUSTIFY_RIGHT_CLASS, justifyItems === VALID_ITEM_JUSTIFY.right), _defineProperty(_cx, FLEX_JUSTIFY_CENTER_CLASS, justifyItems === VALID_ITEM_JUSTIFY.center), _cx), className);

			return _react2.default.createElement(
				'div',
				_extends({ className: classNames }, other),
				children
			);
		}
	}]);

	return FlexComponent;
}(_react2.default.Component);

FlexComponent.defaultProps = {
	direction: DIRECTION_ROW
};


var Flex = (0, _withLoading2.default)(FlexComponent);
Flex.displayName = 'Flex';
exports.default = Flex;
FlexComponent.__docgenInfo = {
	'description': 'Design System Component: Provides `Flex` styled container for ideal use with `FlexItem` content\n@module FlexComponent',
	'methods': [],
	'displayName': 'FlexComponent',
	'props': {
		'direction': {
			'defaultValue': {
				'value': '\'row\'',
				'computed': false
			},
			'flowType': {
				'name': 'union',
				'raw': '\'row\' | \'column\'',
				'elements': [{
					'name': 'literal',
					'value': '\'row\''
				}, {
					'name': 'literal',
					'value': '\'column\''
				}]
			},
			'required': false,
			'description': 'Direction to lay out flex items'
		},
		'className': {
			'flowType': {
				'name': 'string'
			},
			'required': false,
			'description': ''
		},
		'children': {
			'flowType': {
				'name': 'React$Node'
			},
			'required': true,
			'description': 'The child elements of the component'
		},
		'align': {
			'flowType': {
				'name': 'union',
				'raw': '\'top\' | \'bottom\' | \'center\'',
				'elements': [{
					'name': 'literal',
					'value': '\'top\''
				}, {
					'name': 'literal',
					'value': '\'bottom\''
				}, {
					'name': 'literal',
					'value': '\'center\''
				}]
			},
			'required': false,
			'description': 'Alignment of flex items along the axis of the flex direction'
		},
		'justify': {
			'flowType': {
				'name': 'union',
				'raw': '\'center\' | \'spaceAround\' | \'spaceBetween\' | \'flexEnd\' | \'flexStart\'',
				'elements': [{
					'name': 'literal',
					'value': '\'center\''
				}, {
					'name': 'literal',
					'value': '\'spaceAround\''
				}, {
					'name': 'literal',
					'value': '\'spaceBetween\''
				}, {
					'name': 'literal',
					'value': '\'flexEnd\''
				}, {
					'name': 'literal',
					'value': '\'flexStart\''
				}]
			},
			'required': false,
			'description': 'Justification of flex items along the axis of the flex direction'
		},
		'wrap': {
			'flowType': {
				'name': 'boolean'
			},
			'required': false,
			'description': 'Whether flex items should wrap within their flex container'
		},
		'noGutters': {
			'flowType': {
				'name': 'boolean'
			},
			'required': false,
			'description': 'Whether to render flex items without padding between them'
		},
		'switchDirection': {
			'flowType': {
				'name': 'union',
				'raw': '\'all\' | \'medium\' | \'large\'',
				'elements': [{
					'name': 'literal',
					'value': '\'all\''
				}, {
					'name': 'literal',
					'value': '\'medium\''
				}, {
					'name': 'literal',
					'value': '\'large\''
				}]
			},
			'required': false,
			'description': 'The breakpoint at which the direction of the layout switches'
		},
		'rowReverse': {
			'flowType': {
				'name': 'union',
				'raw': 'boolean | \'all\' | \'medium\' | \'large\'',
				'elements': [{
					'name': 'boolean'
				}, {
					'name': 'literal',
					'value': '\'all\''
				}, {
					'name': 'literal',
					'value': '\'medium\''
				}, {
					'name': 'literal',
					'value': '\'large\''
				}]
			},
			'required': false,
			'description': 'When to reverse the order of flex items along the row axis'
		},
		'columnReverse': {
			'flowType': {
				'name': 'union',
				'raw': 'boolean | \'all\' | \'medium\' | \'large\'',
				'elements': [{
					'name': 'boolean'
				}, {
					'name': 'literal',
					'value': '\'all\''
				}, {
					'name': 'literal',
					'value': '\'medium\''
				}, {
					'name': 'literal',
					'value': '\'large\''
				}]
			},
			'required': false,
			'description': 'When to reverse the order of flex items along the column axis'
		},
		'justifyItems': {
			'flowType': {
				'name': 'union',
				'raw': '\'left\' | \'center\' | \'right\'',
				'elements': [{
					'name': 'literal',
					'value': '\'left\''
				}, {
					'name': 'literal',
					'value': '\'center\''
				}, {
					'name': 'literal',
					'value': '\'right\''
				}]
			},
			'required': false,
			'description': ''
		},
		'isLoading': {
			'flowType': {
				'name': 'boolean'
			},
			'required': false,
			'description': 'Whether the component is in a loading state'
		},
		'loadingProps': {
			'flowType': {
				'name': 'signature',
				'type': 'object',
				'raw': '{\n    color?: string,\n    scrimColor?: string,\n    size?: MediaSizes,\n}',
				'signature': {
					'properties': [{
						'key': 'color',
						'value': {
							'name': 'string',
							'required': false
						}
					}, {
						'key': 'scrimColor',
						'value': {
							'name': 'string',
							'required': false
						}
					}, {
						'key': 'size',
						'value': {
							'name': 'MediaSizes',
							'required': false
						}
					}]
				}
			},
			'required': false,
			'description': 'Props to pass to the `<Loading />` component'
		}
	}
};
//# sourceMappingURL=Flex.js.map