'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.FlexItemComponent = exports.FLEX_GROW_FACTORS = exports.FLEX_ITEM_GROW_CLASS = exports.FLEX_ITEM_SHRINK_CLASS = exports.FLEX_ITEM_CLASS = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _withLoading = require('../utils/components/withLoading');

var _withLoading2 = _interopRequireDefault(_withLoading);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FLEX_ITEM_CLASS = exports.FLEX_ITEM_CLASS = 'flex-item';
var FLEX_ITEM_SHRINK_CLASS = exports.FLEX_ITEM_SHRINK_CLASS = 'flex-item--shrink';
var FLEX_ITEM_GROW_CLASS = exports.FLEX_ITEM_GROW_CLASS = 'flex-item--';
var FLEX_GROW_FACTORS = exports.FLEX_GROW_FACTORS = [1, 2, 3, 4, 5, 6, 7];
/**
 * Design System Component: Provides `FlexItem` styled container for use in `Flex` component containers
 * @module FlexItemComponent
 */

var FlexItemComponent = exports.FlexItemComponent = function (_React$Component) {
	_inherits(FlexItemComponent, _React$Component);

	function FlexItemComponent() {
		_classCallCheck(this, FlexItemComponent);

		return _possibleConstructorReturn(this, (FlexItemComponent.__proto__ || Object.getPrototypeOf(FlexItemComponent)).apply(this, arguments));
	}

	_createClass(FlexItemComponent, [{
		key: 'render',

		/**
   * @return {React.element} the commend form React element
   */
		value: function render() {
			var _cx;

			var _props = this.props,
			    children = _props.children,
			    className = _props.className,
			    shrink = _props.shrink,
			    growFactor = _props.growFactor,
			    _props$loadingProps = _props.loadingProps,
			    loadingProps = _props$loadingProps === undefined ? {} : _props$loadingProps,
			    isLoading = _props.isLoading,
			    other = _objectWithoutProperties(_props, ['children', 'className', 'shrink', 'growFactor', 'loadingProps', 'isLoading']);

			var classNames = (0, _classnames2.default)(FLEX_ITEM_CLASS, (_cx = {}, _defineProperty(_cx, FLEX_ITEM_SHRINK_CLASS, shrink), _defineProperty(_cx, '' + FLEX_ITEM_GROW_CLASS + growFactor, growFactor), _defineProperty(_cx, 'component--isLoading', isLoading), _cx), className);

			return _react2.default.createElement(
				'div',
				_extends({ className: classNames }, other),
				children
			);
		}
	}]);

	return FlexItemComponent;
}(_react2.default.Component);

var FlexItem = (0, _withLoading2.default)(FlexItemComponent);
FlexItem.displayName = 'FlexItem';
exports.default = FlexItem;
FlexItemComponent.__docgenInfo = {
	'description': '',
	'methods': [],
	'displayName': 'FlexItemComponent',
	'props': {
		'shrink': {
			'flowType': {
				'name': 'boolean'
			},
			'required': false,
			'description': 'Whether the flex item should shrink to the size of it\'s content'
		},
		'growFactor': {
			'flowType': {
				'name': 'union',
				'raw': '1 | 2 | 3 | 4 | 5 | 6 | 7',
				'elements': [{
					'name': 'literal',
					'value': '1'
				}, {
					'name': 'literal',
					'value': '2'
				}, {
					'name': 'literal',
					'value': '3'
				}, {
					'name': 'literal',
					'value': '4'
				}, {
					'name': 'literal',
					'value': '5'
				}, {
					'name': 'literal',
					'value': '6'
				}, {
					'name': 'literal',
					'value': '7'
				}]
			},
			'required': false,
			'description': 'Proportion of flex item\'s size compared to sibling flex items'
		},
		'isLoading': {
			'flowType': {
				'name': 'boolean'
			},
			'required': false,
			'description': 'Whether the component is in a loading state'
		},
		'loadingProps': {
			'flowType': {
				'name': 'signature',
				'type': 'object',
				'raw': '{\n    color?: string,\n    scrimColor?: string,\n    size?: MediaSizes,\n}',
				'signature': {
					'properties': [{
						'key': 'color',
						'value': {
							'name': 'string',
							'required': false
						}
					}, {
						'key': 'scrimColor',
						'value': {
							'name': 'string',
							'required': false
						}
					}, {
						'key': 'size',
						'value': {
							'name': 'MediaSizes',
							'required': false
						}
					}]
				}
			},
			'required': false,
			'description': 'Props to pass to the `<Loading />` component'
		},
		'children': {
			'flowType': {
				'name': 'React$Node'
			},
			'required': true,
			'description': 'The child elements of the component'
		},
		'className': {
			'flowType': {
				'name': 'string'
			},
			'required': false,
			'description': 'Nearest DOM element\'s class name'
		}
	}
};
//# sourceMappingURL=FlexItem.js.map