'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.GridListComponent = exports.GRID_AUTOHEIGHT_CLASS = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _withLoading = require('../utils/components/withLoading');

var _withLoading2 = _interopRequireDefault(_withLoading);

var _ConditionalWrap = require('../utils/components/ConditionalWrap');

var _ConditionalWrap2 = _interopRequireDefault(_ConditionalWrap);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var GRID_AUTOHEIGHT_CLASS = exports.GRID_AUTOHEIGHT_CLASS = 'gridList--autoHeight';

/**
 * @module GridListComponent
 */
var GridListComponent = exports.GridListComponent = function (_React$Component) {
	_inherits(GridListComponent, _React$Component);

	function GridListComponent() {
		_classCallCheck(this, GridListComponent);

		return _possibleConstructorReturn(this, (GridListComponent.__proto__ || Object.getPrototypeOf(GridListComponent)).apply(this, arguments));
	}

	_createClass(GridListComponent, [{
		key: 'render',
		value: function render() {
			var _cx,
			    _cx2,
			    _cx3,
			    _this2 = this;

			var _props = this.props,
			    className = _props.className,
			    columns = _props.columns,
			    items = _props.items,
			    autoHeight = _props.autoHeight,
			    autoHeightWithWrap = _props.autoHeightWithWrap,
			    _props$itemClassNames = _props.itemClassNames,
			    itemClassNames = _props$itemClassNames === undefined ? '' : _props$itemClassNames,
			    _props$loadingProps = _props.loadingProps,
			    loadingProps = _props$loadingProps === undefined ? {} : _props$loadingProps,
			    isLoading = _props.isLoading,
			    other = _objectWithoutProperties(_props, ['className', 'columns', 'items', 'autoHeight', 'autoHeightWithWrap', 'itemClassNames', 'loadingProps', 'isLoading']);

			var classNames = (0, _classnames2.default)('gridList', (_cx = {}, _defineProperty(_cx, 'gridList--has' + columns.default, !!columns.default), _defineProperty(_cx, 'atMedium_gridList--has' + (columns.medium || columns.default), !!columns.medium), _defineProperty(_cx, 'atLarge_gridList--has' + (columns.large || columns.default), !!columns.large), _cx), className);

			var autoHeightClassNames = (0, _classnames2.default)('flex gridList', GRID_AUTOHEIGHT_CLASS, (_cx2 = {
				'flex--wrap': autoHeightWithWrap
			}, _defineProperty(_cx2, GRID_AUTOHEIGHT_CLASS + '--has' + columns.default, !!columns.default), _defineProperty(_cx2, 'atMedium_' + GRID_AUTOHEIGHT_CLASS + '--has' + (columns.medium || 0), !!columns.medium), _defineProperty(_cx2, 'atLarge_' + GRID_AUTOHEIGHT_CLASS + '--has' + (columns.large || 0), !!columns.large), _cx2), className);

			var listItemClassNames = (0, _classnames2.default)('gridList-item', (_cx3 = {}, _defineProperty(_cx3, 'flex-item', autoHeight), _defineProperty(_cx3, itemClassNames, Boolean(itemClassNames)), _cx3));

			return _react2.default.createElement(
				_ConditionalWrap2.default,
				{
					condition: this.props.children && isLoading,
					wrap: function wrap(children) {
						return _react2.default.createElement(
							'div',
							{ className: 'component--isLoading' },
							[children, _this2.props.children]
						);
					}
				},
				_react2.default.createElement(
					'ul',
					_extends({
						className: autoHeight || autoHeightWithWrap ? autoHeightClassNames : classNames
					}, other),
					items.map(function (item, key) {
						return _react2.default.createElement(
							'li',
							{ key: key, className: listItemClassNames },
							_react2.default.createElement(
								'div',
								{ className: 'gridList-itemInner' },
								item
							)
						);
					})
				)
			);
		}
	}]);

	return GridListComponent;
}(_react2.default.Component);

var GridList = (0, _withLoading2.default)(GridListComponent);
GridList.displayName = 'GridList';
exports.default = GridList;
GridListComponent.__docgenInfo = {
	'description': '@module GridListComponent',
	'methods': [],
	'displayName': 'GridListComponent',
	'props': {
		'autoHeight': {
			'flowType': {
				'name': 'boolean'
			},
			'required': false,
			'description': 'Whether the height of the items in the GridList should fill the available height'
		},
		'autoHeightWithWrap': {
			'flowType': {
				'name': 'boolean'
			},
			'required': false,
			'description': 'Whether autoheight GridList items should wrap lines'
		},
		'columns': {
			'flowType': {
				'name': 'signature',
				'type': 'object',
				'raw': '{\n    default: number,\n    medium?: number,\n    large?: number,\n}',
				'signature': {
					'properties': [{
						'key': 'default',
						'value': {
							'name': 'number',
							'required': true
						}
					}, {
						'key': 'medium',
						'value': {
							'name': 'number',
							'required': false
						}
					}, {
						'key': 'large',
						'value': {
							'name': 'number',
							'required': false
						}
					}]
				}
			},
			'required': true,
			'description': 'Columns in the grid at each breakpoint'
		},
		'items': {
			'flowType': {
				'name': 'Array',
				'elements': [{
					'name': 'React$Element',
					'elements': [{
						'name': 'unknown'
					}],
					'raw': 'React$Element<*>'
				}],
				'raw': 'Array<React$Element<*>>'
			},
			'required': true,
			'description': 'Items to render into a grid'
		},
		'itemClassNames': {
			'flowType': {
				'name': 'string'
			},
			'required': false,
			'description': 'Class names to add to each item\'s wrapper'
		},
		'isLoading': {
			'flowType': {
				'name': 'boolean'
			},
			'required': false,
			'description': 'Whether the component is in a loading state'
		},
		'loadingProps': {
			'flowType': {
				'name': 'signature',
				'type': 'object',
				'raw': '{\n    color?: string,\n    scrimColor?: string,\n    size?: MediaSizes,\n}',
				'signature': {
					'properties': [{
						'key': 'color',
						'value': {
							'name': 'string',
							'required': false
						}
					}, {
						'key': 'scrimColor',
						'value': {
							'name': 'string',
							'required': false
						}
					}, {
						'key': 'size',
						'value': {
							'name': 'MediaSizes',
							'required': false
						}
					}]
				}
			},
			'required': false,
			'description': 'Props to pass to the `<Loading />` component'
		},
		'className': {
			'flowType': {
				'name': 'string'
			},
			'required': false,
			'description': 'Nearest DOM element\'s class name'
		},
		'children': {
			'flowType': {
				'name': 'React$Node'
			},
			'required': true,
			'description': 'The child elements of the component'
		}
	}
};
//# sourceMappingURL=GridList.js.map