'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.InlineBlockListComponent = exports.INLINEBLOCKLIST_SEPERATED_CLASS = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _withLoading = require('../utils/components/withLoading');

var _withLoading2 = _interopRequireDefault(_withLoading);

var _ConditionalWrap = require('../utils/components/ConditionalWrap');

var _ConditionalWrap2 = _interopRequireDefault(_ConditionalWrap);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var INLINEBLOCKLIST_SEPERATED_CLASS = exports.INLINEBLOCKLIST_SEPERATED_CLASS = 'inlineblockList--separated';

/**
 * @module InlineBlockListComponent
 */
var InlineBlockListComponent = exports.InlineBlockListComponent = function (_React$Component) {
	_inherits(InlineBlockListComponent, _React$Component);

	function InlineBlockListComponent() {
		_classCallCheck(this, InlineBlockListComponent);

		return _possibleConstructorReturn(this, (InlineBlockListComponent.__proto__ || Object.getPrototypeOf(InlineBlockListComponent)).apply(this, arguments));
	}

	_createClass(InlineBlockListComponent, [{
		key: 'render',
		value: function render() {
			var _this2 = this;

			var _props = this.props,
			    className = _props.className,
			    items = _props.items,
			    separator = _props.separator,
			    _props$loadingProps = _props.loadingProps,
			    loadingProps = _props$loadingProps === undefined ? {} : _props$loadingProps,
			    isLoading = _props.isLoading,
			    verticalAlign = _props.verticalAlign,
			    other = _objectWithoutProperties(_props, ['className', 'items', 'separator', 'loadingProps', 'isLoading', 'verticalAlign']);

			var classNames = (0, _classnames2.default)('inlineblockList', _defineProperty({}, INLINEBLOCKLIST_SEPERATED_CLASS, separator), className);

			var itemProps = {
				'data-separator': separator,
				style: { verticalAlign: verticalAlign }
			};

			return _react2.default.createElement(
				_ConditionalWrap2.default,
				{
					condition: this.props.children && isLoading,
					wrap: function wrap(children) {
						return _react2.default.createElement(
							'div',
							{ className: 'component--isLoading' },
							[children, _this2.props.children]
						);
					}
				},
				_react2.default.createElement(
					'ul',
					_extends({ className: classNames }, other),
					items.map(function (item, key) {
						return _react2.default.createElement(
							'li',
							_extends({ key: key }, itemProps),
							item
						);
					})
				)
			);
		}
	}]);

	return InlineBlockListComponent;
}(_react2.default.Component);

var InlineBlockList = (0, _withLoading2.default)(InlineBlockListComponent);
InlineBlockList.displayName = 'InlineBlockList';
exports.default = InlineBlockList;
InlineBlockListComponent.__docgenInfo = {
	'description': '@module InlineBlockListComponent',
	'methods': [],
	'displayName': 'InlineBlockListComponent',
	'props': {
		'items': {
			'flowType': {
				'name': 'Array',
				'elements': [{
					'name': 'union',
					'raw': 'React$Element<*> | string',
					'elements': [{
						'name': 'React$Element',
						'elements': [{
							'name': 'unknown'
						}],
						'raw': 'React$Element<*>'
					}, {
						'name': 'string'
					}]
				}],
				'raw': 'Array<React$Element<*> | string>'
			},
			'required': true,
			'description': 'Items to render into an inline list'
		},
		'separator': {
			'flowType': {
				'name': 'string'
			},
			'required': false,
			'description': 'The glyph that separates each item'
		},
		'isLoading': {
			'flowType': {
				'name': 'boolean'
			},
			'required': false,
			'description': 'Whether the component is in a loading state'
		},
		'loadingProps': {
			'flowType': {
				'name': 'signature',
				'type': 'object',
				'raw': '{\n    color?: string,\n    scrimColor?: string,\n    size?: MediaSizes,\n}',
				'signature': {
					'properties': [{
						'key': 'color',
						'value': {
							'name': 'string',
							'required': false
						}
					}, {
						'key': 'scrimColor',
						'value': {
							'name': 'string',
							'required': false
						}
					}, {
						'key': 'size',
						'value': {
							'name': 'MediaSizes',
							'required': false
						}
					}]
				}
			},
			'required': false,
			'description': 'Props to pass to the `<Loading />` component'
		},
		'className': {
			'flowType': {
				'name': 'string'
			},
			'required': false,
			'description': 'Nearest DOM element\'s class name'
		},
		'verticalAlign': {
			'flowType': {
				'name': 'union',
				'raw': '\'top\' | \'middle\' | \'bottom\'',
				'elements': [{
					'name': 'literal',
					'value': '\'top\''
				}, {
					'name': 'literal',
					'value': '\'middle\''
				}, {
					'name': 'literal',
					'value': '\'bottom\''
				}]
			},
			'required': true,
			'description': 'The vertical alignment of all items within their container'
		},
		'children': {
			'flowType': {
				'name': 'React$Node'
			},
			'required': true,
			'description': 'The child elements of the component'
		}
	}
};
//# sourceMappingURL=InlineBlockList.js.map