'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.SectionComponent = exports.VALID_BREAKPOINTS = exports.SECTION_FLUSH_CLASS = exports.SECTION_NOSEPARATOR_CLASS = exports.SECTION_HASSEPARATOR_CLASS = exports.SECTION_CLASS = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _withLoading = require('../utils/components/withLoading');

var _withLoading2 = _interopRequireDefault(_withLoading);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SECTION_CLASS = exports.SECTION_CLASS = 'section';
var SECTION_HASSEPARATOR_CLASS = exports.SECTION_HASSEPARATOR_CLASS = 'section--hasSeparator';
var SECTION_NOSEPARATOR_CLASS = exports.SECTION_NOSEPARATOR_CLASS = 'section--noSeparator';
var SECTION_FLUSH_CLASS = exports.SECTION_FLUSH_CLASS = 'section--flush';
var VALID_BREAKPOINTS = exports.VALID_BREAKPOINTS = {
	all: 'atAll',
	medium: 'atMedium',
	large: 'atLarge'
};

/**
 * Design System Component: Provides `section` container for components
 * @module SectionComponent
 */
var SectionComponent = exports.SectionComponent = function (_React$Component) {
	_inherits(SectionComponent, _React$Component);

	function SectionComponent() {
		_classCallCheck(this, SectionComponent);

		return _possibleConstructorReturn(this, (SectionComponent.__proto__ || Object.getPrototypeOf(SectionComponent)).apply(this, arguments));
	}

	_createClass(SectionComponent, [{
		key: 'render',
		value: function render() {
			var _cx;

			var _props = this.props,
			    children = _props.children,
			    className = _props.className,
			    noSeparator = _props.noSeparator,
			    hasSeparatorUntil = _props.hasSeparatorUntil,
			    hasSeparator = _props.hasSeparator,
			    flushUntil = _props.flushUntil,
			    _props$loadingProps = _props.loadingProps,
			    loadingProps = _props$loadingProps === undefined ? {} : _props$loadingProps,
			    isLoading = _props.isLoading,
			    other = _objectWithoutProperties(_props, ['children', 'className', 'noSeparator', 'hasSeparatorUntil', 'hasSeparator', 'flushUntil', 'loadingProps', 'isLoading']);

			var hasSeparatorUntilBreakpoint = '';
			if (typeof hasSeparatorUntil === 'string') {
				hasSeparatorUntilBreakpoint = VALID_BREAKPOINTS[hasSeparatorUntil] || VALID_BREAKPOINTS['all'];
			}

			var flushBreakpoint = '';

			if (flushUntil) {
				flushBreakpoint = VALID_BREAKPOINTS[flushUntil] || VALID_BREAKPOINTS['all'];
			}

			var classNames = (0, _classnames2.default)(SECTION_CLASS, (_cx = {}, _defineProperty(_cx, flushBreakpoint + '_' + SECTION_FLUSH_CLASS + ' ' + SECTION_FLUSH_CLASS, flushUntil && flushBreakpoint), _defineProperty(_cx, hasSeparatorUntilBreakpoint + '_' + SECTION_HASSEPARATOR_CLASS + ' ' + SECTION_HASSEPARATOR_CLASS, hasSeparatorUntil), _defineProperty(_cx, SECTION_HASSEPARATOR_CLASS, hasSeparator), _defineProperty(_cx, 'component--isLoading', isLoading), _cx), className);

			return _react2.default.createElement(
				'section',
				_extends({ className: classNames }, other),
				children
			);
		}
	}]);

	return SectionComponent;
}(_react2.default.Component);

var Section = (0, _withLoading2.default)(SectionComponent);
Section.displayName = 'Section';
exports.default = Section;
SectionComponent.__docgenInfo = {
	'description': 'Design System Component: Provides `section` container for components\n@module SectionComponent',
	'methods': [],
	'displayName': 'SectionComponent',
	'props': {
		'hasSeparatorUntil': {
			'flowType': {
				'name': 'union',
				'raw': 'boolean | \'all\' | \'medium\' | \'large\'',
				'elements': [{
					'name': 'boolean'
				}, {
					'name': 'literal',
					'value': '\'all\''
				}, {
					'name': 'literal',
					'value': '\'medium\''
				}, {
					'name': 'literal',
					'value': '\'large\''
				}]
			},
			'required': false,
			'description': 'When to remove the extra bottom padding and bottom border'
		},
		'noSeparator': {
			'flowType': {
				'name': 'union',
				'raw': 'boolean | \'all\' | \'medium\' | \'large\'',
				'elements': [{
					'name': 'boolean'
				}, {
					'name': 'literal',
					'value': '\'all\''
				}, {
					'name': 'literal',
					'value': '\'medium\''
				}, {
					'name': 'literal',
					'value': '\'large\''
				}]
			},
			'required': false,
			'description': 'Whether to remove the bottom padding and bottom border'
		},
		'flushUntil': {
			'flowType': {
				'name': 'union',
				'raw': '\'all\' | \'medium\' | \'large\'',
				'elements': [{
					'name': 'literal',
					'value': '\'all\''
				}, {
					'name': 'literal',
					'value': '\'medium\''
				}, {
					'name': 'literal',
					'value': '\'large\''
				}]
			},
			'required': false,
			'description': 'When to remove the left and right margins'
		},
		'isLoading': {
			'flowType': {
				'name': 'boolean'
			},
			'required': false,
			'description': 'Whether the component is in a loading state'
		},
		'loadingProps': {
			'flowType': {
				'name': 'signature',
				'type': 'object',
				'raw': '{\n    color?: string,\n    scrimColor?: string,\n    size?: MediaSizes,\n}',
				'signature': {
					'properties': [{
						'key': 'color',
						'value': {
							'name': 'string',
							'required': false
						}
					}, {
						'key': 'scrimColor',
						'value': {
							'name': 'string',
							'required': false
						}
					}, {
						'key': 'size',
						'value': {
							'name': 'MediaSizes',
							'required': false
						}
					}]
				}
			},
			'required': false,
			'description': 'Props to pass to the `<Loading />` component'
		},
		'className': {
			'flowType': {
				'name': 'string'
			},
			'required': false,
			'description': 'Nearest DOM element\'s class name'
		},
		'children': {
			'flowType': {
				'name': 'React$Node'
			},
			'required': true,
			'description': 'The child elements of the component'
		},
		'hasSeparator': {
			'flowType': {
				'name': 'boolean'
			},
			'required': false,
			'description': 'Whether section has a separator or not'
		}
	}
};
//# sourceMappingURL=Section.js.map