'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.StripeComponent = exports.STRIPE_NOSCRIM_CLASS = exports.STRIPE_HERO_CLASS = exports.STRIPE_INVERTED_CLASS = exports.STRIPE_COLLECTION_CLASS = exports.STRIPE_CLASS = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _withLoading = require('../utils/components/withLoading');

var _withLoading2 = _interopRequireDefault(_withLoading);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var STRIPE_CLASS = exports.STRIPE_CLASS = 'stripe';
var STRIPE_COLLECTION_CLASS = exports.STRIPE_COLLECTION_CLASS = 'stripe--collection';
var STRIPE_INVERTED_CLASS = exports.STRIPE_INVERTED_CLASS = 'stripe--inverted';
var STRIPE_HERO_CLASS = exports.STRIPE_HERO_CLASS = 'stripe--withBGImg';
var STRIPE_NOSCRIM_CLASS = exports.STRIPE_NOSCRIM_CLASS = 'stripe--noScrim';

/**
 * Design System Component: Provides `stripe` styled container for components
 * @module StripeComponent
 */
var StripeComponent = exports.StripeComponent = function (_React$Component) {
	_inherits(StripeComponent, _React$Component);

	function StripeComponent() {
		_classCallCheck(this, StripeComponent);

		return _possibleConstructorReturn(this, (StripeComponent.__proto__ || Object.getPrototypeOf(StripeComponent)).apply(this, arguments));
	}

	_createClass(StripeComponent, [{
		key: 'render',
		value: function render() {
			var _cx;

			var _props = this.props,
			    children = _props.children,
			    className = _props.className,
			    style = _props.style,
			    backgroundImage = _props.backgroundImage,
			    collection = _props.collection,
			    inverted = _props.inverted,
			    hideScrim = _props.hideScrim,
			    _props$loadingProps = _props.loadingProps,
			    loadingProps = _props$loadingProps === undefined ? {} : _props$loadingProps,
			    isLoading = _props.isLoading,
			    other = _objectWithoutProperties(_props, ['children', 'className', 'style', 'backgroundImage', 'collection', 'inverted', 'hideScrim', 'loadingProps', 'isLoading']);

			var classNames = (0, _classnames2.default)(STRIPE_CLASS, (_cx = {}, _defineProperty(_cx, STRIPE_COLLECTION_CLASS, collection), _defineProperty(_cx, STRIPE_INVERTED_CLASS + ' inverted', inverted), _defineProperty(_cx, '' + STRIPE_HERO_CLASS, backgroundImage), _defineProperty(_cx, STRIPE_NOSCRIM_CLASS, hideScrim), _defineProperty(_cx, 'component--isLoading', isLoading), _cx), className);

			var styles = backgroundImage ? _extends({}, style, {
				backgroundImage: 'url(' + backgroundImage + ')'
			}) : style;

			return _react2.default.createElement(
				'div',
				_extends({ className: classNames, style: styles }, other),
				backgroundImage && !hideScrim ? _react2.default.createElement(
					'div',
					{ className: 'stripe-aboveScrim' },
					children
				) : children
			);
		}
	}]);

	return StripeComponent;
}(_react2.default.Component);

var Stripe = (0, _withLoading2.default)(StripeComponent);
Stripe.displayName = 'Stripe';
exports.default = Stripe;
StripeComponent.__docgenInfo = {
	'description': 'Design System Component: Provides `stripe` styled container for components\n@module StripeComponent',
	'methods': [],
	'displayName': 'StripeComponent',
	'props': {
		'backgroundImage': {
			'flowType': {
				'name': 'string'
			},
			'required': false,
			'description': 'The url to an image to use as the background image of the component'
		},
		'collection': {
			'flowType': {
				'name': 'boolean'
			},
			'required': false,
			'description': 'Whether to make the component a collection Stripe or not. (off white background)'
		},
		'inverted': {
			'flowType': {
				'name': 'boolean'
			},
			'required': false,
			'description': 'Whether to invert the colors of the Stripe component or not'
		},
		'hero': {
			'flowType': {
				'name': 'boolean'
			},
			'required': false,
			'description': 'Whether to make the component a Hero Stripe or not (wrapped with Bounds)'
		},
		'hideScrim': {
			'flowType': {
				'name': 'boolean'
			},
			'required': false,
			'description': 'Whether to shade the stripe\'s hero area with a text protection scrim'
		},
		'isLoading': {
			'flowType': {
				'name': 'boolean'
			},
			'required': false,
			'description': 'Whether the component is in a loading state'
		},
		'loadingProps': {
			'flowType': {
				'name': 'signature',
				'type': 'object',
				'raw': '{\n    color?: string,\n    scrimColor?: string,\n    size?: MediaSizes,\n}',
				'signature': {
					'properties': [{
						'key': 'color',
						'value': {
							'name': 'string',
							'required': false
						}
					}, {
						'key': 'scrimColor',
						'value': {
							'name': 'string',
							'required': false
						}
					}, {
						'key': 'size',
						'value': {
							'name': 'MediaSizes',
							'required': false
						}
					}]
				}
			},
			'required': false,
			'description': 'Props to pass to the `<Loading />` component'
		},
		'className': {
			'flowType': {
				'name': 'string'
			},
			'required': false,
			'description': 'Nearest DOM element\'s class name'
		},
		'children': {
			'flowType': {
				'name': 'React$Node'
			},
			'required': true,
			'description': 'The component\'s rendered children'
		},
		'style': {
			'flowType': {
				'name': 'signature',
				'type': 'object',
				'raw': '{ [string]: string }',
				'signature': {
					'properties': [{
						'key': {
							'name': 'string'
						},
						'value': {
							'name': 'string',
							'required': true
						}
					}]
				}
			},
			'required': true,
			'description': 'custom style properties'
		}
	}
};
//# sourceMappingURL=Stripe.js.map