'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.ANDROID_DOWNLOAD_LINK = exports.IOS_DOWNLOAD_LINK = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Flex = require('../layout/Flex');

var _Flex2 = _interopRequireDefault(_Flex);

var _FlexItem = require('../layout/FlexItem');

var _FlexItem2 = _interopRequireDefault(_FlexItem);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var IOS_DOWNLOAD_LINK = exports.IOS_DOWNLOAD_LINK = 'https://meetu.ps/2ZhShs';
var ANDROID_DOWNLOAD_LINK = exports.ANDROID_DOWNLOAD_LINK = 'https://meetu.ps/2ZhSyb';
var getAppStoreDownloadPhoto = function getAppStoreDownloadPhoto(platform, language) {
	return (
		// eslint-disable-next-line global-require, import/no-dynamic-require
		require('../../assets/images/app_download/' + platform + '/download_' + language + '.png')
	);
};

/**
 * Renders iOS and Android app badges
 * @class AppBadges
 */
var AppBadges = function AppBadges(_ref) {
	var className = _ref.className,
	    language = _ref.language,
	    getAppStorePhoto = _ref.getAppStorePhoto,
	    isIosPhone = _ref.isIosPhone,
	    isAndroidPhone = _ref.isAndroidPhone,
	    isMobile = _ref.isMobile,
	    other = _objectWithoutProperties(_ref, ['className', 'language', 'getAppStorePhoto', 'isIosPhone', 'isAndroidPhone', 'isMobile']);

	var classNames = (0, _classnames2.default)('getTheApp-downloadLinks', className);

	return _react2.default.createElement(
		_Flex2.default,
		_extends({ className: classNames }, other),
		(isIosPhone || !isMobile) && _react2.default.createElement(
			_FlexItem2.default,
			{ className: 'getTheApp-ios' },
			_react2.default.createElement(
				'a',
				{ href: IOS_DOWNLOAD_LINK, target: '_blank', rel: 'noopener noreferrer' },
				_react2.default.createElement('img', {
					className: 'getTheApp-downloadImage span--100 margin--center',
					src: getAppStorePhoto('ios', language),
					alt: 'Meetup iOS App Download'
				})
			)
		),
		(isAndroidPhone || !isMobile) && _react2.default.createElement(
			_FlexItem2.default,
			{ className: 'getTheApp-android' },
			_react2.default.createElement(
				'a',
				{
					href: ANDROID_DOWNLOAD_LINK,
					target: '_blank',
					rel: 'noopener noreferrer'
				},
				_react2.default.createElement('img', {
					className: 'getTheApp-downloadImage span--100 margin--center',
					src: getAppStorePhoto('android', language),
					alt: 'Meetup Android App Download'
				})
			)
		)
	);
};

AppBadges.defaultProps = {
	getAppStorePhoto: getAppStoreDownloadPhoto
};

AppBadges.propTypes = {
	/** A function to load the app badge images - will likely take language and platform parameters */
	getAppStorePhoto: _propTypes2.default.func,

	/** The language the badge image is in */
	language: _propTypes2.default.string.isRequired,

	/** Checks if the user is using an iOS device*/
	isIosPhone: _propTypes2.default.bool,

	/** Checks if the user is using an Android device*/
	isAndroidPhone: _propTypes2.default.bool,

	/** Checks if the user is using a mobile device*/
	isMobile: _propTypes2.default.bool
};

exports.default = AppBadges;
AppBadges.__docgenInfo = {
	'description': 'Renders iOS and Android app badges\n@class AppBadges',
	'methods': [],
	'props': {
		'getAppStorePhoto': {
			'defaultValue': {
				'value': '(platform, language) =>\n\t// eslint-disable-next-line global-require, import/no-dynamic-require\n\trequire(`../../assets/images/app_download/${platform}/download_${language}.png`)',
				'computed': false
			},
			'type': {
				'name': 'func'
			},
			'required': false,
			'description': 'A function to load the app badge images - will likely take language and platform parameters'
		},
		'language': {
			'type': {
				'name': 'string'
			},
			'required': true,
			'description': 'The language the badge image is in'
		},
		'isIosPhone': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Checks if the user is using an iOS device'
		},
		'isAndroidPhone': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Checks if the user is using an Android device'
		},
		'isMobile': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Checks if the user is using a mobile device'
		}
	}
};
//# sourceMappingURL=AppBadges.js.map