'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.AVATAR_CLASS = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AVATAR_CLASS = exports.AVATAR_CLASS = 'avatar';
/**
 * SQ2 Avatar component
 *
 * In general, you should use a higher-order component instead of this base
 * component, e.g. `AvatarMember` or `AvatarGroup`
 *
 * @see {@link https://github.com/meetup/sassquatch2/blob/develop/sass/ui-components/_avatar.scss}
 * @see {@link http://meetup.github.io/sassquatch2/ui_components.html#avatar}
 * @module Avatar
 */

var Avatar = function (_React$PureComponent) {
	_inherits(Avatar, _React$PureComponent);

	function Avatar() {
		_classCallCheck(this, Avatar);

		return _possibleConstructorReturn(this, (Avatar.__proto__ || Object.getPrototypeOf(Avatar)).apply(this, arguments));
	}

	_createClass(Avatar, [{
		key: 'render',
		value: function render() {
			var _props = this.props,
			    small = _props.small,
			    medium = _props.medium,
			    large = _props.large,
			    big = _props.big,
			    xxlarge = _props.xxlarge,
			    src = _props.src,
			    alt = _props.alt,
			    className = _props.className,
			    style = _props.style,
			    children = _props.children,
			    other = _objectWithoutProperties(_props, ['small', 'medium', 'large', 'big', 'xxlarge', 'src', 'alt', 'className', 'style', 'children']);

			var classNames = (0, _classnames2.default)('avatar', {
				'avatar--small': small,
				'avatar--medium': medium,
				'avatar--large': large,
				'avatar--xxlarge': big || xxlarge
			}, className);

			var backgroundImage = src;
			var allStyles = style || {};
			if (backgroundImage) {
				allStyles.backgroundImage = 'url(' + backgroundImage + ')';
			}

			var aria = {
				role: 'img',
				'aria-label': alt
			};

			var computedProps = {
				className: classNames,
				style: allStyles
			};

			var allProps = _extends({}, computedProps, aria, other);

			// hidden by default;
			// displayed only for print media
			var printPhoto = src && _react2.default.createElement('img', { className: 'avatar-print', src: src, alt: alt });

			if (this.props.to || this.props.href) {
				return _react2.default.createElement(
					'a',
					allProps,
					_react2.default.createElement(
						'span',
						{ className: 'visibility--a11yHide' },
						alt
					),
					children,
					printPhoto
				);
			}

			return _react2.default.createElement(
				'span',
				allProps,
				_react2.default.createElement(
					'span',
					{ className: 'visibility--a11yHide' },
					alt
				),
				children,
				printPhoto
			);
		}
	}]);

	return Avatar;
}(_react2.default.PureComponent);

Avatar.defaultProps = {
	alt: 'Avatar'
};

Avatar.propTypes = {
	/** Render Avatar at a smaller size */
	small: _propTypes2.default.bool,

	/** Render Avatar at a medium size */
	medium: _propTypes2.default.bool,

	/** Render Avatar at a larger size */
	large: _propTypes2.default.bool,

	/** Would like to deprecate this in favor of xxlarge */
	big: _propTypes2.default.bool,

	/** Render Avatar at a very large size*/
	xxlarge: _propTypes2.default.bool,

	/** The image source URL for the Avatar */
	src: _propTypes2.default.string,

	/** Link to arbitrary URL outside app */
	href: _propTypes2.default.string,

	/** The image label, mainly for accessibility */
	alt: _propTypes2.default.string,

	/** For linking to app routes */
	to: _propTypes2.default.string
};

exports.default = Avatar;
Avatar.__docgenInfo = {
	'description': 'SQ2 Avatar component\n\nIn general, you should use a higher-order component instead of this base\ncomponent, e.g. `AvatarMember` or `AvatarGroup`\n\n@see {@link https://github.com/meetup/sassquatch2/blob/develop/sass/ui-components/_avatar.scss}\n@see {@link http://meetup.github.io/sassquatch2/ui_components.html#avatar}\n@module Avatar',
	'methods': [],
	'displayName': 'Avatar',
	'props': {
		'alt': {
			'defaultValue': {
				'value': '\'Avatar\'',
				'computed': false
			},
			'type': {
				'name': 'string'
			},
			'required': false,
			'description': 'The image label, mainly for accessibility'
		},
		'small': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Render Avatar at a smaller size'
		},
		'medium': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Render Avatar at a medium size'
		},
		'large': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Render Avatar at a larger size'
		},
		'big': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Would like to deprecate this in favor of xxlarge'
		},
		'xxlarge': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Render Avatar at a very large size'
		},
		'src': {
			'type': {
				'name': 'string'
			},
			'required': false,
			'description': 'The image source URL for the Avatar'
		},
		'href': {
			'type': {
				'name': 'string'
			},
			'required': false,
			'description': 'Link to arbitrary URL outside app'
		},
		'to': {
			'type': {
				'name': 'string'
			},
			'required': false,
			'description': 'For linking to app routes'
		}
	}
};
//# sourceMappingURL=Avatar.js.map