'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _swarmComponents = require('@meetup/swarm-components');

var _designConstants = require('../utils/designConstants');

var _shapeConstants = require('swarm-icons/dist/js/shapeConstants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Icon component used to insert an svg icon into a component or page
 *
 * **Accessibility** If an Icon is used on its own without supporting
 * text to explain what it is/does, be a good citizen and pass in an
 * `aria-label` attribute describing what the icon represents
 *
 * @module Icon
 */
var Icon = function (_React$PureComponent) {
	_inherits(Icon, _React$PureComponent);

	function Icon() {
		_classCallCheck(this, Icon);

		return _possibleConstructorReturn(this, (Icon.__proto__ || Object.getPrototypeOf(Icon)).apply(this, arguments));
	}

	_createClass(Icon, [{
		key: 'componentDidCatch',
		value: function componentDidCatch(error, info) {
			console.log(error + ': \n ' + info.componentStack);
		}
	}, {
		key: 'render',
		value: function render() {
			var _props = this.props,
			    className = _props.className,
			    circled = _props.circled,
			    role = _props.role,
			    ariaLabel = _props.ariaLabel,
			    other = _objectWithoutProperties(_props, ['className', 'circled', 'role', 'ariaLabel']);

			return _react2.default.createElement(
				'span',
				{ className: className },
				_react2.default.createElement(_swarmComponents.Icon, _extends({
					circle: circled,
					role: role || 'presentation',
					'aria-label': ariaLabel
				}, other))
			);
		}
	}]);

	return Icon;
}(_react2.default.PureComponent);

Icon.defaultProps = {
	size: 's'
};

Icon.propTypes = {
	/** The name of the icon shape to render */
	shape: _propTypes2.default.oneOf(_shapeConstants.VALID_SHAPES).isRequired,

	/** Which of our media sizes to render the icon at */
	size: _propTypes2.default.oneOf(Object.keys(_designConstants.MEDIA_SIZES)).isRequired,

	/** Whether the icon is outlined with a circle */
	circled: _propTypes2.default.bool,

	/** What color the icon should be filled with */
	color: _propTypes2.default.string,

	/** Gives icon role */
	role: _propTypes2.default.string,

	/** If an Icon is used on its own without supporting text to explain what it is/does, be a good citizen and pass in an `aria-label` */
	ariaLabel: _propTypes2.default.string
};

exports.default = Icon;
Icon.__docgenInfo = {
	'description': 'Icon component used to insert an svg icon into a component or page\n\n**Accessibility** If an Icon is used on its own without supporting\ntext to explain what it is/does, be a good citizen and pass in an\n`aria-label` attribute describing what the icon represents\n\n@module Icon',
	'methods': [{
		'name': 'componentDidCatch',
		'docblock': null,
		'modifiers': [],
		'params': [{
			'name': 'error',
			'type': null
		}, {
			'name': 'info',
			'type': null
		}],
		'returns': null
	}],
	'displayName': 'Icon',
	'props': {
		'size': {
			'defaultValue': {
				'value': '\'s\'',
				'computed': false
			},
			'type': {
				'name': 'enum',
				'computed': true,
				'value': 'Object.keys(MEDIA_SIZES)'
			},
			'required': true,
			'description': 'Which of our media sizes to render the icon at'
		},
		'shape': {
			'type': {
				'name': 'enum',
				'computed': true,
				'value': 'VALID_SHAPES'
			},
			'required': true,
			'description': 'The name of the icon shape to render'
		},
		'circled': {
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': 'Whether the icon is outlined with a circle'
		},
		'color': {
			'type': {
				'name': 'string'
			},
			'required': false,
			'description': 'What color the icon should be filled with'
		},
		'role': {
			'type': {
				'name': 'string'
			},
			'required': false,
			'description': 'Gives icon role'
		},
		'ariaLabel': {
			'type': {
				'name': 'string'
			},
			'required': false,
			'description': 'If an Icon is used on its own without supporting text to explain what it is/does, be a good citizen and pass in an `aria-label`'
		}
	}
};
//# sourceMappingURL=Icon.js.map