'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.Nav = exports.DropdownLoader = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _UXCaptureInlineMark = require('mwp-app-render/lib/components/uxcapture/UXCaptureInlineMark');

var _UXCaptureInlineMark2 = _interopRequireDefault(_UXCaptureInlineMark);

var _UXCaptureImageLoad = require('mwp-app-render/lib/components/uxcapture/UXCaptureImageLoad');

var _UXCaptureImageLoad2 = _interopRequireDefault(_UXCaptureImageLoad);

var _logoMSwarm2color = require('../../assets/svg/logo--mSwarm--2color.svg');

var _logoMSwarm2color2 = _interopRequireDefault(_logoMSwarm2color);

var _logoScript = require('../../assets/svg/logo--script.svg');

var _logoScript2 = _interopRequireDefault(_logoScript);

var _Flex = require('../layout/Flex');

var _Flex2 = _interopRequireDefault(_Flex);

var _FlexItem = require('../layout/FlexItem');

var _FlexItem2 = _interopRequireDefault(_FlexItem);

var _Icon = require('../media/Icon');

var _Icon2 = _interopRequireDefault(_Icon);

var _AvatarMember = require('../media/AvatarMember');

var _AvatarMember2 = _interopRequireDefault(_AvatarMember);

var _Avatar = require('../media/Avatar');

var _Avatar2 = _interopRequireDefault(_Avatar);

var _SignupModal = require('../SignupModal');

var _SignupModal2 = _interopRequireDefault(_SignupModal);

var _NavItem = require('./components/NavItem');

var _NavItem2 = _interopRequireDefault(_NavItem);

var _ProfileDropdown = require('./components/profile/ProfileDropdown');

var _ProfileDropdown2 = _interopRequireDefault(_ProfileDropdown);

var _NotificationsDropdown = require('./components/notifications/NotificationsDropdown');

var _NotificationsDropdown2 = _interopRequireDefault(_NotificationsDropdown);

var _DashboardDropdown = require('./components/dashboard/DashboardDropdown');

var _DashboardDropdown2 = _interopRequireDefault(_DashboardDropdown);

var _NavbarSearch = require('./components/search/NavbarSearch');

var _NavbarSearch2 = _interopRequireDefault(_NavbarSearch);

var _message = require('../../assets/svg/message.svg');

var _message2 = _interopRequireDefault(_message);

var _notification = require('../../assets/svg/notification.svg');

var _notification2 = _interopRequireDefault(_notification);

var _connections = require('../../assets/svg/connections.svg');

var _connections2 = _interopRequireDefault(_connections);

var _proDashboard = require('../../assets/svg/proDashboard.svg');

var _proDashboard2 = _interopRequireDefault(_proDashboard);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var CLASS_UNAUTH_ITEM = 'navItem--unauthenticated';
var CLASS_AUTH_ITEM = 'navItem--authenticated';
var SEARCH_INPUT_MAX_WIDTH = 500;
var SEARCH_INPUT_HEIGHT = 44;

var DropdownLoader = exports.DropdownLoader = function DropdownLoader(_ref) {
	var label = _ref.label;
	return React.createElement(
		'div',
		{ className: 'valignChildren--center align--center', 'aria-live': 'polite' },
		React.createElement(
			'p',
			{ className: 'visibility--a11yHide' },
			label
		),
		React.createElement(_Icon2.default, { shape: 'updates', size: 'l' })
	);
};

/**
 * @param {Object} props component properties
 * @returns {React.element} Navigation Bar
 */

var Nav = exports.Nav = function (_React$Component) {
	_inherits(Nav, _React$Component);

	/**
  * @constructor
  * @param {Object} props properties passed into component
  */
	function Nav(props) {
		_classCallCheck(this, Nav);

		var _this = _possibleConstructorReturn(this, (Nav.__proto__ || Object.getPrototypeOf(Nav)).call(this, props));

		_this.markAllNotifAsRead = function (notifications) {
			var _this$props$navItems$ = _this.props.navItems.notifications,
			    notificationsDropdown = _this$props$navItems$.notificationsDropdown,
			    list = _this$props$navItems$.list;

			var notificationsList = notifications || list;

			if (notificationsList && notificationsList.length) {
				var newList = [].concat(_toConsumableArray(notificationsList));

				newList.sort(function (a, b) {
					return parseInt(b.updated) - parseInt(a.updated);
				});
				notificationsDropdown.markRead(newList[0].id);
			}
		};

		_this.onDismissSignupModal = _this.onDismissSignupModal.bind(_this);
		_this.onClickSignupAction = _this.onClickSignupAction.bind(_this);
		_this.onClickMobileDropdownAction = _this.onClickMobileDropdownAction.bind(_this);
		_this.onClickDropdownAction = _this.onClickDropdownAction.bind(_this);
		_this.onDismissDropdown = _this.onDismissDropdown.bind(_this);
		_this.onSearchIconClick = _this.onSearchIconClick.bind(_this);
		_this.state = {
			isSignupModalOpen: false,
			showMobileDashboard: false,
			isSearchOpened: false
		};
		return _this;
	}

	/**
  * Triggers the SignupModal to be closed
  * @return {undefined}
  */


	_createClass(Nav, [{
		key: 'onDismissSignupModal',
		value: function onDismissSignupModal() {
			this.setState(function () {
				return { isSignupModalOpen: false };
			});
		}

		/**
   * Triggers the SignupModal to be rendered
   * @return {undefined}
   */

	}, {
		key: 'onClickSignupAction',
		value: function onClickSignupAction() {
			if (this.props.navItems.signup.signupModal.onOpen) this.props.navItems.signup.signupModal.onOpen();

			this.setState(function () {
				return { isSignupModalOpen: true };
			});
		}

		/**
   * Triggers the Mobile Pro Dashbard to be rendered
   * @return {undefined}
   */

	}, {
		key: 'onClickMobileDropdownAction',
		value: function onClickMobileDropdownAction() {
			this.setState(function () {
				return { showMobileDashboard: true };
			});
			if (this.props.markAllAsReadOnOpen) {
				this.markAllNotifAsRead();
			}
		}

		/**
   * Triggers the notifications dropdown action
   * @return {undefined}
   */

	}, {
		key: 'onClickDropdownAction',
		value: function onClickDropdownAction() {
			var _this2 = this;

			var notifications = this.props.navItems.notifications;

			var isNotificationsLoaded = Boolean(notifications.list);

			if (isNotificationsLoaded) {
				this.markAllNotifAsRead();
				return;
			}
			var action = notifications.getNotificationsQuery();
			if (action && action.meta && action.meta.request) {
				action.meta.request.then(function (_ref2) {
					var _ref3 = _slicedToArray(_ref2, 1),
					    resp = _ref3[0];

					var notifications = resp.response.value;

					_this2.markAllNotifAsRead(notifications);
				});
			}
			return action;
		}

		/**
   * Triggers the Mobile Pro Dashbard to be closed
   * @return {undefined}
   */

	}, {
		key: 'onDismissDropdown',
		value: function onDismissDropdown() {
			this.setState(function () {
				return { showMobileDashboard: false };
			});
		}
	}, {
		key: 'onSearchIconClick',
		value: function onSearchIconClick() {
			this.setState(function (state) {
				return { isSearchOpened: !state.isSearchOpened };
			});
			if (typeof document !== 'undefined') {
				var inputEl = document.getElementById(_NavbarSearch.NAVBAR_SEARCH_INPUT_ID);
				if (inputEl) {
					inputEl.focus();
				}
			}
		}
	}, {
		key: 'render',


		/**
   * @return {React.element} the navbar component
   */
		value: function render() {
			var _props = this.props,
			    media = _props.media,
			    self = _props.self,
			    navItems = _props.navItems,
			    localeCode = _props.localeCode,
			    className = _props.className,
			    markAllAsReadOnOpen = _props.markAllAsReadOnOpen,
			    uxCapture = _props.uxCapture,
			    isSearchEnabled = _props.isSearchEnabled,
			    onSearchCallback = _props.onSearchCallback,
			    isNewNavActive = _props.isNewNavActive,
			    isNewNavsOrder = _props.isNewNavsOrder,
			    other = _objectWithoutProperties(_props, ['media', 'self', 'navItems', 'localeCode', 'className', 'markAllAsReadOnOpen', 'uxCapture', 'isSearchEnabled', 'onSearchCallback', 'isNewNavActive', 'isNewNavsOrder']);

			var _state = this.state,
			    isSignupModalOpen = _state.isSignupModalOpen,
			    showMobileDashboard = _state.showMobileDashboard,
			    isSearchOpened = _state.isSearchOpened;
			var login = navItems.login,
			    create = navItems.create,
			    signup = navItems.signup,
			    proDashboard = navItems.proDashboard,
			    explore = navItems.explore,
			    messages = navItems.messages,
			    connections = navItems.connections,
			    notifications = navItems.notifications,
			    groups = navItems.groups,
			    groupDraft = navItems.groupDraft,
			    profile = navItems.profile,
			    updatesLabel = navItems.updatesLabel,
			    logo = navItems.logo,
			    dropdownLoaderLabel = navItems.dropdownLoaderLabel,
			    search = navItems.search,
			    tryPro = navItems.tryPro;

			var isLoggedOut = self.status === 'prereg' || !self.name;
			var classNames = (0, _classnames2.default)('globalNav padding--all', className);
			var proLogo = ((proDashboard.mainAccount || {}).group_photo || {}).thumb_link;
			var proLetter = ((proDashboard.mainAccount || {}).name || '').slice(0, 1).toUpperCase();

			var showScriptLogo = Boolean(media.isAtLargeUp || isLoggedOut);
			var showSwarmLogo = Boolean(media.isAtMediumUp && !media.isAtLargeUp && !isLoggedOut);
			var isGroupsLoaded = Boolean(groups.list);
			var isNotificationsLoaded = Boolean(notifications.list);
			var isProAdminDesktop = Boolean(self.is_pro_admin) && media.isAtMediumUp;
			var isCoreDesktop = media.isAtMediumUp && Boolean(!self.is_pro_admin) && Boolean(!self.is_pro_org);

			var profileAvatarSize = media.isAtMediumUp ? { medium: true } : { small: true };

			// eslint-disable-next-line no-unused-vars
			var notificationContent = isNotificationsLoaded ? React.createElement(_NotificationsDropdown2.default, {
				self: self,
				notifications: notifications.list,
				onMarkReadAction: notifications.notificationsDropdown.markRead,
				localeCode: localeCode,
				emptyContentLabel: notifications.notificationsDropdown.emptyContentLabel,
				notificationsTitleLabel: notifications.label,
				generateClassicUrl: notifications.notificationsDropdown.generateClassicUrl
			}) : React.createElement(DropdownLoader, { label: dropdownLoaderLabel });

			var profileContent = isGroupsLoaded ? React.createElement(_ProfileDropdown2.default, {
				payments: profile.profileDropdown.payments,
				settings: profile.profileDropdown.settings,
				help: profile.profileDropdown.help,
				logout: profile.profileDropdown.logout,
				groupHome: profile.profileDropdown.groupHome,
				allGroupsLabel: profile.profileDropdown.allGroupsLabel,
				allGroupsLink: profile.profileDropdown.allGroupsLink,
				savedEvents: profile.profileDropdown.savedEvents,
				yourGroups: profile.profileDropdown.yourGroups,
				yourEvents: profile.profileDropdown.yourEvents,
				yourConnections: profile.profileDropdown.yourConnections,
				profile: profile,
				groups: groups.list,
				groupDraft: groupDraft,
				isNewNavActive: isNewNavActive,
				isNewNavsOrder: isNewNavsOrder && (localeCode ? localeCode.includes('en') : false),
				hasNewConnections: connections.hasNewConnections
			}) : React.createElement(DropdownLoader, { label: dropdownLoaderLabel });

			var createMeetupLink = create && {
				shrink: true,
				linkTo: create.link,
				label: create.label,
				linkClassName: create.linkClassName,
				className: (0, _classnames2.default)(CLASS_UNAUTH_ITEM, 'navItemLink--createMeetup', isProAdminDesktop && Boolean(create.label) && 'navItemLink--createMeetupPro'),
				onLinkClick: create.onLinkClick,
				actionAttributes: create.actionAttributes
			};

			var getMessagesIcon = function getMessagesIcon() {
				if (media.isAtMediumUp) {
					return React.createElement('img', { className: 'proIcon', alt: messages.label, src: _message2.default });
				}

				return React.createElement(_Icon2.default, {
					shape: 'messages',
					size: 's',
					className: (0, _classnames2.default)('display--block', !isNewNavActive && 'atMedium_display--none')
				});
			};

			var getConnectionsIcon = function getConnectionsIcon() {
				return React.createElement('img', { className: 'proIcon', alt: connections.label, src: _connections2.default });
			};

			var getNotificationsIcon = function getNotificationsIcon() {
				if (media.isAtMediumUp) {
					return React.createElement('img', {
						className: 'proIcon',
						alt: notifications.label,
						src: _notification2.default
					});
				}

				return React.createElement(_Icon2.default, {
					shape: 'notifications',
					size: 's',
					className: (0, _classnames2.default)('display--block', !isNewNavActive && 'atMedium_display--none')
				});
			};

			var getTryProIcon = function getTryProIcon() {
				return React.createElement(
					'div',
					{ className: 'tryProIcon tw-text-white tw-bg-viridian tw-px-1 tw-py-0.5 tw-rounded tw-font-semibold tw-text-xs' },
					'PRO'
				);
			};

			var proDashboardIcon = media.isAtMediumUp ? React.createElement('img', { className: 'proIcon', alt: proDashboard.label, src: _proDashboard2.default }) : React.createElement(
				_Flex2.default,
				{ noGutters: true, align: 'center' },
				React.createElement(
					_FlexItem2.default,
					null,
					proLogo ? React.createElement(_Avatar2.default, {
						src: proLogo,
						className: 'display--block margin--left circular atMedium_display--none',
						small: true
					}) : React.createElement(
						'div',
						{ className: 'proDashboard-noLogo circular margin--left text--secondary atMedium_display--none' },
						proLetter
					)
				),
				React.createElement(
					_FlexItem2.default,
					{ shrink: true, className: 'display--block atMedium_display--none' },
					React.createElement(_Icon2.default, { shape: 'chevron-down', size: 'xxs', className: 'padding--halfLeft' })
				)
			);

			var unauthItems = [media.isAtMediumUp && createMeetupLink, {
				shrink: true,
				linkTo: login.link,
				label: login.label,
				className: CLASS_UNAUTH_ITEM + ' navItem--login'
			}, {
				shrink: true,
				onAction: this.onClickSignupAction,
				label: signup.label,
				className: CLASS_UNAUTH_ITEM + ' navItem--signup'
			}, isSearchEnabled && !media.isAtMediumUp && {
				shrink: true,
				icon: search.icon,
				className: search.className + ' navItem--searchIcon',
				onAction: this.onSearchIconClick
			}];

			var authItems = [isProAdminDesktop && createMeetupLink, self.is_pro_admin && {
				shrink: true,
				linkTo: media.isAtMediumUp ? proDashboard.link : '',
				onAction: !media.isAtMediumUp && this.onClickMobileDropdownAction,
				label: media.isAtMediumUp ? proDashboard.label : proDashboard.mobileLabel,
				labelClassName: (0, _classnames2.default)(media.isAtMediumUp && 'navItem-label-pro'),
				className: (0, _classnames2.default)(CLASS_AUTH_ITEM, 'atMedium_display--block', !media.isAtMediumUp && 'navItemLink--dashboard'),
				linkClassName: (0, _classnames2.default)(media.isAtMediumUp && 'navItemLink-pro'),
				icon: proDashboardIcon,
				onLinkClick: proDashboard.onLinkClick,
				actionAttributes: proDashboard.actionAttributes
			}, media.isAtMediumUp && !self.is_pro_admin && createMeetupLink, {
				shrink: true,
				linkTo: groups.link,
				label: groups.label,
				className: 'atMedium_display--none ' + CLASS_AUTH_ITEM,
				icon: React.createElement(_Icon2.default, { shape: 'groups', size: 's', className: 'display--block' })
			}, isCoreDesktop && {
				shrink: true,
				linkTo: tryPro.link,
				label: tryPro.label,
				className: 'navItem',
				labelClassName: 'navItem-label-pro ' + CLASS_AUTH_ITEM,
				icon: getTryProIcon(),
				onLinkClick: tryPro.onLinkClick,
				linkClassName: 'navItemLink-pro',
				isTargetBlank: true
			}, media.isAtMediumUp && {
				shrink: true,
				linkTo: connections.link,
				label: connections.label,
				labelClassName: 'navItem-label-pro',
				className: (0, _classnames2.default)('navItem--connections', CLASS_AUTH_ITEM),
				linkClassName: 'navItemLink-pro',
				counterBadgeClassName: 'navItem--counterBadgeConnections',
				icon: getConnectionsIcon(),
				hasUpdates: connections.hasNewConnections > 0,
				updatesLabel: updatesLabel,
				onLinkClick: messages.onLinkClick
			}, {
				shrink: true,
				linkTo: messages.link,
				label: messages.label,
				labelClassName: (0, _classnames2.default)(media.isAtMediumUp && 'navItem-label-pro'),
				className: 'navItem--messages ' + CLASS_AUTH_ITEM,
				linkClassName: (0, _classnames2.default)(media.isAtMediumUp && 'navItemLink-pro'),
				counterBadgeClassName: (0, _classnames2.default)(media.isAtMediumUp && 'navItem--counterBadgeProMessages'),
				icon: getMessagesIcon(),
				hasUpdates: messages.unreadMessages > 0,
				updatesLabel: updatesLabel,
				onLinkClick: messages.onLinkClick,
				actionAttributes: messages.actionAttributes
			}, {
				shrink: true,
				linkTo: notifications.link,
				label: notifications.label,
				labelClassName: (0, _classnames2.default)(media.isAtMediumUp && 'navItem-label-pro'),
				className: (0, _classnames2.default)('navItem--notifications', CLASS_AUTH_ITEM),
				linkClassName: (0, _classnames2.default)(media.isAtMediumUp && 'navItemLink-pro'),
				counterBadgeClassName: (0, _classnames2.default)(media.isAtMediumUp && 'navItem--counterBadgeProNotifications'),
				icon: getNotificationsIcon(),
				hasUpdates: notifications.unreadNotifications > 0,
				updatesLabel: updatesLabel,
				onLinkClick: notifications.onLinkClick,
				// if would like to have notification dropdown
				// add onClickAction:this.onClickDropdownAction and dropdownContent:notificationContent
				actionAttributes: notifications.actionAttributes
			}, {
				shrink: true,
				linkTo: media.isAtMediumUp ? '' : profile.link,
				label: profile.label,
				labelClassName: 'navItem-label display--block atMedium_display--none',
				className: (0, _classnames2.default)(CLASS_AUTH_ITEM, 'profileDropdown', {
					'profileDropdown--hasGroups': Boolean(groups.list && groups.list.length),
					'display--none': self.is_pro_admin && !media.isAtMediumUp
				}),
				icon: React.createElement(
					_Flex2.default,
					{ noGutters: true, align: 'center', 'aria-label': profile.label },
					React.createElement(
						_FlexItem2.default,
						null,
						React.createElement(_AvatarMember2.default, _extends({
							member: self
						}, profileAvatarSize, {
							badgeType: profile.badgeType
						}))
					),
					React.createElement(
						_FlexItem2.default,
						{
							shrink: true,
							className: 'display--none atMedium_display--block'
						},
						React.createElement(_Icon2.default, {
							shape: 'chevron-down',
							size: 'xxs',
							className: 'padding--halfLeft',
							id: 'profileChevronIcon'
						})
					)
				),
				onClickAction: media.isAtMediumUp && !isGroupsLoaded ? function () {
					profile.getSelfGroupsQuery.apply(profile, arguments);
					profile.getSelfGroupDraftQuery.apply(profile, arguments);
				} : undefined,
				dropdownContent: media.isAtMediumUp ? profileContent : undefined,
				actionAttributes: profile.actionAttributes
			}];

			unauthItems = unauthItems.filter(Boolean).map(function (item, i) {
				return React.createElement(_NavItem2.default, {
					key: i,
					shrink: item.shrink,
					linkTo: item.linkTo,
					label: item.label,
					icon: item.icon,
					className: item.className,
					linkClassName: item.linkClassName,
					onAction: item.onAction
				});
			});

			authItems = authItems.filter(Boolean).map(function (item, i) {
				return item && React.createElement(_NavItem2.default, {
					key: i,
					shrink: item.shrink,
					linkTo: item.linkTo,
					label: item.label,
					labelClassName: item.labelClassName,
					className: item.className,
					counterBadgeClassName: item.counterBadgeClassName,
					icon: item.icon,
					onClickAction: item.onClickAction,
					dropdownContent: item.dropdownContent,
					onAction: item.onAction,
					hasUpdates: item.hasUpdates,
					linkClassName: item.linkClassName,
					isNewNavActive: isNewNavActive,
					onLinkClick: item.onLinkClick,
					isTargetBlank: item.isTargetBlank,
					actionAttributes: item.actionAttributes
				});
			});

			var scriptLogoAttr = {
				src: _logoScript2.default,
				alt: logo.logoAccessible,
				height: '44px'
			};

			var scriptLogoIcon = uxCapture ? React.createElement(
				React.Fragment,
				null,
				React.createElement(_UXCaptureImageLoad2.default, _extends({
					mark: 'ux-image-onload-script-logo'
				}, scriptLogoAttr)),
				React.createElement(_UXCaptureInlineMark2.default, { mark: 'ux-image-inline-script-logo' })
			) : React.createElement('img', scriptLogoAttr);

			var searchInputStyle = isSearchOpened ? {
				overflow: 'hidden',
				transition: 'max-height .2s ease-out, opacity .4s ease-in-out',
				height: 'auto',
				maxHeight: '60px',
				opacity: 1
			} : {
				overflow: 'hidden',
				maxHeight: 0,
				opacity: 0,
				paddingTop: 0,
				transition: 'max-height .2s ease-out, opacity .1s ease-in-out, padding .1s ease-in-out'
			};

			return React.createElement(
				'nav',
				_extends({
					'aria-label': 'Header navigation',
					role: 'navigation',
					className: classNames
				}, other),
				React.createElement(
					_Flex2.default,
					{
						align: media.isAtMediumUp ? 'center' : 'top',
						justify: 'spaceBetween',
						className: 'span--100 navBar'
					},
					showSwarmLogo && React.createElement(_NavItem2.default, {
						linkTo: logo.link,
						className: 'logo logo--swarm align--left',
						linkClassName: 'display--inlineBlock',
						icon: React.createElement('img', {
							src: _logoMSwarm2color2.default,
							alt: logo.logoAccessible,
							height: '48px'
						}),
						onLinkClick: logo.onLinkClick
					}),
					showScriptLogo && React.createElement(_NavItem2.default, {
						shrink: isSearchEnabled && media.isAtMediumUp,
						linkTo: logo.link,
						className: 'logo logo--script align--left',
						linkClassName: 'display--inlineBlock',
						icon: scriptLogoIcon,
						onLinkClick: logo.onLinkClick
					}),
					isSearchEnabled && (self.is_pro_admin ? media.isAtLargeUp : media.isAtMediumUp) && React.createElement(
						_FlexItem2.default,
						null,
						React.createElement(_NavbarSearch2.default, {
							onSearchCallback: onSearchCallback,
							placeholder: search.placeholder,
							style: {
								maxWidth: SEARCH_INPUT_MAX_WIDTH,
								height: SEARCH_INPUT_HEIGHT
							},
							isNewNavActive: isNewNavActive
						})
					),
					isSignupModalOpen && React.createElement(_SignupModal2.default, {
						signupOptions: signup.signupModal,
						onDismiss: this.onDismissSignupModal,
						appleOnClick: signup.signupModal.appleOnClick,
						googleOnClick: signup.signupModal.googleOnClick,
						facebookOnClick: signup.signupModal.facebookOnClick,
						emailOnClick: signup.signupModal.emailOnClick
					}),
					showMobileDashboard && React.createElement(_DashboardDropdown2.default, {
						dismissAction: this.onDismissDropdown,
						mobileTabs: proDashboard.mobileTabs
					}),
					isLoggedOut ? unauthItems : authItems
				),
				isSearchEnabled && !media.isAtMediumUp && React.createElement(
					'div',
					{
						className: (0, _classnames2.default)({ 'padding--top': isSearchOpened }),
						style: searchInputStyle
					},
					React.createElement(_NavbarSearch2.default, {
						onSearchCallback: onSearchCallback,
						placeholder: search.placeholder,
						style: { height: SEARCH_INPUT_HEIGHT },
						isNewNavActive: false
					})
				)
			);
		}
	}]);

	return Nav;
}(React.Component);

Nav.defaultProps = {
	localeCode: 'en-US',
	uxCapture: false
};

Nav.propTypes = {
	/** Data for the current user */
	self: _propTypes2.default.object,

	/** Info about viewport size */
	media: _propTypes2.default.object,

	/** Data for links and buttons to render into the nav */
	navItems: _propTypes2.default.object,

	/** The locale code of the current user */
	localeCode: _propTypes2.default.string,
	markAllAsReadOnOpen: _propTypes2.default.bool,

	/** Add uxCapture marks in the nav */
	uxCapture: _propTypes2.default.bool,

	isSearchEnabled: _propTypes2.default.bool,
	onSearchCallback: _propTypes2.default.func,

	/** Flag to indicate that new Nav should be shown (same as in build-meetup/homepage) */
	isNewNavActive: _propTypes2.default.bool
};

exports.default = Nav;
//# sourceMappingURL=Nav.js.map