'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.NotificationsDropdownComponent = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Section = require('../../../layout/Section');

var _Section2 = _interopRequireDefault(_Section);

var _Chunk = require('../../../layout/Chunk');

var _Chunk2 = _interopRequireDefault(_Chunk);

var _Notifications = require('./Notifications');

var _Notifications2 = _interopRequireDefault(_Notifications);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var NotificationsDropdownComponent = exports.NotificationsDropdownComponent = function NotificationsDropdownComponent(_ref) {
	var self = _ref.self,
	    notifications = _ref.notifications,
	    onMarkReadAction = _ref.onMarkReadAction,
	    localeCode = _ref.localeCode,
	    emptyContentLabel = _ref.emptyContentLabel,
	    notificationTitleLabel = _ref.notificationTitleLabel,
	    generateClassicUrl = _ref.generateClassicUrl;

	var isEmptyState = notifications.length < 1;

	var NotificationsList = function NotificationsList() {
		return _react2.default.createElement(
			'div',
			{ className: 'notifications--populated' },
			_react2.default.createElement(
				'ul',
				{ className: 'list' },
				notifications.map(function (notif, key) {
					return (
						// eslint-disable-next-line react/no-array-index-key
						_react2.default.createElement(
							'li',
							{ key: key },
							_react2.default.createElement(_Notifications2.default, {
								className: key === 0 ? 'border--none' : '',
								id: notif.id,
								memberId: self.id.toString(),
								kind: notif.kind,
								photoUrl: notif.photo ? notif.photo.photo_link : '',
								isRead: notif.read,
								link: notif.link,
								onMarkReadAction: onMarkReadAction,
								dangerouslySetInnerHTML: { __html: notif.text },
								formattedTimeSince: notif.formattedTimeSince,
								localeCode: localeCode,
								generateClassicUrl: generateClassicUrl
							})
						)
					);
				})
			)
		);
	};

	var NotificationsEmpty = function NotificationsEmpty() {
		return _react2.default.createElement(
			_Section2.default,
			{ className: 'notifications--empty align--center valignChildren--center' },
			_react2.default.createElement(
				_Chunk2.default,
				null,
				_react2.default.createElement(
					'p',
					null,
					emptyContentLabel
				)
			)
		);
	};

	return _react2.default.createElement(
		'div',
		{ className: 'align--left' },
		_react2.default.createElement(
			'h2',
			{ className: 'padding--all border--bottom text--labelSecondary' },
			notificationTitleLabel
		),
		isEmptyState ? _react2.default.createElement(NotificationsEmpty, null) : _react2.default.createElement(NotificationsList, null)
	);
};

exports.default = NotificationsDropdownComponent;
NotificationsDropdownComponent.__docgenInfo = {
	'description': '',
	'methods': []
};
//# sourceMappingURL=NotificationsDropdown.js.map