'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.NavbarSearchComponent = exports.NAVBAR_SEARCH_INPUT_ID = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _solid = require('@meetup/swarm-icons/lib/components/solid');

var _TextInput = require('../../../forms/TextInput');

var _TextInput2 = _interopRequireDefault(_TextInput);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }
// $FlowFixMe


var NAVBAR_SEARCH_INPUT_ID = exports.NAVBAR_SEARCH_INPUT_ID = 'navbar_search_input_id';

var NavbarSearchComponent = function NavbarSearchComponent(_ref) {
	var onSearchCallback = _ref.onSearchCallback,
	    isNewNavActive = _ref.isNewNavActive,
	    other = _objectWithoutProperties(_ref, ['onSearchCallback', 'isNewNavActive']);

	var _useState = (0, _react.useState)(''),
	    _useState2 = _slicedToArray(_useState, 2),
	    value = _useState2[0],
	    setValue = _useState2[1];

	var onSearch = (0, _react.useCallback)(function (e) {
		var inputValue = e.target.value;
		// $FlowFixMe
		if (e.keyCode === 13 && inputValue) {
			onSearchCallback(inputValue);
		}
	}, [onSearchCallback]);

	var onChange = (0, _react.useCallback)(function (e) {
		setValue(e.target.value);
	}, []);

	var onClick = (0, _react.useCallback)(function () {
		onSearchCallback(value);
	}, [value, onSearchCallback]);

	var newSearchBar = _react2.default.createElement(
		'div',
		{ className: 'navbar-search' },
		_react2.default.createElement(
			'div',
			{ className: 'navbar-search-input' },
			_react2.default.createElement(_TextInput2.default, _extends({
				id: NAVBAR_SEARCH_INPUT_ID,
				name: 'navbar_search',
				isSearch: true,
				onKeyDown: onSearch,
				onChange: onChange,
				value: value
			}, other))
		),
		_react2.default.createElement(
			'button',
			{
				className: 'navbar-search-btn',
				onClick: onClick,
				'aria-label': 'search',
				role: 'presentation',
				title: 'search'
			},
			_react2.default.createElement(_solid.Search, { style: { fill: 'white', height: '30px' } })
		)
	);

	var oldSearchBar = _react2.default.createElement(_TextInput2.default, _extends({
		id: NAVBAR_SEARCH_INPUT_ID,
		name: 'navbar_search',
		iconShape: 'search',
		isSearch: true,
		onKeyDown: onSearch,
		onChange: onChange,
		value: value
	}, other));

	return isNewNavActive ? newSearchBar : oldSearchBar;
};

exports.NavbarSearchComponent = NavbarSearchComponent;
exports.default = NavbarSearchComponent;
//# sourceMappingURL=NavbarSearch.js.map