'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

// Swarm Usage & Expectations Doc -> https://docs.google.com/document/d/1aj8FGlpoXQbDzvFgVpaWHzlGn4DfiexHzx96r63Me_4/edit#heading=h.ozjf42vcdlpq

// List of components to be removed from meetup-web-components on October 3, 2019 ->
// + Button
// + Checkbox
// + TextInput
// + CharCounter
// + NumberInput
// + RadioButton
// + RadioButtonGroup
// + Select
// + SelectInput
// + TogglePill
// + ToggleSwitch

// All questions and concerns should be directed to #swarm in slack

// 'global' record of which components have already logged a warning
var hasBeenWarned = {};

function DeprecationWarning(WrappedComponent) {
	var Wrapped = function (_React$Component) {
		_inherits(Wrapped, _React$Component);

		function Wrapped() {
			_classCallCheck(this, Wrapped);

			return _possibleConstructorReturn(this, (Wrapped.__proto__ || Object.getPrototypeOf(Wrapped)).apply(this, arguments));
		}

		_createClass(Wrapped, [{
			key: 'componentDidMount',
			value: function componentDidMount() {
				if (!hasBeenWarned[WrappedComponent.name]) {
					console.warn('The ' + WrappedComponent.name + ' component has been deprecated and will be removed from meetup-web-components on October 21, 2019. Please upgrade to the latest from https://github.com/meetup/swarm-ui');
					hasBeenWarned[WrappedComponent.name] = true;
				}
			}
		}, {
			key: 'render',
			value: function render() {
				return _react2.default.createElement(WrappedComponent, this.props);
			}
		}]);

		return Wrapped;
	}(_react2.default.Component);

	Wrapped.displayName = WrappedComponent.name;
	return Wrapped;
}

exports.default = DeprecationWarning;
//# sourceMappingURL=DeprecationWarning.js.map