'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _ConditionalWrap = require('./ConditionalWrap');

var _ConditionalWrap2 = _interopRequireDefault(_ConditionalWrap);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * @module ToggleWrapper
 *
 * Provides boolean isActive prop to wrapped component.
 * Prop name can also be customized if need be
 *
 * @returns {React.element}
 */
var ToggleWrapper = function (_React$Component) {
	_inherits(ToggleWrapper, _React$Component);

	function ToggleWrapper(props) {
		_classCallCheck(this, ToggleWrapper);

		var _this = _possibleConstructorReturn(this, (ToggleWrapper.__proto__ || Object.getPrototypeOf(ToggleWrapper)).call(this, props));

		_this.state = { isActive: props.isActive };
		_this.toggleActive = _this.toggleBool.bind(_this);
		_this.onKeyUp = _this.onKeyUp.bind(_this);
		return _this;
	}

	_createClass(ToggleWrapper, [{
		key: 'componentDidUpdate',
		value: function componentDidUpdate(prevProps, prevState) {
			if (prevState.isActive !== this.state.isActive) {
				this.state.isActive ? this.props.onCallback && this.props.onCallback() : this.props.offCallback && this.props.offCallback();
			}
		}
	}, {
		key: 'UNSAFE_componentWillReceiveProps',
		value: function UNSAFE_componentWillReceiveProps(nextProps) {
			if (nextProps.isActive !== this.props.isActive) {
				this.toggleActive();
			}
		}
	}, {
		key: 'toggleBool',
		value: function toggleBool(e) {
			this.setState({ isActive: !this.state.isActive });

			if (this.props.onToggle) {
				this.props.onToggle(e);
			}
		}
	}, {
		key: 'onKeyUp',
		value: function onKeyUp(e) {
			var isActivatingButton = [' ' /* space bar */, 'Enter'].some(function (key) {
				return e.key === key;
			});

			if (isActivatingButton) {
				this.toggleActive();
			}
		}
	}, {
		key: 'render',
		value: function render() {
			var _this2 = this;

			var isInput = this.props.type == 'radio' || this.props.type == 'checkbox';

			return _react2.default.createElement(
				_ConditionalWrap2.default,
				{
					condition: !isInput,
					wrap: function wrap(children) {
						return _react2.default.createElement(
							'div',
							{
								role: 'button',
								'aria-pressed': _this2.state.isActive,
								onKeyUp: _this2.onKeyUp,
								tabIndex: _this2.props.tabIndex || '0'
							},
							_this2.props.children({
								isActive: _this2.state.isActive,
								toggleActive: _this2.toggleActive
							})
						);
					}
				},
				this.props.children({
					tabIndex: isInput && this.props.tabIndex || '0',
					isActive: this.state.isActive,
					toggleActive: this.toggleActive,
					onKeyUp: this.props.type == 'radio' ? null : this.onKeyUp
				})
			);
		}
	}]);

	return ToggleWrapper;
}(_react2.default.Component);

ToggleWrapper.defaultProps = {
	isActive: false
};
ToggleWrapper.propTypes = {
	isActive: _propTypes2.default.bool
};

exports.default = ToggleWrapper;
ToggleWrapper.__docgenInfo = {
	'description': '@module ToggleWrapper\n\nProvides boolean isActive prop to wrapped component.\nProp name can also be customized if need be\n\n@returns {React.element}',
	'methods': [{
		'name': 'UNSAFE_componentWillReceiveProps',
		'docblock': null,
		'modifiers': [],
		'params': [{
			'name': 'nextProps',
			'type': null
		}],
		'returns': null
	}, {
		'name': 'toggleBool',
		'docblock': null,
		'modifiers': [],
		'params': [{
			'name': 'e',
			'type': null
		}],
		'returns': null
	}, {
		'name': 'onKeyUp',
		'docblock': null,
		'modifiers': [],
		'params': [{
			'name': 'e',
			'type': null
		}],
		'returns': null
	}],
	'displayName': 'ToggleWrapper',
	'props': {
		'isActive': {
			'defaultValue': {
				'value': 'false',
				'computed': false
			},
			'type': {
				'name': 'bool'
			},
			'required': false,
			'description': ''
		}
	}
};
//# sourceMappingURL=ToggleWrapper.js.map