'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Loading = require('../../media/Loading');

var _Loading2 = _interopRequireDefault(_Loading);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var getDisplayName = function getDisplayName(WrappedComponent) {
	return WrappedComponent.displayName || WrappedComponent.name || 'Component';
};

var withLoading = function withLoading(WrappedComponent) {
	/**
  * @module WithLoading
  */
	var WithLoading = function (_React$Component) {
		_inherits(WithLoading, _React$Component);

		function WithLoading() {
			_classCallCheck(this, WithLoading);

			return _possibleConstructorReturn(this, (WithLoading.__proto__ || Object.getPrototypeOf(WithLoading)).apply(this, arguments));
		}

		_createClass(WithLoading, [{
			key: 'render',
			value: function render() {
				var _props = this.props,
				    children = _props.children,
				    isLoading = _props.isLoading,
				    loadingProps = _props.loadingProps,
				    other = _objectWithoutProperties(_props, ['children', 'isLoading', 'loadingProps']);

				return _react2.default.createElement(
					WrappedComponent,
					_extends({
						'aria-busy': isLoading,
						isLoading: isLoading
					}, other),
					this.props.dangerouslySetInnerHTML ? null : [children, isLoading && _react2.default.createElement(_Loading2.default, _extends({
						key: 'loadingIndicator',
						partialCover: true
					}, loadingProps))]
				);
			}
		}]);

		return WithLoading;
	}(_react2.default.Component);

	WithLoading.displayName = getDisplayName(WrappedComponent);
	return WithLoading;
};

withLoading.defaultProps = {
	isLoading: false
};
withLoading.propTypes = {
	isLoading: _propTypes2.default.bool,
	loadingProps: _propTypes2.default.shape({
		color: _propTypes2.default.string,
		scrimColor: _propTypes2.default.string,
		size: _propTypes2.default.string
	})
};

exports.default = withLoading;
//# sourceMappingURL=withLoading.js.map