'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.decorateWithInfo = exports.decorateWithBasics = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _addonInfo = require('@storybook/addon-info');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var decorateWithBasics = exports.decorateWithBasics = function decorateWithBasics(story) {
	/*
  * -- Inline SVG icon sprite --
  *
  * raw SVG sprite from `swarm-icons`
  */
	var iconSpriteStyle = { display: 'none' };
	var iconSprite = require('raw-loader!swarm-icons/dist/sprite/sprite.inc');
	var styles = {
		display: 'flex',
		alignItems: 'center',
		justifyContent: 'center',
		height: '100%',
		width: '100%'
	};

	return _react2.default.createElement(
		'div',
		{ style: styles },
		_react2.default.createElement('div', {
			style: iconSpriteStyle,
			dangerouslySetInnerHTML: { __html: iconSprite }
		}),
		story()
	);
};

var decorateWithInfo = exports.decorateWithInfo = function decorateWithInfo(story, context) {
	return (0, _addonInfo.withInfo)(context.story + ' ' + context.kind)(story)(context);
};
decorateWithBasics.__docgenInfo = {
	'description': '',
	'methods': []
};
//# sourceMappingURL=decorators.js.map