'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.StoryLink = exports.Inverted = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Inverted
 *
 * Creates an inverted stripe for use in a story
 */
var Inverted = exports.Inverted = function Inverted(props) {
	return _react2.default.createElement(
		'div',
		{
			className: 'stripe stripe--inverted inverted',
			style: {
				height: '100%',
				width: '100%',
				display: 'flex',
				justifyContent: 'center',
				alignItems: 'center'
			}
		},
		props.children
	);
};

/**
 * StoryLink
 *
 * `Link` component for use in stories
 * where a router context is not necessary
 *
 * Also disables link from being followed on click
 */
var StoryLink = exports.StoryLink = function StoryLink(props) {
	return _react2.default.createElement(
		'a',
		{
			href: '#',
			style: props.onClick ? null : { pointerEvents: 'none' },
			onClick: props.onClick
		},
		props.children
	);
};
Inverted.__docgenInfo = {
	'description': 'Inverted\n\nCreates an inverted stripe for use in a story',
	'methods': []
};
StoryLink.__docgenInfo = {
	'description': 'StoryLink\n\n`Link` component for use in stories\nwhere a router context is not necessary\n\nAlso disables link from being followed on click',
	'methods': []
};
//# sourceMappingURL=storyComponents.js.map