'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.componentHasProperty = exports.hasRoleAttribute = exports.hasAttribute = exports.hasChildByClassName = exports.variantTest = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _enzyme = require('enzyme');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

// import TestUtils from 'react-dom/test-utils';

var variantTest = exports.variantTest = function variantTest(FoundationComponent, className, variants) {
	variants.forEach(function (variant) {
		var props = _defineProperty({}, variant, true);

		var component = (0, _enzyme.shallow)(_react2.default.createElement(FoundationComponent, props));
		expect(component.find('.' + className + '--' + variant).exists()).toBe(true);
	});
};

var hasChildByClassName = exports.hasChildByClassName = function hasChildByClassName(el, className) {
	var hasClass = !!el.getElementsByClassName(className).length;
	expect(hasClass).toBe(true);
};

var hasAttribute = exports.hasAttribute = function hasAttribute(el, attr, value) {
	var elAttrValue = el.getAttribute(attr);
	expect(elAttrValue).not.toBeNull();
	if (value !== undefined) {
		expect((' ' + elAttrValue + ' ').indexOf(' ' + value + ' ')).not.toBe(-1);
	}
};

var hasRoleAttribute = exports.hasRoleAttribute = function hasRoleAttribute(el, roleName) {
	hasAttribute(el, 'role', roleName);
};

var componentHasProperty = exports.componentHasProperty = function componentHasProperty(component, prop, value) {
	expect(component && component.props && component.props[prop] === value).toBe(true);
};
//# sourceMappingURL=testUtils.js.map