module.exports = {
	prefix: 'tw-',
	purge: {
		enabled: true,
		content: ['./src/**/*.html', './src/**/*.jsx', './src/**/*.tsx', './src/**/*.js'],
	},
	darkMode: false, // or 'media' or 'class'
	theme: {
		screens: {
			xs: '0px',
			sm: '577px',
			md: '769px',
			lg: '993px',
			xl: '1201px',
		},
		extend: {
			screens: {
				xs: '0px',
			},
		},
		colors: {
			lightBlue: '#F7FEFF',
			merlot: '#7A1D47',
			meetupRed: '#E32359',
			peach: '#F65858',
			lightPeach: '#F77070',
			marigold: '#FFAD43',
			indigo: '#00455D',
			viridian: '#00798A',
			beach: '#97CAD1',
			oldGold: '#947F5F',
			darkGold: '#877457',
			white: '#FFFFFF',
			black: '#000000',
			alertRed: '#C80000',
			alertBg: '#FBE1E4',
			beachHighlight: '#F7FEFF',
			tooltipBlue: '#3679E4',
			tooltipDark: '#353e48',
			confirmGreen: '#06A002',
			warningOrange: '#E5800B',
			gray1: '#F6F7F8',
			gray2: '#E6E6E6',
			gray3: '#D9D9D9',
			gray4: '#C5C4C4',
			gray5: '#A2A2A2',
			gray6: '#757575',
			gray7: '#212121',
			titleColor: '#2e3e48',
			shadowColor: 'rgba(46, 62, 72, 0.12)',
			paleBeach: 'rgba(151, 202, 209, 0.2)',
			linearGradient:
				'linear-gradient(-180deg, rgba(251, 252, 252, 0) 0%, rgb(246, 247, 248) 100%)',
			midnightDark: '#1c1c1e',
			yellow: '#FFF200',
			sand: '#FFF7ED',
			linkBlue: '#0098AB',
			submarine: '#8b9898',
		},
	},
	variants: {
		extend: {},
	},
	plugins: [],
};
